
== [8.2.12] 2026-02-05 ==

* Do not prevent shared builds on OpenBSD/alpha
* Eliminate 'argument unused' gcc warning in push_all_stack_partially_eager
* Eliminate 'assign long to void*' gcc warning in get_stack_base on Serenity
* Eliminate 'format expects argument of type' gcc warnings in dump_meminfo
* Eliminate 'GC_push_all_stack not used' gcc warning if fix-up pointers
* Eliminate 'GC_remove_roots_subregion not used' gcc warning on Solaris
* Eliminate 'unused parameter' clang warnings in GC_darwin_sigbus
* Fix 'KERN_PROTECTION_FAILURE while world is stopped' error on MacOS X
* Fix 'MA_FETCHOP undeclared' gcc error if USE_PROC_FOR_LIBRARIES on Solaris
* Fix 'PIOCNMAP undeclared' gcc error if USE_PROC_FOR_LIBRARIES on Solaris
* Fix 'reserved' argument handling in GC_DllMain
* Fix 'undefined errno' compiler error in strdup/strndup on WinCE
* Fix a cycle in NORMAL freelist if malloc is redirected on Linux
* Fix assertion in GC_wait_for_reclaim if DllMain-based thread registration
* Fix code defect of LOCK/UNLOCK in separate 'if' in GC_generic_malloc_many
* Fix missing new-line in help message of console variant of cord/de
* Fix race in DllMain by deferring delete_thread call to GC_start_world
* Fix redirected 'free' for callers from libdl/libpthread if IGNORE_FREE
* Fix reliance on glibc-specific '__data_start' for some Linux platforms
* Fix shared library build on MinGW if disable_single_obj_compilation
* Fix SIGSEGV during pthread_setname_np if redirect malloc on FreeBSD
* Fix SIGSEGV if pthread_detach is called before collector initialization
* Fix SIGSEGV in remove_all_threads_but_me if fork from unregistered thread
* Fix typos (about getcontext) in printed message in setjmp_test
* Fix various typos in comments and documentation
* Prevent collection if fork from an unregistered thread
* Refine USE_PROC_FOR_LIBRARIES macro documentation for Solaris
* Remove unneeded '__MINGW_EXCPT_DEFINE_PSDK' macro define for mingw32
* Remove unused GC_VERSION in configure
* Remove unused redefinition of GC_free in gctest
* Revert 'Avoid abort on ResumeThread failure if DllMain closes thread'
* Revert 'Fix GC_suspend abort when the thread is deleted by DllMain'
* Turn on pthread_atfork usage on Hurd
* Workaround locals not pushed in sanitized binaries by disabling fake stacks


== [8.2.10] 2025-10-18 ==

* Add missing test_cpp dependency on gc_allocator.h in build scripts
* Add Serenity OS to list of platforms with POSIX threads in configure
* Avoid abort on ResumeThread failure if Win32 DllMain closes thread handle
* Avoid code duplication in GC_dyld_image_add/remove on Darwin
* Do not define GC_SysVGetDataStart on AIX
* Do not produce '-lpthread' by threadlibs on Tru64/OSF1
* Do not search for data start using GC_find_limit on Haiku
* Do not use deprecated _dyld_bind_fully_image_containing_address (Darwin)
* Do not use deprecated get_etext and get_end on Darwin
* Do not use deprecated getsectbynamefromheader_64 (Darwin)
* Duplicate abort message in system app crash dialog on Haiku
* Eliminate 'allocating insufficient size 0 for char` gcc warning in gctest
* Eliminate 'compare signed/unsigned in check_finalizer_nested' bcc warning
* Eliminate 'conversion from void* to ptr_t' g++ warning in PS_ALLOCA_BUF
* Eliminate 'int-to-ptr cast' gcc warning in GC_push_all_stacks on Solaris
* Eliminate 'int-to-ptr cast' gcc warning in GC_restart_all on OpenBSD
* Eliminate 'int-to-ptr cast' gcc warnings in DEBUG_THREADS code
* Eliminate 'message number 726 is invalid' wcc warning
* Eliminate 'unused parameter fd' gcc warning in NOSYS GC_write
* Eliminate 'value exceeds maximum obj size' gcc warning in hugetest on x32
* Ensure no GC_proc_buf overrun on Solaris
* Export CMake libraries with aliases
* Fix 'cannot implement AO_compare_and_swap_full' error by wcc in tests
* Fix 'cannot locate assembly file' bcc32 error in CMake script
* Fix 'conflicting types for sbrk' gcc error on Solaris if redirect malloc
* Fix 'missing GNU-stack section in atomic_ops_sysdeps' ld warning
* Fix 'symbol undefined _snprintf' dmc linker error in cordtest
* Fix 'undefined STACKBOTTOM' preprocessor error for no-OS PowerPC target
* Fix 'undefined symbol GC_arrays` in tools on Solaris
* Fix 'undefined symbol sbrk' linker error on FreeBSD
* Fix all broken URLs in documentation (as of Nov 2024)
* Fix assertion violation about GC_mark_lock_holder in fork_child_proc
* Fix blocked signals in fork_prepare_proc on HP/UX
* Fix cast of struct-based pthread_t to void pointer on Win32
* Fix code blocks formatting in .md files
* Fix compilation error regarding locks initialization in GC_init on HP_PA
* Fix CPP_WORDSZ for LoongArch
* Fix deprecation warning about support of CMake older than v3.10
* Fix extraneous '#' symbol before comment near USE_WINALLOC for Cygwin
* Fix GC_GRANULE_BYTES for SPARC V9
* Fix GC_suspend abort when the thread is deleted by DllMain
* Fix GC_threads alignment caused by 1-byte global AO_TS_t variables (wcc)
* Fix GETPAGESIZE and USE_M[UN]MAP for Nintendo Switch
* Fix getting memory from OS on Haiku
* Fix I_HOLD_LOCK assertion violation in child process
* Fix mark lock in child process after fork
* Fix missing export for Symbian-specific GC_init_global_static_roots
* Fix missing parentheses in SIG_THR_RESTART macro definition
* Fix print_heap_obj call with the lock held in backgraph add_edge
* Fix pthread id stored in GC_threads of child process
* Fix pthread id stored in key thread_specific_data of child process
* Fix pthread_sigmask result checking in GC_start_mark_threads_inner
* Fix reading async proc maps when GC is single-threaded but process is not
* Fix rounding up in STACKBOTTOM for OSF1
* Fix stack base detection on Haiku by using pthread_getattr_np()
* Fix stack direction detection in setjmp_t on E2K
* Fix symbols alignment checking for CRIS and M68K
* Fix undefined reference to GC_objfreelist and GC_bytes_allocd
* Fix usage of new structured procfs interface on Solaris
* Fix various typos in comments and documentation
* Force use of spin locks to improve performance on Haiku
* Grow GC_proc_buf to required size in GC_proc_read_dirty instead of WARN
* Handle sparc-sun-solaris3 (SunOS6) in configure to use sparc_mach_dep.S
* Initial support of Serenity OS on x86[_64]
* Refine comment in fork_child_proc() about GC_allocate_ml attribute
* Refine description of 'more background' links in Overview document
* Remove always-false check if C++ allocator.allocate returns null in test
* Remove comment about limited support of memory unmapping
* Remove improper comment about returned value of CORD_extend_path
* Remove outdated comment about 'make distcheck' from Makefile.am
* Support RISC-V ILP32 ABI (rv64ilp32)
* Suppress 'missing return value' wcc warning for AO asm primitives
* Suppress 'unreachable code' wcc warnings in win32 threads ASSERT (CMake)
* Turn off thread suspend/resume API support explicitly
* Update libatomic_ops repo URL in README after repo transfer
* Update URLs in documentation after repo transfer to bdwgc organization
* Workaround '__stdcall__ ignored for this target' clang warning on Cygwin64
* Workaround 'array index 4096 is above bounds' gcc warning in malloc_kind
* Workaround 'REFERENCED_DYNAMICALLY flag' linker error on macOS 15.4
* Workaround incremental collection fails on Haiku
* Workaround tests crash if mprotect-based VDB is manually selected (bcc)
* Workaround undefined GC_ptr_store_and_dirty MinGW error in Makefile.direct
* Workaround vpush/vpop instructions generation for non-FPU ARMv5 target


== [8.2.8] 2024-09-08 ==

* Allow GC_size() argument to be null
* Disable backtrace saving at garbage collections if DONT_SAVE_TO_LAST_STACK
* Eliminate 'cast signed to bigger unsigned' CSA warnings in GC_find_limit
* Eliminate 'x might be clobbered by longjmp' gcc warning in setjmp_t.c
* Fix 'un-mprotect vdb failed' abort with out-of-memory reason on Linux
* Fix ADD_CALL_CHAIN() placement to follow GC_store_debug_info_inner call
* Fix GC_debug_realloc to support custom kind
* Fix GC_is_visible for case of arg pointing exactly to object upper bound
* Fix GC_print_trace_inner to print the last element of the circular buffer
* Fix cordtst2.tmp file deletion in cordtest on Windows
* Fix double lock in GC_malloc called from backtrace()
* Fix handling of page-unaligned boundaries in soft_set_grungy_pages
* Fix heap blocks size computation by GC_get_memory_use
* Fix indent of a closing curly braces in GC_apply_to_all_blocks
* Fix infinite resend lost signals if a thread is restarted by SIGQUIT
* Fix null pointer dereference in GC_is_visible if type_descr is null
* Fix per_object_helper() after changing hb_sz units
* Fix pointer relational comparison in GC_do_enumerate_reachable_objects
* Fix poor thread-local allocation performance because of double EXTRA_BYTES
* Fix potential GC_add_roots_inner call with an overflowed pointer (Win32)
* Fix potential address overflow in GC_add_to_heap
* Fix potential buffer overrun during read in GC_text_mapping
* Fix various typos in comments
* Prevent GC_noop_sink from scanning by the collector
* Prevent redirected malloc call from a garbage collection routine
* Redirect malloc_usable_size() in leak_detector.h
* Remove redundant dirty/reachable_here calls in GC_malloc_explicitly_typed
* Update and fix diagrams describing the tree structure for pointer lookups
* Use atomic store to set GC_first_nonempty in GC_do_parallel_mark
* Use atomic store to set entry id and update cache_ptr in slow_getspecific
* Workaround '.obj file not found' error reported by watcom wlib


== [8.2.6] 2024-02-04 ==

* Avoid unexpected heap growth in gctest for the case of VERY_SMALL_CONFIG
* Change gc.man to include gc/gc.h
* Check for out-of-memory on every memory allocation in tests
* Do not compile pthread_start.c on Cygwin even if build shared libs (CMake)
* Eliminate 'alloc_small declared but unused' gcc warning in gctest
* Eliminate 'make_key is defined but unused' gcc warning in threadkeytest
* Eliminate 'old_segv_handler is defined but unused' gcc warning on OpenBSD
* Eliminate 'rand() may return deterministic values' warning
* Eliminate 'unused parameter' compiler warnings reported by MS clang
* Eliminate 'unused parameter' gcc warning in free() if IGNORE_FREE
* Eliminate 'unused value' gcc warnings in init_global_static_roots (Symbian)
* Eliminate GCC warning of unsafe __builtin_return_address(1) in Cmake script
* Eliminate compiler warning of missing cast in LONG_MULT after shift
* Eliminate warning of unused expression result in GC_FreeBSDGetDataStart
* Ensure _GNU_SOURCE is defined if HAVE_DLADDR is defined by configure
* Fix 'g++ not found' error on OpenBSD (Makefile.direct)
* Fix 'implicit declaration of function pthread_atfork' gcc error on MinGW
* Fix 'implicit declaration of function sbrk' gcc error on Symbian
* Fix 'implicit declaration of iscntrl()' warning in cord/de_win (MinGW)
* Fix 'info' buffer potential overrun in GC_save_callers
* Fix 'l-value specifies const object' MSVC error in GC_push_many_regs
* Fix 'linker input unused' error inside check_c_compiler_flag (CMake)
* Fix 'missing binary operator before token' gcc error in gcconfig.h
* Fix 'missing sysconf() prototype' gcc error in setjmp_t tool (OpenBSD)
* Fix 'sigset_t undeclared' MS VC error if pthreads-w32 is used
* Fix 'undefined reference' linker errors if shared build on OpenBSD (CMake)
* Fix 'unused GC_set_and_save_fault_handler' warning on OS X
* Fix GC_push_stack_for() to push also Xmm registers on Windows/x64
* Fix GC_set_handle_fork(1) on Darwin when MPROTECT_VDB but no threads
* Fix MACH_TYPE macro redefinition on Symbian/arm
* Fix SVR4 macro definition order
* Fix asm constraint in LONG_MULT for gcc/x86
* Fix assertion violation in GC_get_maps on Linux if malloc redirection
* Fix back graph and checksums support in WCC_MAKEFILE
* Fix bitwise negation and rounding direction in setjmp_t tool
* Fix checksums GC_record_fault invocation on Darwin
* Fix closing bracket placement for case statement in configure
* Fix deprecation warning about support of CMake older than v3.5
* Fix extra 'extern C' for include signal.h in gcconfig.h
* Fix getcontext() detection by CMake on OpenBSD
* Fix handling of GC_gc_no counter wrap in GC_clear_stack
* Fix handling of GC_gc_no counter wrap in GC_notify_or_invoke_finalizers
* Fix indent of a closing curly brace in GC_forward_exception
* Fix lock assertion violation in GC_try_to_collect_inner on OS X
* Fix missing GC_pthread_sigmask on FreeBSD and NetBSD
* Fix missing _setjmp() on djgpp
* Fix missing atomic barriers in CORD_from_file_lazy
* Fix missing outermost parentheses in CORD_pos_cur_char_addr and hugetest
* Fix missing redirect and implementation of pthread_sigmask() on OpenBSD
* Fix missing type widening before left shift in GC_MAKE_PROC
* Fix misspelled GC_HEADERS_H macro in gc_priv.h
* Fix null dereference in check_finalizer_nested if redirect malloc on Linux
* Fix posix_memalign() to overwrite pointer storage only on success
* Fix race in init_lib_bounds on Linux with glibc v2.34+ if redirect malloc
* Fix skipped removal of page protection in case of address hash collision
* Fix typos in comments
* Fix undefined GC_real_pthread_sigmask if redirect malloc on OS X
* Fix update of last_back_trace_gc_no if KEEP_BACK_PTRS is not defined
* Handle GC_gc_no counter overflow properly in GC_print_trace
* Include Darwin CoreFoundation.h only if 32-bit ARM
* Make gc_allocator<void> members public
* Re-enable incremental mode on OS X (arm64)
* Remove .log and cordtest .tmp files by 'make clean' (Makefile.direct)
* Remove a redundant check of HOST_ANDROID in gcconfig.h
* Remove duplication of random numbers generator formula
* Specify constexpr in GC allocators if C++20 or later
* Support NetBSD/riscv64
* Support non-msys MinGW build by CMake
* Turn on handle fork by default on Darwin (multi-threaded only)
* Use AO primitives in GC_RAND_NEXT instead of no_sanitize attribute
* Workaround 'malloc inconsistent dll linkage' MS VC error in CMake script
* Workaround MS Clang failure to compile de_win.rc
* Workaround mark stack overflow in GC_push_finalizer_structures on MinGW


== [8.2.4] 2023-05-26 ==

* Abort with appropriate message if first call of mmap fails with EPERM
* Adjust CORD_ec comment placement in ec.h
* Adjust WoW64 workaround to work on UWP/WinRT
* Adjust naming of Win32/64 and x86/64 words in comments and documentation
* Avoid potential race between realloc and GC_block_was_dirty
* Do not double-clear first two words of object in GC_generic_malloc
* Do not mention FASTLOCK in comment
* Do not mix debug and non-debug allocations in disclaim tests
* Do not prohibit threaded builds with malloc redirection on non-Linux
* Do not prohibit zero proc argument in GC_register_disclaim_proc
* Eliminate '&array may not produce intended result' wcc warnings
* Eliminate 'GC_unmap_end declared but unused' bcc warning in disclaim_bench
* Eliminate 'ISO C++17 does not allow register specifier' gcc warning
* Eliminate 'cast signed to bigger unsigned' CSA warning in WARNs, new_thread
* Eliminate 'n obtained from untrusted source' code defect FP in test_cpp
* Eliminate 'skipping config since MAXSIG/_NSIG is unknown' cppcheck FP
* Eliminate data race FP between remove_protection and write_fault_handler
* Eliminate data race FP reported in need_unreachable_finalization by TSan
* Ensure 'new' system header is included by gc_cpp.h if GC_INCLUDE_NEW
* Ensure GC_NO_PTHREAD_SIGMASK defined if no GC_pthread_sigmask prototype
* Fix 'EMSCRIPTEN macro redefined' compile error
* Fix 'ISO C90 forbids mixed decl and code' warning in SOFT_VDB dirty_init
* Fix 'call to undeclared pthread_setname_np' errors in configure and cmake
* Fix 'failed to create new win32 semaphore' Cygwin fatal error at fork
* Fix 'operator new is missing throw(bad_alloc)' clang warning in gc_cpp.h
* Fix 'overflow in conversion from word' g++ warning in GC_init
* Fix 'unknown option --no-undefined' linker error in cmake script (OS X)
* Fix 'unresolved _end' linker error when targeting Android bitcode
* Fix CORD_next() indent inside loop in test_basics() of cordtest
* Fix DCL_LOCK_STATE placement in GC_set_oom_fn
* Fix GC_excl_table overrun on overflow in GC_exclude_static_roots
* Fix GC_thread_is_registered for finished threads
* Fix GC_unreachable_finalize_mark_proc to ensure its unique address
* Fix GC_unregister_my_thread call before GC functions usage in gctest
* Fix IRIX5 defined wrongly on FreeBSD/mips, WinCE/mips, Tandem S-Series
* Fix allocated objects count increment in alloc8bytes of gctest
* Fix alt-stack handling in GC_push_all_stacks if stack grows up
* Fix comparisons to heap boundary in GC_get_back_ptr_info and GC_mark_from
* Fix data race in GC_heapsize_at_forced_unmap variable
* Fix description of client promise for IGNORE_OFF_PAGE allocated objects
* Fix disabling of automatic dynamic libraries registration
* Fix double initialization of main thread local free lists on Win32
* Fix gccpp and gctba library names in gcinterface.md
* Fix infinite loop in disable_gc_for_dlopen and GC_wait_for_gc_completion
* Fix infinite wait in pthread_join/detach if thread already finished (Win32)
* Fix joinable threads shutdown on NaCl
* Fix loop condition over dll_thread_table in GC_lookup_pthread (Win32)
* Fix missing GC_CALLBACK for GC_waitForSingleObjectInfinite
* Fix missing extern C for __asan_default_options
* Fix missing libalphagc.so dependency in Makefile.direct
* Fix missing lock while updating GC_in_thread_creation in GC_exit_check
* Fix missing recovery from faults in GC_mark_some on Win64 if MinGW
* Fix missing result check of pthread_attr_getdetachstate in pthread_create
* Fix mistyped function name in documentation of REDIRECT_REALLOC
* Fix negative heap size values reported in WARN
* Fix null pointer dereference in TRACE_TARGET
* Fix of GC_bytes_allocd increment in GC_generic_malloc_inner
* Fix overlapping region assertion in mark_some if malloc redirect on Linux
* Fix potential SIGSEGV on out-of-memory in gctest
* Fix signals delivery fail in find-leak mode if init from non-main thread
* Fix stack top/bottom print order in GC_push_all_stacks if stack grows up
* Fix store-and-dirty call in GC_CONS
* Fix unregistering of thread created by intercepted pthread_create on NaCl
* Fix unused GC_parse_version if no SOFT_VDB and no parallel mark on Linux
* Fix use of unset errno after pthread_create/sigmask calls
* Fix various typos in comments and documentation
* Increment allocated objects count after GC_GCJ_MALLOC() in gctest
* Invoke GC_oom_fn if GC_make_array_descriptor failed because of no memory
* Make Emscripten Asyncify feature optional
* Mention gctba library in README.cmake
* Prevent 'function should return a value' BCC error in CMake script
* Provide meaningful error message in case of Emscripten threaded build
* Reduce local variable scope in resend_lost_signals_retry for cppcheck
* Remove disable-warning options from WCC_MAKEFILE unrecognized by wcc v2.0
* Remove false warning of missing libpthread.so on Linux
* Remove redundant 'ifdef THREADS' around LOCK/UNLOCK in call_with_alloc_lock
* Remove redundant GC_ATTR_UNUSED for GC_mark_and_push
* Remove unused GC_old_sig_mask from gc_locks.h
* Replace WARN in GC_mark_some wrapper back to GC_COND_LOG_PRINTF
* Specify throw and noexcept for operator new/delete in gc_cpp.h for MS VC
* Support Hurd/x86_64
* Support client-defined stack pointer adjustment before thread stack push
* Suppress 'unreachable code' wcc warning in I_HOLD_LOCK assertion (CMake)
* Update autotools for release preparation (ac-2.71, am-1.16.5, m4-1.14.19)
* Update dump function name in GC_DUMP_REGULARLY variable documentation
* Use emscripten_stack_get_base instead of emscripten_scan_stack
* Use sbrk() to get OS memory on Emscripten
* Workaround 'writing into region of size 0' gcc warning in suspend_handler
* Workaround CSA null pointer dereference FP in invalidate_map of cord/de
* Workaround a malfunction of soft-dirty bits clearing on Power9


== [8.2.2] 2022-08-26 ==

* Abort if no progress with thread suspend/resume signals resending
* Add CMake option to force libatomic_ops headers usage
* Add _PROP suffix to CORD/GC[CPP]_VERSION variables in CMake script
* Allow not to bypass pthread_cancel hardening in pthread_start
* Allow to start marker threads in child of single-threaded client
* Avoid potential race in GC_init_real_syms after GC_allow_register_threads
* Avoid potential signal loss before sigsuspend in suspend_handler if TSan
* Define SUNOS5SIGS macro for kFreeBSD
* Distribute gc_gcj.h and some other headers in single-obj-compilation
* Do not assert that GC is initialized at DLL_THREAD_DETACH (Win32)
* Do not call SET_HDR() to remove forwarding counts if none exists in hblk
* Do not call mprotect/mmap to GC_unmap/remap (Linux)
* Do not count unmapped regions if GC_unmap is madvise-based (Linux)
* Do not define NEED_FIND_LIMIT in case of OpenBSD user threads
* Do not fail tests if pthread_create returns resource unavailable error
* Do not name GCC intrinsics as C11 ones
* Do not probe to find main data root start if dl_iterate_phdr exists
* Do not send signal to thread which is suspended manually
* Do not use usleep between signals resend if ThreadSanitizer
* Eliminate '-pedantic is not option that controls warnings' GCC-6.3 message
* Eliminate '/GS cannot protect parameters' MS VC warning in msvc_dbg
* Eliminate 'R_AARCH64_ABS64 used with TLS symbol' linker warning (clang)
* Eliminate 'buffer overflow detected' FP error in realloc_test
* Eliminate 'extension used' clang warning in sparc_mach_dep.S (configure)
* Eliminate 'function/data pointer conversion in expression' MSVC warning
* Eliminate 'implicit decl of _setjmp' gcc warning if -std=c11 on Cygwin
* Eliminate 'layout of aggregates has changed in GCC 5' warning in test_cpp
* Eliminate 'new_l may be used uninitialized' gcc warning in os_dep (Cygwin)
* Eliminate 'old_gc_no is initialized but not referenced' MS VC false warning
* Eliminate 'possible loss of data' compiler warning in GC_envfile_getenv
* Eliminate 'potentially uninitialized local variable tc' warning (MSVC)
* Eliminate 'skipping config since MAX_HEAP_SECTS is unknown' cppcheck FP
* Eliminate 'unused but set variable' gcc warnings in cpptest
* Eliminate 'value exceeds maximum size' warnings in debug_malloc, huge_test
* Eliminate 'writing into region of size 0' gcc FP warning in realloc
* Eliminate ASan stack-buffer-underflow FP in GC_mark_and_push_stack (E2K)
* Eliminate code defect about incorrect size of allocated object (leaktest)
* Eliminate data race reported by TSan in GC_have_errors
* Eliminate division-by-zero FP warning in GC_ASSERT in reclaim_block
* Eliminate stringop-overflow gcc-12 warning in CORD__next
* Ensure typed objects descriptor is never located in the first word
* Fix 'GC_greatest_stack_base_below is defined but not used' warning (IA64)
* Fix 'GC_text_mapping not used' GCC warning if redirect malloc w/o threads
* Fix 'ISO C forbids conversion of function pointer to object' warning
* Fix 'undeclared getpagesize' compiler warning on AIX and OSF1
* Fix 'undefined reference to __data_start' linker error on Linux/aarch64
* Fix 'unresolved __imp__wsprintfA' linker error in msvc_dbg.c (MSVC)
* Fix 'unresolved symbol GetModuleHandle' error in win32_threads.c (UWP)
* Fix (workaround) stack overflow in gctest on Alpine Linux/s390x
* Fix GC_ATTR_NO_SANITIZE_THREAD definition for GCC
* Fix GC_allocate_ml incorrect cleanup in GC_deinit if pthreads (MinGW)
* Fix GC_dirty() argument in GC_malloc_explicitly_typed_ignore_off_page
* Fix GC_make_descriptor for zero length argument
* Fix GC_suspend_thread if called before thread destructor
* Fix GC_unmapped_bytes update in GC_unmap for Sony PS/3
* Fix SIGSEGV caused by dropped stack access from child process in gctest
* Fix SUNOS5SIGS documentation to match macro definition in gcconfig.h
* Fix abort in Win32 DllMain if PARALLEL_MARK
* Fix abort when GC_repeat_read returns zero
* Fix assertion about built-in AO_test_and_set_acquire on sparc64 (gcc-12)
* Fix assertion violation in GC_allow_register_threads on Windows
* Fix assertion violation of GC_thread_key alignment if pthread-based TLS
* Fix comment in GC_init regarding GC_init_parallel call
* Fix context saving when GC_suspend_thread(self)
* Fix data race in fail_proc1 of gctest
* Fix hang in GC_free if GC_PREFER_MPROTECT_VDB (Mingw64)
* Fix hang in select() called from suspend signal handler if TSan
* Fix hang on sem_wait in GC_suspend_thread if thread was resumed recently
* Fix hb_obj_kind type in documentation (ASCII diagram) describing hblkhdr
* Fix incremental mode enabling in gctest if TEST_MANUAL_VDB
* Fix linking of tests in case of finalization is off
* Fix lock assertion violation in GC_find_limit if always multi-threaded
* Fix memory return to OS in GC_unmap
* Fix missing lock when GC_generate_random_valid_address is called
* Fix missing write() declaration if CONSOLE_LOG (Watcom)
* Fix nodist_libgc_la_SOURCES value in Makefile.am for Solaris/sparc
* Fix oldProc initialization in gc_cleanup and eliminate related warnings
* Fix parallel_initialized assertion violation in initsecondarythread (Win32)
* Fix potential race if start_mark_threads called from threads in child
* Fix propagation of out-of-memory occurred in GC_make_sequence_descriptor
* Fix pthread_setname_np and dladdr detection by CMake
* Fix race between calloc_explicitly_typed and push_complex_descriptor
* Fix typos in comments and debugging.md
* Fix undefined __stack_base__ on UWP/arm64 (llvm-mingw)
* Force GC_with_callee_saves_pushed in suspend_handler if NO_SA_SIGACTION
* Link with rt library to get clock_gettime where necessary
* Make finalizer_closure pointer read/write atomic in malloc and callback
* Move platform-specific sleep call to GC_usleep (refactoring)
* Pass -lrt linker option in CMake script on HP/UX, NetBSD
* Prevent (fix) parallel custom mark procs run in single-threaded clients
* Prevent changing of GC_markers_m1 value while collection in progress
* Refer to Makefile.direct instead of deleted Makefile file in README
* Relax assertion of hb_n_marks in reclaim_block if more than two markers
* Remove IF_IA64 macro in pthread_stop_world (refactoring)
* Remove checking of RS6000 completely
* Remove duplicate check of MSWIN_XBOX1 in os_dep.c
* Remove duplicate include gc_tiny_fl.h in gc_priv.h
* Remove non-working check of M68K in gctest
* Remove useless TSan W/A about read of mark_lock_holder for Windows
* Replace RAISE_SIGNAL macro with a static function (refactoring)
* Replace SSH cloning with HTTPS one in README
* Retry pthread_kill if EAGAIN (Linux)
* Revert "Check real-symbols are already initialized in pthread_join/detach"
* Revert "Remove nested always-false ifdef for HPUX and FREEBSD"
* Revert addition of msvc_dbg.h in include.am
* Set default build type to RelWithDebInfo (CMake)
* Start configure help messages with a lower case letter
* Support 'z' format modifier by CORD_vsprintf
* Support Elbrus 2000 (Linux/e2k)
* Support GCC MCF thread model (mcfgthreads) in configure (MinGW)
* Support GC_remove_roots on Win32
* Support OpenBSD/riscv64
* Support build using Makefile.direct on Linux/sparc
* Support space-separated flags in CFLAGS_EXTRA passed to CMake
* Update README.win32 about default build configuration (configure, cmake)
* Update documentation of GC_RATE and MAX_PRIOR_ATTEMPTS
* Use SIGRTMIN+6 as suspend signal if sigrt-signals on OpenBSD
* Use SIGUSR1/2 on FreeBSD/arm64
* Use compiler TLS on NetBSD only if at least gcc-4.4 or clang-3.9
* Workaround 'info is not assigned' cppcheck FP if assertions on (OS X)
* Workaround SIG_SUSPEND delivery to thread inside mutex_lock fail if TSan
* Workaround TSan FP about race between generic_malloc and array_mark_proc
* Workaround TSan FP in acquire_mark_lock called from fork_prepare_proc
* Workaround TSan FP warning in finalized_malloc, push_unconditionally
* Workaround TSan FP warning in fork_prepare_proc
* Workaround TSan FP warning in push_marked1/2/4, ptr_store_and_dirty
* Workaround Thread Sanitizer (TSan) FP warning in is_valid_displacement
* Workaround call stack size exceeded in gctest (Wasm)
* Workaround crash in FreeBSD rand() by avoiding its concurrent usage
* Workaround gctest hang if test compiled as C++ code by MSVC (CMake)
* Workaround msvc_dbg.c build failure on arm[64] (MSVC)


== [8.2.0] 2021-09-29 ==

* Add API for accessing incremental GC time limit with nanosecond precision
* Add API function to force start of incremental collection
* Add GC_ prefix to scan_ptr and some other static variables (refactoring)
* Add GC_get/set_disable_automatic_collection API
* Add I_HOLD_LOCK assertion to expand_hp_inner and related functions
* Add assertion on free-list argument and result of GC_new_kind
* Add assertion that GC is initialized to base incremental_protection_needs
* Add assertions that GC_page_size is initialized
* Add cordtest, staticrootstest, test_cpp, tracetest, disclaim tests (CMake)
* Add debug messages on thread suspend/resume (Win32)
* Add dummy testing of GC_incr_bytes_allocd/freed
* Add table of contents in gcdescr.md
* Add testing of GC_CALLOC/MALLOC_EXPLICITLY_TYPED (gctest)
* Adjust formatting of numbered lists in README.md to match other .md files
* Adjust highlighting of API prototypes in gcinterface.md
* Adjust macro def/usage for AVR32, CRIS, NETBSD, OPENBSD, SH4 in gcconfig.h
* Adjust printf calls in gctest check_heap_stats so that each has new-line
* Allow incremental GC on Cygwin
* Allow memory unmapping in case of MPROTECT_VDB
* Allow to disable GWW or mprotect-based VDB at build
* Allow to disable Glibc FPU exception mask and TSX workarounds (Linux)
* Allow to disable __builtin_return_address(1) usage (x86 and x64)
* Allow to specify custom value of LOG_PHT_ENTRIES
* Always abort on failure to access /proc/self/maps (Linux)
* Always define default_push_other_roots (code refactoring)
* Avoid gcc stringop-overflow warning for intended overflow in smashtest
* Avoid initial 3ms pause on world stop/start with GC_retry_signals (Linux)
* Build cord.lib by Makefile.direct, NT_MAKEFILE, OS2_MAKEFILE, WCC_MAKEFILE
* Build gc as a shared multi-threaded library by default (CMake)
* Build gccpp library by Makefile.direct, NT_MAKEFILE and WCC_MAKEFILE
* Build gctba library
* Build shared libraries by default (WCC_MAKEFILE)
* Change CLOCK_TYPE to timespec for Nintendo Switch (code refactoring)
* Change EMSCRIPTEN macro for internal use to no-underscore format
* Change log_size fields of finalizer to unsigned type (code refactoring)
* Change type of toggleref_array_size/capacity to size_t (code refactoring)
* Check leak of objects allocated by CRT malloc in gctest (MS VC)
* Check real-symbols are already initialized in pthread_join/detach
* Collapse multiple includes of windows.h (code refactoring)
* Comments reformatting in mark.c to properly delimit sentences
* Compile de test GUI app with resources (CMake)
* Compile gc.c unless building static libraries (NT_MAKEFILE, WCC_MAKEFILE)
* Compile msvc_dbg.c by CMake script (MS VC)
* Declare API function and print amount of memory obtained from OS
* Define GC_win32_free_heap API function for all Windows targets
* Define STATIC macro to static by default
* Depend number of fork_a_thread calls on NTHREADS (gctest)
* Detect dladdr() presence in CMake script
* Detect presence of execinfo.h system header in CMake script
* Detect presence of getcontext and dl_iterate_phdr in CMake script
* Detect sigsetjmp() availability in CMake script
* Disable Clang/GCC aliasing optimization in CMake script by default
* Do not build tests by default (Makefile.direct and other Makefiles)
* Do not build the tests by default (CMake)
* Do not call GC_push_conditional unless PROC_VDB
* Do not call add_to_our_memory with null pointer (refactoring)
* Do not compile pthread_*.c files in Cygwin or MSYS (CMake)
* Do not define GC_write_cs for Xbox One target
* Do not define HAVE_NO_FORK for all Unix-like systems
* Do not hard-code CMAKE_DL_LIBS value and install paths (CMake)
* Do not hard-code finalizable objects limit which triggers GC
* Do not update scratch_last_end_ptr unless used by reg dynamic libraries
* Document GC_incr_bytes_allocd/freed API function
* Eliminate '(long)size<=0 is always false' cppcheck FP
* Eliminate 'Consecutive return is unnecessary' cppcheck style warning
* Eliminate 'accessing GC_dont_gc without lock' in GC_init code defect FP
* Eliminate 'bytes_freed access w/o lock in incr_bytes_free' code defect FP
* Eliminate 'checking if unsigned i < 0' cppcheck FP in is_heap_base
* Eliminate 'hash_val value is never used' cppcheck false positive
* Eliminate 'passing tainted var maps_buf to tainted sink' code defect FP
* Eliminate 'retry_cnt is assigned value but never used' cppcheck FP
* Eliminate 'stop variable is always 0' compiler warning in print_callers
* Eliminate 'struct member os_callback is never used' cppcheck warning
* Eliminate 't->flags not atomically updated' code defect FP
* Eliminate 'tmpl might be accessed at non-zero index' cppcheck error
* Eliminate GCC warning of unsafe __builtin_return_address(1)
* Eliminate code duplication in reclaim_clear and disclaim_and_reclaim
* Eliminate double lock code defect false positive in generic_lock
* Eliminate memory leak reported in add_current_malloc_heap at exit (Win32)
* Emscripten single-threaded support (detect stack base, push registers)
* Enable CMake-based build for Borland and Watcom compilers
* Enable compilation without C runtime (Win32)
* Enable fork testing in single-thread builds (Unix-like)
* Enable mprotect-based incremental GC for Linux/arm and Linux/aarch64
* Enable true incremental collection even if parallel marker is on
* Enable use of __builtin_unwind_init() if clang-8 or later
* Ensure ELFSIZE is defined in dyn_load.c for OpenBSD (code refactoring)
* Ensure add_to_heap_inner arguments are valid (refactoring)
* Ensure all getters and setters are run at least once by gctest (pthreads)
* Export CMake targets with namespace BDWgc
* Fix 'const obj must be initialized if not extern' error in gc_alloc_ptrs.h
* Fix ./libgc.la dependency on FreeBSD (Automake)
* Fix HOST determination in CMake script
* Fix copyright message in de_win.rc, gc_cpp.cc, ec.h and specific.h
* Fix missing OS_TYPE definition for some targets
* Fix mmap(PROT_NONE) failure if RLIMIT_AS value is low (Linux)
* Generate cordtest and de executable files in GC base folder
* Generate pkg-config metadata file (CMake)
* Get rid of some non-ELF ifdefs (code refactoring)
* Handle potential incomplete buffer read in GC_linux_main_stack_base
* Implement GET_TIME for Nintendo Switch
* Increase NTHREADS value in tests if code coverage analysis
* Install docs and man page if enable_docs (CMake)
* Install gc_gcj.h and gc_pthread_redirects.h only if appropriate
* Log abort message details even if not print_stats (unless SMALL_CONFIG)
* Mark buffer returned by get_maps as const (code refactoring)
* Move C++ GC_ATTR_EXPLICIT and GC_NOEXCEPT definition to gc_config_macros.h
* Move GC state non-pointer variables into GC_arrays (code refactoring)
* Move GC state pointer variables into GC_arrays
* Move GC_scratch_recycle_inner() to alloc.c (refactoring)
* Move GC_throw_bad_alloc definition to new C++ file
* Move QNX and Emscripten macro definitions to proper place in gcconfig.h
* Move definition of GC_n_mark_procs and GC_n_kinds from mark.c to misc.c
* New API (GC_set_markers_count) to control number of parallel markers
* New API function to clear GC exclusion table
* New API function to get size of object debug header
* New API standalone functions to acquire and release the allocator lock
* New CMake option (disable_gc_debug) to remove debugging code
* New CMake option (disable_handle_fork) to disable fork handling completely
* New macro (CONSOLE_LOG) to enable logging to console on Win32
* New macro (GCTEST_PRINT_VERBOSE) to enable verbose logging in test.c only
* New macro (NO_MSGBOX_ON_ERROR) to avoid message box on GC abort (Win32)
* OpenBSD does not use ELF_CLASS (code refactoring)
* Pass -D GC_DLL -fvisibility=hidden if default configure build is requested
* Pass -no-undefined linker flag if building shared libraries (CMake)
* Print pid of child processes if verbose logging (gctest)
* Read environment variables from a file on WinCE (CMake script)
* Reduce stack-allocated buffer in get_nprocs from 4KB to 1.7KB
* Refine flags field comment in pthread_support.h
* Reflect result of VDB selection at runtime in incremental_protection_needs
* Reformat code of GC_push_roots
* Reformat gc.man (wrap long lines)
* Reformatting and code refactoring of CMake script
* Remove 'current users' section from overview.md
* Remove 'distributed ports', 'scalable versions' sections from overview.md
* Remove AC_MSG_RESULT for THREADDLLIBS (dgux386)
* Remove Borland-specific Makefile and gc.mak script
* Remove GC_eobjfreelist variable in typd_mlc.c (code refactoring)
* Remove GC_gcj_malloc_initialized variable (code refactoring)
* Remove Linux-specific commands for building cord/de from Makefile.direct
* Remove Win32 main_thread static variable if threads discovery is disabled
* Remove code duplication between GC_unmap and GC_unmap_gap (refactoring)
* Remove code duplication between PROTECT and UNPROTECT macros (refactoring)
* Remove commented out assignment of gc_use_mmap in configure (refactoring)
* Remove dash characters comprising prefix of some verbose logs (gctest)
* Remove dependency on user32.dll import library from static libgc (Win32)
* Remove documentation specific to particular old BDWGC releases
* Remove duplicate Linux-related macro definitions in gcconfig.h
* Remove duplicate macro definitions in gcconfig.h except for Linux
* Remove gcmt-dll generation, rename libgc-lib.a to libgc.a (CMake)
* Remove goto statement in print_callers (code refactoring)
* Remove limit on number of heap sections
* Remove new_gc_alloc.h file
* Remove redundant GC_with_callee_saves_pushed call in multi-threaded builds
* Remove redundant check of GC_free argument in register_finalizer
* Remove redundant type casts in backgraph HEIGHT_UNKNOWN/IN_PROGRESS
* Remove unused GC_prev_heap_addr (refactoring)
* Remove unused STACK_GRAN macro definitions (code refactoring)
* Remove unused sparc_sunos4_mach_dep.s file
* Remove useless empty statements after block ones (refactoring)
* Remove weakobj_free_list variable in disclaim_weakmap_test (refactoring)
* Rename READ to PROC_READ in os_dep.c (code refactoring)
* Rename cord/cord test executable to de (CMake)
* Rename ext_descr to typed_ext_descr_t (code refactoring)
* Rename gc64.dll to gc.dll and gc[64]_dll.lib to gc.lib in NT_MAKEFILE
* Rename gc68060.lib to gc.lib, cord/cord68060.lib to cord.lib in SMakefile
* Rename make_as_lib option to enable_static in NT_MAKEFILE and WCC_MAKEFILE
* Rename nothreads option to disable_threads in NT_MAKEFILE
* Repeat run_one_test NTHREADS times by gctest if single-threaded
* Replace "msecs" with "ms" in all comments and messages
* Replace 'stack base' with 'stack bottom' in the documentation
* Replace SN_TARGET_ORBIS to PLATFORM_* and GC_NO_* macros
* Replace _M_AMD64 macro with _M_X64 (code refactoring)
* Replace find_limit_openbsd to find_limit_with_bound (OpenBSD 5.2+)
* Replace obsolete AC_HELP_STRING with AS_HELP_STRING (refactoring)
* Replace push_one calls with push_many_regs one for Win32 thread context
* Report memory region bounds and errno on GC_unmap/remap failure
* Report presence of process fork testing (gctest)
* Report time with a nanosecond precision where available
* Retry suspend/resume signals on all platforms by default
* Run tree and typed tests in child process (gctest)
* Set GC_collecting hint for GC_collect_a_little_inner calls (pthreads)
* Set name of GC marker threads
* Set so-version for installed shared libraries (CMake)
* Simplify logged message in scratch_recycle
* Simplify loops of collect_a_little/stopped_mark invoking mark_some
* Support -fvisibility=hidden option in CMake script
* Support CFLAGS_EXTRA to pass extra user-defined compiler flags (CMake)
* Support FreeBSD/RISC-V, Linux/arc, LoongArch, OpenBSD/powerpc64
* Support header files installation (CMake)
* Support most configure options in CMake script
* Suppress warnings in test_tinyfl() of gctest reported by Watcom C complier
* Take nanoseconds into account when updating full_gc_total_time
* Turn off C++ API by default, export it in gccpp library (CMake)
* Turn on automatic fork() handling by default on Android
* Update README.cmake regarding Unix, C++ and tests
* Update libgc.so version info to differentiate against v8.0.x
* Update the ASCII diagrams describing the tree structure for pointer lookups
* Update the documentation to match the current GC implementation
* Upgrade cmake_minimum_required(version) to 3.1
* Use CreateThread without GC_ prefix in gctest (code refactoring)
* Use KB/MB/GB abbreviations uniformly across entire documentation
* Use USE_MMAP_ANON when USE_MMAP is configured on OpenBSD
* Use a specific Emscripten allocator for Tiny
* Use atomic primitives for Sony PlayStation Portable 2 and PS4
* Use better precision Windows timers
* Use clock_gettime() instead of clock() on Cygwin and Linux
* Use compiler TLS on FreeBSD and NetBSD
* Use mprotect-based VDB on PowerPC and S390 (Linux)
* Use soft dirty bits on Linux (x86, powerpc, s390, x64)
* Workaround 'condition result<=0 is always false' cppcheck FP in get_maps
* Workaround 'push_regs configured incorrectly' error (GCC-11)
* Workaround 'same value in both branches of ternary operator' cppcheck FP
* Workaround various cppcheck false positives


== [8.0.18] 2026-02-04 ==

* Eliminate 'GC_push_all_stack not used' gcc warning if fix-up pointers
* Fix 'MA_FETCHOP undeclared' gcc error if USE_PROC_FOR_LIBRARIES on Solaris
* Fix 'PIOCNMAP undeclared' gcc error if USE_PROC_FOR_LIBRARIES on Solaris

Also, includes 7.6.26 changes


== [8.0.16] 2025-10-17 ==

* Add missing test_cpp dependency on gc_allocator.h in build scripts
* Avoid abort on ResumeThread failure if Win32 DllMain closes thread handle
* Do not define GC_SysVGetDataStart on AIX
* Do not produce '-lpthread' by threadlibs on Tru64/OSF1
* Eliminate 'allocating insufficient size 0 for char` gcc warning in gctest
* Eliminate 'compare signed/unsigned in check_finalizer_nested' bcc warning
* Eliminate 'int-to-ptr cast' gcc warning in GC_restart_all on OpenBSD
* Eliminate 'int-to-ptr cast' gcc warnings in DEBUG_THREADS code
* Eliminate 'unused parameter fd' gcc warning in NOSYS GC_write
* Eliminate 'value exceeds maximum obj size' gcc warning in hugetest on x32
* Eliminate 'writing into region of size 0' gcc warning in suspend_handler
* Fix 'cannot implement AO_compare_and_swap_full' error by wcc in tests
* Fix 'missing GNU-stack section in atomic_ops_sysdeps' ld warning
* Fix 'symbol undefined _snprintf' dmc linker error in cordtest
* Fix 'undefined STACKBOTTOM' preprocessor error for no-OS PowerPC target
* Fix 'undefined symbol sbrk' linker error on FreeBSD
* Fix blocked signals in fork_prepare_proc on HP/UX
* Fix code blocks formatting in .md files
* Fix GC_GRANULE_BYTES for SPARC V9
* Fix GC_suspend abort when the thread is deleted by DllMain
* Fix GETPAGESIZE and USE_M[UN]MAP for Nintendo Switch
* Fix missing parentheses in SIG_THR_RESTART macro definition
* Fix print_heap_obj call with the lock held in backgraph add_edge
* Fix pthread id stored in GC_threads of child process
* Fix pthread_sigmask result checking in GC_start_mark_threads_inner
* Fix rounding up in STACKBOTTOM for OSF1
* Fix symbols alignment checking for CRIS and M68K
* Fix undefined reference to GC_objfreelist and GC_bytes_allocd
* Fix usage of new structured procfs interface on Solaris
* Fix various typos in comments and documentation
* Refine comment in fork_child_proc() about GC_allocate_ml attribute
* Remove always-false check if C++ allocator.allocate returns null in test
* Remove comment about limited support of memory unmapping
* Remove improper comment about returned value of CORD_extend_path
* Remove outdated comment about 'make distcheck' from Makefile.am
* Update libatomic_ops repo URL in README after repo transfer
* Update URLs in documentation after repo transfer to bdwgc organization
* Workaround '__stdcall__ ignored for this target' clang warning on Cygwin64
* Workaround tests crash if mprotect-based VDB is manually selected (bcc)


== [8.0.14] 2024-09-07 ==

* Disable backtrace saving at garbage collections if DONT_SAVE_TO_LAST_STACK
* Fix infinite resend lost signals if a thread is restarted by SIGQUIT

Also, includes 7.6.22 changes


== [8.0.12] 2024-02-04 ==

* Eliminate 'make_key is defined but unused' gcc warning in threadkeytest
* Ensure _GNU_SOURCE is defined if HAVE_DLADDR is defined by configure
* Fix 'implicit declaration of function pthread_atfork' gcc error on MinGW
* Fix 'missing binary operator before token' gcc error in gcconfig.h
* Fix GC_set_handle_fork(1) on Darwin when MPROTECT_VDB but no threads
* Fix checksums GC_record_fault invocation on Darwin
* Fix extra 'extern C' for include signal.h in gcconfig.h

Also, includes 7.6.20 changes


== [8.0.10] 2023-05-26 ==

* Abort with appropriate message if first call of mmap fails with EPERM
* Avoid potential race between realloc and GC_block_was_dirty
* Do not prohibit zero proc argument in GC_register_disclaim_proc
* Eliminate '&array may not produce intended result' wcc warnings
* Eliminate 'cast signed to bigger unsigned' CSA warning in GC_new_thread
* Ensure 'new' system header is included by gc_cpp.h if GC_INCLUDE_NEW
* Fix 'overflow in conversion from word' g++ warning in GC_init
* Fix description of client promise for IGNORE_OFF_PAGE allocated objects
* Fix infinite loop in disable_gc_for_dlopen and GC_wait_for_gc_completion
* Fix missing extern C for __asan_default_options
* Fix store-and-dirty call in GC_CONS
* Fix typo in comment of GC_Thread_Rep.dummy
* Fix use of unset errno after pthread_sigmask calls
* Increment allocated objects count after GC_GCJ_MALLOC() in gctest
* Remove redundant GC_ATTR_UNUSED for GC_mark_and_push
* Workaround CSA null pointer dereference FP in invalidate_map of cord/de

Also, includes 7.6.18 changes


== [8.0.8] 2022-08-26 ==

* Avoid potential race in GC_init_real_syms after GC_allow_register_threads
* Define SUNOS5SIGS macro for kFreeBSD
* Distribute gc_disclaim.h in single-obj-compilation
* Do not assert that GC is initialized at DLL_THREAD_DETACH (Win32)
* Do not name GCC intrinsics as C11 ones
* Do not send signal to thread which is suspended manually
* Eliminate 'buffer overflow detected' FP error in realloc_test
* Eliminate 'extension used' clang warning in sparc_mach_dep.S (configure)
* Eliminate 'function/data pointer conversion in expression' MSVC warning
* Eliminate 'implicit decl of _setjmp' gcc warning if -std=c11 on Cygwin
* Eliminate 'new_l may be used uninitialized' gcc warning in os_dep (Cygwin)
* Eliminate 'old_gc_no is initialized but not referenced' MS VC false warning
* Eliminate 'possible loss of data' compiler warning in GC_envfile_getenv
* Eliminate 'value exceeds maximum size' warnings in debug_malloc, huge_test
* Eliminate 'writing into region of size 0' gcc FP warning in realloc
* Eliminate division-by-zero FP warning in GC_ASSERT in reclaim_block
* Eliminate stringop-overflow gcc-12 warning in CORD__next
* Ensure typed objects descriptor is never located in the first word
* Fix 'GC_greatest_stack_base_below is defined but not used' warning (IA64)
* Fix 'GC_text_mapping not used' GCC warning if redirect malloc w/o threads
* Fix 'ISO C forbids conversion of function pointer to object' warning
* Fix 'undeclared getpagesize' compiler warning on AIX and OSF1
* Fix 'undefined reference to __data_start' linker error on Linux/aarch64
* Fix GC_allocate_ml incorrect cleanup in GC_deinit if pthreads (MinGW)
* Fix GC_dirty() argument in GC_malloc_explicitly_typed_ignore_off_page
* Fix GC_make_descriptor for zero length argument
* Fix GC_suspend_thread if called before thread destructor
* Fix GC_unmapped_bytes update in GC_unmap for Sony PS/3
* Fix SIGSEGV caused by dropped stack access from child process in gctest
* Fix SUNOS5SIGS documentation to match macro definition in gcconfig.h
* Fix abort in Win32 DllMain if PARALLEL_MARK
* Fix assertion about built-in AO_test_and_set_acquire on sparc64 (gcc-12)
* Fix assertion violation in GC_allow_register_threads on Windows
* Fix assertion violation of GC_thread_key alignment if pthread-based TLS
* Fix context saving when GC_suspend_thread(self)
* Fix data race in fail_proc1 of gctest
* Fix get_maps failure when GC_repeat_read returns zero
* Fix hang in GC_free if GC_PREFER_MPROTECT_VDB (Mingw64)
* Fix hang in select() called from suspend signal handler if TSan
* Fix hang on sem_wait in GC_suspend_thread if thread was resumed recently
* Fix hb_obj_kind type in documentation (ASCII diagram) describing hblkhdr
* Fix incremental mode enabling in gctest if TEST_MANUAL_VDB
* Fix lock assertion violation in GC_find_limit if always multi-threaded
* Fix missing lock when GC_generate_random_valid_address is called
* Fix nodist_libgc_la_SOURCES value in Makefile.am for Solaris/sparc
* Fix oldProc initialization in gc_cleanup and eliminate related warnings
* Fix parallel_initialized assertion violation in initsecondarythread (Win32)
* Fix potential race if start_mark_threads called from threads in child
* Fix propagation of out-of-memory occurred in GC_make_sequence_descriptor
* Fix race between calloc_explicitly_typed and push_complex_descriptor
* Fix stack overflow in gctest on Alpine Linux/s390x
* Fix typo in debugging.html
* Fix typos in comments of .c files and gc.h
* Fix undefined __stack_base__ on UWP/arm64 (llvm-mingw)
* Make finalizer_closure pointer read/write atomic in malloc and callback
* Prevent (fix) parallel custom mark procs run in single-threaded clients
* Prevent changing of GC_markers_m1 value while collection in progress
* Refer to Makefile.direct instead of deleted Makefile file in README
* Relax assertion of hb_n_marks in reclaim_block if more than two markers
* Remove checking of RS6000 completely
* Remove duplicate check of MSWIN_XBOX1 in os_dep.c
* Remove non-working check of M68K in gctest
* Remove useless TSan W/A about read of mark_lock_holder for Windows
* Replace SSH cloning with HTTPS one in README
* Revert "Remove nested always-false ifdef for HPUX and FREEBSD"
* Revert addition of msvc_dbg.h in include.am
* Support 'z' format modifier by CORD_vsprintf
* Update documentation of GC_RATE and MAX_PRIOR_ATTEMPTS
* Use SIGRTMIN+6 as suspend signal if sigrt-signals on OpenBSD
* Workaround TSan FP about race between generic_malloc and array_mark_proc
* Workaround TSan FP warning in finalized_malloc, push_unconditionally
* Workaround TSan FP warning in push_marked1/2/4, ptr_store_and_dirty
* Workaround Thread Sanitizer (TSan) FP warning in is_valid_displacement
* Workaround crash in FreeBSD rand() by avoiding its concurrent usage (tests)


== [8.0.6] 2021-09-28 ==

* Add loop to handle abort error like in suspend logic on Darwin
* Add support of OpenBSD/aarch64
* Add threading libraries to bdw-gc.pc
* Allocate start_info struct on the stack in GC_pthread_create
* Allow GC_PAUSE_TIME_TARGET environment variable values smaller than 5 ms
* Avoid compiler warning about unused d in GC_CALLOC/MALLOC_EXPLICITLY_TYPED
* Avoid gcc stringop-overflow warning for intended overflow in smashtest
* Check _MSVC_LANG macro in addition to __cplusplus (MS VC)
* Compile C++ code with exception handling enabled in NT_MAKEFILE
* Define OS_TYPE and DATAEND for UWP targets
* Disable mprotect-based incremental GC if /proc roots are used (Linux)
* Do not report 'Incremental GC incompatible' warning more than once
* Do not use Manual VDB mode if C malloc is redirected
* Do not use iOS private symbols
* Eliminate 'GC_non_gc_bytes is deprecated' warning in new_gc_alloc.h
* Eliminate 'GC_old_bus_handler defined but not used' compiler warning
* Eliminate 'cast between incompatible func types' warnings for FARPROC vars
* Eliminate 'comparing signed and unsigned values' BCC warning in cordtest
* Eliminate 'gc_pthread_redirects.h should contain header guard' code defect
* Eliminate 'implicit declaration of sbrk' gcc warning if -std=c11 on Cygwin
* Eliminate 'possible loss of data' BCC and MS VC warnings
* Eliminate 'static GC_sysinfo definition has incomplete type' Clang warning
* Eliminate 'unused function' compiler warnings (GC_add_map_entry, GC_lock)
* Eliminate 'while clause does not guard' GCC warning in GC_parse_map_entry
* Enable sbrk-to-mmap fallback on major supported Unix-like platforms
* Ensure process is running on one CPU core if AO ops are emulated with locks
* Explicitly zero-initialize trace_buf (fix trace_buf initialization)
* Fix 'ACCESS_VIOLATION in marker' GC warning on Win32 async thread start
* Fix 'GC_generic_malloc must be available' GCC error in new_gc_alloc.h
* Fix 'ISO C++17 does not allow dynamic exception spec' clang-8 error
* Fix 'Wrong __data_start/_end pair' if -Bsymbolic-functions used (Linux)
* Fix 'condition pred!=NULL is always true' compiler warning
* Fix 'external linkage required for var because of dllimport' error on MinGW
* Fix 'ulong undefined' compilation error on AIX
* Fix 'undefined reference to __data_start' linker error on RISC-V
* Fix 'use of undeclared BUS_PAGE_FAULT' compilation error on FreeBSD 12
* Fix 'write to GC log failed' error (Cygwin)
* Fix 'wrong finalization data' gctest failure on Windows
* Fix CMake build on macOS Catalina
* Fix GC_OPENBSD_THREADS definition (OpenBSD/hppa)
* Fix GC_proc_fd value in child process at fork (Solaris)
* Fix GC_with_callee_saves_pushed for Android NDK r23 (clang-12)
* Fix MPROTECT_VDB definition for single-threaded GC builds
* Fix OS_TYPE and USE_MMAP_ANON definitions for Cygwin/x64
* Fix STACKBOTTOM on 32-bit HP/UX 11.11
* Fix abort in GC_printf when gctest is built as WinMain executable (Cygwin)
* Fix assertion violation in register_dynlib_callback on Android
* Fix build for OS X (CMake)
* Fix building of shared library with C++ support on MinGW
* Fix compiling by Makefile.direct on OpenBSD/UltraSparc
* Fix configure message about 'AIX gcc optimization fix'
* Fix cordtest build in SMakefile.amiga
* Fix data race regarding *rlh value in generic_malloc_many
* Fix first_thread stack_base initialization if custom GC_stackbottom (Win32)
* Fix gc_allocator.h compilation by Clang
* Fix gc_cflags variable name in configure (HP/UX)
* Fix handling of areas smaller than page size in GC_scratch_recycle
* Fix incorrect markup formatting in documentation
* Fix misaligned tlfs passed to AO_load on m68k
* Fix missing GC_quiet declaration in pcr_interface.c
* Fix missing gc_dlopen.c and specific.c in CMake script
* Fix missing scratch_last_end_ptr update (Irix)
* Fix mmap() failures on AIX, HP/UX and Haiku
* Fix overflow of scratch_free_ptr value
* Fix page_was_[ever_]dirty() for static roots (Solaris)
* Fix printf format specifier in simple_example.md
* Fix save_callers for multi-threaded case if built-in backtrace unavailable
* Fix subexpression widening in memhash() of disclaim_weakmap_test
* Fix test_cpp failure caused by arbitrary link order (Win32)
* Fix test_cpp failure when gc_cpp resides in a dll (Borland, Watcom)
* Fix various typos mostly in documentation files
* Fix word size, data start and alignment for OpenBSD/mips64(el)
* Include <alloca.h> when using alloca on AIX
* Limit number of unmapped regions (Linux and DragonFly)
* New macro to avoid system-wide new/delete inlining in gc_cpp.h (Win32)
* Prevent GetThreadContext failure (Windows)
* Prevent WARN of incompatible incremental GC if default or manual VDB
* Reduce a time period between GetExitCodeThread and SuspendThread (Win32)
* Refactoring of WoW64 workaround (Win32)
* Refine GC_INIT documentation about its multiple invocation
* Refine GC_parallel documentation in gc.h
* Refine do_blocking() documentation in gc.h
* Remove a misleading comment about Solaris in gc.h
* Remove cord .h files from list of non-installed headers (Automake)
* Remove dead part of condition to define NEED_FIND_LIMIT in gc_priv.h
* Remove gcmt-lib generation by CMake
* Support MSYS builds by CMake and configure
* Update documentation about the incremental collector support
* Use HEURISTIC2 on OpenBSD when single-threaded
* Use pstat_getprocvm to determine main stack bottom on HP-UX
* Workaround 'expression is only useful for its side effects' WCC warning
* Workaround clang-3.8/s390x bug when processing __builtin_frame_address
* Workaround fread fail after enable_incremental if malloc redirected (Linux)


== [8.0.4] 2019-03-02 ==

* Avoid a full GC when growing finalizer tables if in incremental mode
* Avoid potential race in hb_sz access between realloc and reclaim_block
* Avoid test.o rebuild on tests folder timestamp change (Makefile.direct)
* Avoid unexpected heap growth in gctest caused by GC_disable
* Ensure result of every variant of MS_TIME_DIFF has unsigned long type
* Fix 'duplicate symbol' error for tests using multiple static libs (OS X)
* Fix 'undefined reference to __data_start' linker error (Android/aarch64)
* Fix 'unexpected mark stack overflow' abort in push_all_stack
* Fix 'wrong __data_start/_end pair' error on Android
* Fix BSD_TIME variant of MS_TIME_DIFF for the case of a.tv_usec < b.tv_usec
* Fix GetThreadContext stale register values use if WoW64 (Win32)
* Fix invalid initializer of CLOCK_TYPE variables if BSD_TIME
* Fix thread_info() count argument value (OS X)
* Support de_win.c compilation by Makefile.direct (cord/de)


== [8.0.2] 2018-12-23 ==

* Abort with appropriate message if executable pages cannot be allocated
* Add initial testing of GC_enable/disable, MALLOC[_ATOMIC]_IGNORE_OFF_PAGE
* Add paths to filenames mentioned in the copyright section in README
* Add test using disclaim notifiers to implement a weak map
* Adjust #error messages format
* Allow to force executable pages allocation in gctest
* Avoid potential 'macro redefinition' errors for config.h macros
* Call real pthread_sigmask instead of its wrapper in start_mark_threads
* Check result of pthread_mutex_unlock in specific.c
* Default to a single-threaded build for Nintendo, Orbis, Sony PSP targets
* Default to non-executable memory allocation across all make scripts
* Define GC_ATOMIC_UNCOLLECTABLE and JAVA_FINALIZATION in all make scripts
* Do not prevent GC from looking at environment variables (BCC_MAKEFILE)
* Do not use 'ifndef AO_CLEAR' in mark, pthread_support and gctest
* Do not use spin locks if AO test-and-set is emulated (pthreads)
* Document HANDLE_FORK macro optional usage in Makefile.direct
* Document assertion in the setters that used to return old value
* Eliminate 'assigned value never used' compiler warning in test_cpp WinMain
* Eliminate 'casting signed to bigger unsigned int' CSA warning
* Eliminate 'different const qualifiers' MS VC warnings in cordbscs
* Eliminate 'function is never used' cppcheck warning for calloc/realloc
* Eliminate 'non-virtual destructor for class with inheritors' CSA warning
* Eliminate 'pointer targets differ in signedness' compiler warning (Win32)
* Eliminate 'struct member is never used' cppcheck warnings in os_dep
* Eliminate 'uninitialized var' cppcheck false positive in mach_dep, os_dep
* Eliminate 'unreferenced formal parameter' compiler warning in msvc_dbg
* Eliminate redundant check in backwards_height
* Fix 'USE_MUNMAP macro redefinition' error for NaCl
* Fix 'collecting from unknown thread' abort in leak-finding mode for Win32
* Fix 'mprotect remapping failed' abort on NetBSD with PaX enabled
* Fix 'too wide non-owner permissions are set for resource' code defect
* Fix GC_VSNPRINTF in cordprnt for DJGPP and MS VC for WinCE
* Fix GC_register_disclaim_proc for leak-finding mode
* Fix a deadlock in write_fault_handler if AO_or is emulated
* Fix comment typo in CMakeLists.txt
* Fix concurrent bitmap update in GC_dirty
* Fix deadlocks in write and suspend handlers if AO test-and-set is emulated
* Fix executable memory allocation in GC_unix_get_mem
* Fix hbp overflow in GC_install_counts
* Fix linkage with a system libatomic_ops shared library
* Fix lock assertion violation in get_index if GC_ALWAYS_MULTITHREADED
* Fix marking of finalizer closure object
* Fix marks and hb_n_marks consistency when disclaim returns true
* Fix memory allocation on GCF (Linux/x64)
* Fix missing curses.h in cord/de when compiling manually (MS VC, MinGW)
* Fix test_cpp assertion violation in find-leak mode
* Fix tests linkage with internal atomic_ops.o
* Fix unneeded end_stubborn_change/ptr_store_and_dirty in disclaim_test
* Guard against potential buffer overflow in CORD_next and CORD_pos_fetch
* New macro to suppress printing of leaked objects
* Pass -Wall -Wextra -Wpedantic to g++ if supported (configure)
* Prefix internal durango_get_mem symbol with 'GC_'
* Prevent double inclusion of javaxfc.h and private/specific.h
* Print relevant message in tests not appropriate for leak detection mode
* Reduce scope of local variables in GC_remove_all_threads_but_me
* Refine HIDE_POINTER documentation for the case of the leak-finding mode
* Refine documentation in gc_disclaim.h
* Remove extra USE_MMAP definition for Interix
* Remove redundant header double-inclusion checks in the private headers
* Remove strlen calls with a constant string argument in msvc_dbg
* Specify register_disclaim_proc and finalized_malloc argument as non-null
* Support UWP/arm64 target
* Test marking of finalizer closure object in disclaim_test
* Turn off leak detection mode explicitly in cord/de
* Turn off parallel marker, thread-local allocation if used AO ops emulated
* Turn on gcj functionality in BCC, DMC, NT, OS/2, WCC makefiles
* Turn on memory unmapping in BCC/DMC/NT/WCC makefiles and Makefile.direct
* Update NO_EXECUTE_PERMISSION documentation
* Update documentation about arm64 ABI in gcconfig.h
* Use AO_or in async_set_pht_entry_from_index if available
* Use GC_WORD_MAX macro across all C source files
* Use macro to operate on a flag residing in GC_stop_count
* Use standalone private macro to guard against ptr_t redefinition
* Workaround '#error' cppcheck messages in backgraph and private headers
* Workaround 'AST broken' syntax error reported by cppcheck in GC_mark_some
* Workaround 'GC_dump function is never used' cppcheck warning
* Workaround 'local address assignment to a global variable' CSA warning
* Workaround 'local variable end shadows outer symbol' cppcheck warnings
* Workaround 'local variable obj_displ shadows outer symbol' cppcheck warning
* Workaround 'nonlocal var will use ptr to local var' cppcheck false positive
* Workaround 'pointer addition with NULL pointer' cppcheck error in msvc_dbg
* Workaround 'potential non-terminated string' false positive in cordbscs
* Workaround 'value of _MAX_PATH is unknown' cppcheck warning
* Workaround cppcheck warnings regarding CLOCKS_PER_SEC, REDIRECT_REALLOC


== [8.0.0] 2018-09-05 ==

* Accept Android platform by both CMake and configure
* Access finalize_now atomically to avoid TSan warning without no-sanitize
* Acknowledge thread restart from suspend_handler (NetBSD)
* Add a sanity check that load_acquire and store_release are available
* Add AO primitives implementation to GC based on GCC atomic intrinsic
* Add assertion for suspend_ack_sem in start_world
* Add assertion to allocobj that live unmarked object cannot be reclaimed
* Add assertions about held lock when accessing all_bottom_indices
* Add assertions to ensure ADD_CALL_CHAIN is called holding the lock
* Add assertions to finalize and threads support for MANUAL_VDB needs
* Add basic calculation of the total full-collection time
* Add check that gc_cpp operator delete is called (test_cpp)
* Add debug logging to new_thread about GC_threads hash table collisions
* Add GC prefix to _MSVC_DBG_H macro
* Add initial RISC-V support
* Add Makefile target to run all tests without test-driver
* Add test_atomic_ops to perform minimal testing of used atomic primitives
* Add two-argument alloc_size attribute to calloc_explicitly_typed (GCC)
* Align IRIX/OSF1_THREADS definition in gc_config_macros.h with gcconfig.h
* Allocate non-executable memory by default (CMake)
* Allow compilation of PROC_VDB code on Linux host (GC_NO_SYS_FAULT_H)
* Allow configure --with-libatomic-ops=none to use GCC atomic intrinsics
* Allow custom N_LOCAL_ITERS and ENTRIES_TO_GET values
* Allow disabling of dynamic loading in CMake script and configure
* Allow disabling of main static data registration in CMake and configure
* Allow disabling of threads discovery in CMake script and configure
* Allow gc_assertions enabling in CMake script
* Allow gc_debug, redirect_malloc, large_config options in CMake script
* Allow GC_NETBSD_THREADS_WORKAROUND macro manual definition
* Allow mmap enabling in CMake script and configure
* Allow passing -D DEFAULT_VDB to CFLAGS
* Allow subthreadcreate_test to be compiled with zero NTHREADS
* Allow to turn on spin locking even if thread-local allocations are used
* Always include gc_atomic_ops.h unless threads are disabled
* Avoid 'Unexpected heap growth' in 64-bit multi-threaded gctest if n_tests=1
* Avoid duplication of code handling pthreads case in configure
* Avoid potential data race during apply_to_each_object(reset_back_edge)
* Avoid potential data race during GC_dump execution
* Avoid potential race between malloc_kind and mark_thread_local_fls_for
* Avoid potential race between realloc and clear_hdr_marks/reclaim_generic
* Avoid potential race in print_static_roots called by dyld_image_add/remove
* Avoid potential race in SET_MARK_BIT_EXIT_IF_SET if parallel marking
* Avoid potential race when accessing size_map table
* Avoid potential race when storing oh_back_ptr during parallel marking
* Avoid SIGSEGV during GC_INIT on some Android devices
* Build only shared libraries by default (configure)
* Change pointer arguments of push_all[_eager]/conditional API to void* type
* Change type of hb_sz field (of hblkhdr) from size_t to word
* Check consistency of descr, adjust, clear arguments of GC_new_kind
* Check that GC_WIN32_PTHREADS is not specified for Cygwin
* Check thread_local is initialized before accessing thread_key
* Collapse multiple BCOPY_EXISTS macro definitions
* Collapse multiple NT_*_MAKEFILE scripts into a single NT_MAKEFILE
* Collapse multiple page_was_dirty, remove_protection, read_dirty definitions
* Compile checksums.c only if --enable-checksums is given (configure)
* Consistently define WIN32_LEAN_AND_MEAN/NOSERVICE before include windows.h
* Convert .html files to Markdown format
* Convert code of .c files to valid C++ code
* Decide between memory unmapping and mprotect-based dirty bits at runtime
* Declare t local variable in the block where the variable is used
* Define ABORT() using _CrtDbgBreak (if available) on Windows host
* Define CLANG/GNUC_PREREQ macros to check gcc/clang minimum version
* Define DYNAMIC_LOADING for Darwin unless IGNORE_DYNAMIC_LOADING
* Define GC_ASSERT(x) as C assert(x) for external clients of gc_inline.h
* Define GC_PREFETCH_FOR_WRITE to __builtin_prefetch in gc_inline.h (GCC)
* Define GC_THREADS instead of GC_x_THREADS in Makefiles
* Define macro to specify the environment file name extension (Win32/WinCE)
* Define static resend_lost_signals(), restart_all() in pthread_stop_world
* Detect sigsetjmp() availability by configure
* Determine whether to use compiler TLS for kFreeBSD at compile time
* Do not call BCOPY and BZERO if size is zero
* Do not call sem_getvalue in stop_world if one thread exists
* Do not call set_handle_fork(1) in gctest if pthread_atfork not supported
* Do not compile pcr_interface.c and real_malloc.c except by PCR-Makefile
* Do not declare dl_iterate_phdr as weak for kFreeBSD
* Do not include windows.h when compiling gc_cpp.cc
* Do not install gc_allocator.h, gc_disclaim.h unless the features enabled
* Do not merge dynamic root with the existing static one in add_roots_inner
* Do not print n_rescuing_pages value if incremental collections disabled
* Do not push cpsr and frame pointer on Darwin/arm and Darwin/arm64
* Do not rebuild_root_index unless remove_root_at_pos is called
* Do not specify version info for test libraries (Automake)
* Do not use alternate thread library on Solaris
* Do not use asm in GC_pause
* Do not use PKG_CHECK_MODULES in configure
* Do not use system clock consistently if NO_CLOCK
* Do not use x86 asm in PUSH_CONTENTS_HDR for NaCl
* Document GC_BUILTIN_ATOMIC macro (and gc_atomic_ops private header file)
* Document STACK_NOT_SCANNED macro in gcconfig.h (Emscripten)
* Eliminate 'comparison is always false' code defect in get_maps
* Eliminate 'GC_DEBUG redefined' compiler warning in smashtest
* Eliminate 'potential unsafe sign check of a bitwise operation' code defect
* Enable alternative finalization interface (DISCLAIM) in all makefiles
* Enable compilation for Cygwin with MPROTECT_VDB
* Enable handle-fork and memory unmapping by default
* Enable mprotect-based incremental GC for Win64 (GCC)
* Expose API to control rate and max prior attempts of collect_a_little
* Expose API to control the minimum bytes allocated before a GC occurs
* Fix 'comparison of 255 with expr of type bool' error in gc_atomic_ops.h
* Fix 'doc' files installation folder
* Fix build of cord tests as C++ files (Makefile.direct)
* Fix comment typos in backgraph.c, de.c, gcconfig.h
* Fix delete operator redirection if gc_cpp is built as .dll (Cygwin, MinGW)
* Fix start_world not resuming all threads on Darwin
* Fix test_cpp failure in case GC_DEBUG is defined
* Group common defines for POSIX platforms in configure and CMake scripts
* Guard against USE_PTHREAD_LOCKS and USE_SPIN_LOCK are both defined
* Handle pthread restart signals loss if retry_signals
* Hide value stored to thread-specific entries for a test purpose
* Implement FindTopOfStack(0) for ARM and AArch64 (Darwin)
* Implement memory unmapping for Sony PS/3
* Imply configure --single-obj-compilation if --disable-static
* Include malloc.c in extra/gc.c after include gc_inline.h
* Increase MAX_HEAP_SECTS (10 times) for large-config
* Initial single-threaded support of Interix subsystem
* Initial support of Nintendo, Orbis, Sony PSP2, WinRT, Xbox One
* Initial support of TIZEN platform
* Install gc.3 man page instead of copying gc.man to doc folder (configure)
* Make extend_size_map() static (code refactoring)
* Make subthreadcreate test compilable even without libatomic_ops
* Match GC_FAST_MALLOC_GRANS formal and actual arguments where possible
* Move de_win compiled resource files to cord/tests
* Move pcr_interface.c, real_malloc.c to 'extra' folder
* New API function (GC_dump_named) to produce named dumps
* New API function (GC_is_incremental_mode)
* New API function (get_expl_freed_bytes_since_gc)
* New API function (get_size_map_at) to get element of size_map table
* New API to stop and start the GC world externally
* New API to turn on manual VDB at runtime
* New field (expl_freed_bytes_since_gc) in public prof_stats_s
* New macro ALWAYS_SMALL_CLEAR_STACK to avoid clearing large stack sections
* New public API (PTR_STORE_AND_DIRTY) to simplify store-and-dirty operation
* Pass CFLAGS_FOR_PIC value to CFLAGS in Makefile.direct
* Print time passed since GC initialization in GC_dump
* Public API (GC_deinit) to allow Win32 critical sections deletion
* Reduce probability of collision in threads hashtable for 64-bit targets
* Reduce the default MUNMAP_THRESHOLD value to 2 for Sony PS/3
* Refactoring of USE_MMAP/USE_MMAP_ANON pairs definition in gcconfig.h
* Reformat code and comments in gc_allocator.h
* Remove 'dist' target from Makefile.direct
* Remove a redundant check of __cplusplus in Symbian-specific .cpp files
* Remove Android-specific code in gcconfig.h for M68K
* Remove C++ WeakPointer and CleanUp API which lacks implementation
* Remove DGUX_THREADS macro which duplicates GC_DGUX386_THREADS (configure)
* Remove done_init static variable from fnlz_mlc.c
* Remove duplicate definition of ALIGNMENT macro for OpenBSD/arm
* Remove duplicated sample code in leak.md
* Remove EMX_MAKEFILE (add EMX support to Makefile.direct)
* Remove GC code fragment (which already merged) from README.Mac
* Remove GC_GNU_THREADS macro (HURD)
* Remove GENERAL_MALLOC internal macro
* Remove HIGH_BIT macro duplicating SIGNB
* Remove lint-specific code
* Remove Makefile KandRtest target (that supported K&R C compiler)
* Remove MIN_WORDS macro from gc_priv.h
* Remove multi-line macros (FOR_EACH_PRED, ITERATE_DL_HASHTBL_*, PUSH_OBJ)
* Remove name of optional arguments of operator new and new[] in gc_cpp.h
* Remove notes that K&R C compiler is unsupported
* Remove PUSH_CONTENTS_HDR multi-line macro
* Remove redundant check that clear_fl_marks argument is non-null
* Remove redundant THREADS macro checks in alloc.c and gc_priv.h
* Remove stubborn objects allocation code completely, remove stubborn.c
* Remove unnecessary argument casts in add_roots_inner calls
* Remove unnecessary type casts in n_set_marks
* Remove unused USE_GENERIC macro definition and description
* Remove version info in 'de' cord test application
* Replace GC_MALLOC(sizeof T) with GC_NEW(T) in tests
* Replace GC_NO_RETRY_SIGNALS environment variable with GC_RETRY_SIGNALS=0
* Replace some FIXME items with TODO ones
* Run command passed to if_not_there directly from Makefile.direct
* Same type casts for GC_PTR_STORE arguments regardless of GC_DEBUG
* Skip grungy_pages update when mark state invalid to speedup read_dirty
* Skip typed_test in gctest if NO_TYPED_TEST macro is defined
* Support configure --disable-thread-local-alloc option (similar for CMake)
* Support enable_checksums option in CMake script
* Support Haiku multi-threaded build by CMake
* Support threads for DragonFly in configure
* Turn on 'atomic uncollectable' functionality by default (CMake)
* Turn on GC assertions in NT_MAKEFILE for debug builds
* Turn on gcj, disclaim and java finalization by default (CMake)
* Turn on incremental collection in gctest also if DEFAULT_VDB or MANUAL_VDB
* Turn on incremental mode in cordtest and cord/de
* Turn on incremental mode in disclaim_test, test_cpp and staticroots test
* Turn on parallel marker by default for all multi-threaded builds
* Update GC compilation and usage notes for Win32
* Update shared libraries version info to differentiate against v7.6
* Update top_index entry pointer only when the entry is constructed fully
* Use __builtin_expect in SIZET_SAT_ADD macro
* Use __declspec(allocator) for malloc-like prototypes (MS VS 2015+)
* Use __int64 instead of 'long long' in LONG_MULT if appropriate
* Use __thread keyword for Android NDK r12b+ Clang (arm)
* Use atomic allocation for leafs in reverse_test (gctest)
* Use atomic load/store for the concurrently accessed variables in GC_lock
* Use C11 static_assert if available
* Use compiler atomic intrinsics by default if available (configure)
* Use EXPECT FALSE for mark_from code documented as executed rarely
* Use heap-allocated memory for local mark stack of non-marker thread
* Use HOST_ANDROID define instead of PLATFORM_ANDROID
* Use include gc.h with the angle brackets in the man page synopsis
* Use longjmp in fault_handler_openbsd if siglongjmp unavailable (OpenBSD)
* Use MARK_BIT_PER_GRANULE instead of MARK_BIT_PER_OBJ where appropriate
* Use noexcept specifier in gc_allocator and gc_cpp if C++11
* Use same macro (NTHREADS) across all tests to specify number of threads
* Use sigsetjmp() in setjmp_t tool if available
* Use thread-local allocations for all multi-threaded builds
* Use THREAD_EQUAL consistently to compare pthread_t values
* Workaround 'bad pointer arithmetic' false waring in check_annotated_obj
* Workaround Clang optimizer bug crashing clear_stack_inner on OS X 10.8
* Workaround Thread Sanitizer (TSan) false positive warnings


== [7.6.26] 2026-02-04 ==

* Eliminate 'argument unused' gcc warning in push_all_stack_partially_eager
* Fix GC_NO_THREADS_DISCOVERY macro check before definition
* Fix redirected 'free' for callers from libdl/libpthread if IGNORE_FREE

Also, includes 7.4.32 changes


== [7.6.24] 2025-10-17 ==

* Eliminate 'int-to-ptr cast' gcc warning in GC_restart_all on OpenBSD
* Eliminate 'int-to-ptr cast' gcc warnings in DEBUG_THREADS code
* Fix 'missing GNU-stack section in atomic_ops_sysdeps' ld warning
* Fix pthread id stored in GC_threads of child process
* Fix pthread_sigmask result checking in GC_start_mark_threads_inner
* Remove always-false check if C++ allocator.allocate returns null in test
* Update libatomic_ops repo URL in README after repo transfer

Also, includes 7.4.30 changes


== [7.6.22] 2024-09-07 ==

* Eliminate 'cast signed to bigger unsigned' CSA warnings in GC_find_limit
* Fix GC_debug_realloc to support custom kind
* Fix heap blocks size computation by GC_get_memory_use
* Fix pointer relational comparison in GC_do_enumerate_reachable_objects
* Prevent GC_noop_sink from scanning by the collector

Also, includes 7.4.28 changes


== [7.6.20] 2024-02-03 ==

* Eliminate compiler warning of missing cast in LONG_MULT after shift
* Fix 'sigset_t undeclared' MS VC error if pthreads-w32 is used
* Fix lock assertion violation in GC_try_to_collect_inner on OS X
* Fix missing outermost parentheses in macro definitions in huge test
* Fix undefined GC_real_pthread_sigmask if redirect malloc on OS X

Also, includes 7.4.26 changes


== [7.6.18] 2023-05-26 ==

* Fix IRIX5 defined wrongly on FreeBSD/mips
* Fix alt-stack handling in GC_push_all_stacks if stack grows up
* Fix data race in GC_heapsize_at_forced_unmap variable

Also, includes 7.4.24 changes


== [7.6.16] 2022-08-26 ==

* Do not send signal to thread which is suspended manually
* Eliminate 'old_gc_no is initialized but not referenced' MS VC false warning
* Fix 'GC_greatest_stack_base_below is defined but not used' warning (IA64)
* Fix context saving when GC_suspend_thread(self)
* Fix data race in fail_proc1 of gctest
* Fix GC_suspend_thread if called before thread destructor
* Fix hang on sem_wait in GC_suspend_thread if thread was resumed recently
* Fix lock assertion violation in GC_find_limit if always multi-threaded
* Fix potential race if start_mark_threads called from threads in child
* Make finalizer_closure pointer read/write atomic in malloc and callback
* Prevent changing of GC_markers_m1 value while collection in progress
* Replace SSH cloning with HTTPS one in README
* Workaround Thread Sanitizer (TSan) FP warning in is_valid_displacement

Also, includes 7.4.22 changes


== [7.6.14] 2021-09-28 ==

* Add loop to handle abort error like in suspend logic on Darwin
* Add support of OpenBSD/aarch64
* Add threading libraries to bdw-gc.pc
* Disable mprotect-based incremental GC if /proc roots are used (Linux)
* Do not use iOS private symbols
* Eliminate 'GC_old_bus_handler defined but not used' compiler warning
* Eliminate 'comparing signed and unsigned values' BCC warning in cordtest
* Eliminate 'possible loss of data' BCC and MS VC warnings
* Eliminate 'static GC_sysinfo definition has incomplete type' Clang warning
* Eliminate 'unused function GC_add_map_entry' compiler warning
* Eliminate 'while clause does not guard' GCC warning in GC_parse_map_entry
* Explicitly zero-initialize trace_buf (fix trace_buf initialization)
* Fix 'ACCESS_VIOLATION in marker' GC warning on Win32 async thread start
* Fix 'GC_generic_malloc must be available' GCC error in new_gc_alloc.h
* Fix 'ulong undefined' compilation error on AIX
* Fix 'undefined reference to __data_start' linker error on RISC-V
* Fix 'write to GC log failed' error
* Fix GC_proc_fd value in child process at fork (Solaris)
* Fix MPROTECT_VDB definition for single-threaded GC builds
* Fix OS_TYPE and USE_MMAP_ANON definitions for Cygwin/x64
* Fix STACKBOTTOM on 32-bit HP/UX 11.11
* Fix abort in GC_printf when gctest is built as WinMain executable (Cygwin)
* Fix assertion violation in register_dynlib_callback on Android
* Fix compiling by Makefile.direct on OpenBSD/UltraSparc
* Fix configure message about 'AIX gcc optimization fix'
* Fix cordtest build in SMakefile.amiga
* Fix data race regarding *rlh value in generic_malloc_many
* Fix first_thread stack_base initialization if custom GC_stackbottom (Win32)
* Fix gc_allocator.h compilation by Clang
* Fix gc_cflags variable name in configure (HP/UX)
* Fix handling of areas smaller than page size in GC_scratch_recycle
* Fix incorrect define GC_OPENBSD_THREADS on sparc64
* Fix misaligned tlfs passed to AO_load on m68k
* Fix missing GC_quiet declaration in pcr_interface.c
* Fix missing gc_dlopen.c in CMake script
* Fix missing scratch_last_end_ptr update (Irix)
* Fix overflow of scratch_free_ptr value
* Fix page_was_[ever_]dirty() for static roots (Solaris)
* Fix printf format specifier in simple_example.html
* Fix save_callers for multi-threaded case if built-in backtrace unavailable
* Fix test_cpp failure caused by arbitrary link order (Win32)
* Fix test_cpp failure when gc_cpp resides in a dll (Borland, Watcom)
* Fix various typos mostly in documentation files
* Fix word size, data start and alignment for OpenBSD/mips64(el)
* Prevent GetThreadContext failure (Windows)
* Prevent WARN of incompatible incremental GC if default or manual VDB
* Reduce a time period between GetExitCodeThread and SuspendThread (Win32)
* Refactoring of WoW64 workaround (Win32)
* Remove a misleading comment about Solaris in gc.h
* Workaround 'expression is only useful for its side effects' WCC warning
* Workaround fread fail after enable_incremental if malloc redirected (Linux)


== [7.6.12] 2019-03-01 ==

* Eliminate 'assigned value never used' compiler warning in test_cpp WinMain
* Fix 'mprotect remapping failed' abort on NetBSD with PaX enabled
* Fix 'undefined reference to __data_start' linker error (Android/aarch64)
* Fix 'unexpected mark stack overflow' abort in push_all_stack
* Fix 'wrong __data_start/_end pair' error on Android
* Fix BSD_TIME variant of MS_TIME_DIFF for the case of a.tv_usec < b.tv_usec
* Fix GetThreadContext stale register values use if WoW64 (Win32)
* Fix executable memory allocation in GC_unix_get_mem
* Fix invalid initializer of CLOCK_TYPE variables if BSD_TIME
* Fix thread_info() count argument value (OS X)
* Update NO_EXECUTE_PERMISSION documentation


== [7.6.10] 2018-12-13 ==

* Add paths to filenames mentioned in the copyright section in README
* Call real pthread_sigmask instead of its wrapper in start_mark_threads
* Eliminate 'casting signed to bigger unsigned int' CSA warning
* Eliminate 'non-virtual destructor for class with inheritors' CSA warning
* Fix 'collecting from unknown thread' abort in leak-finding mode for Win32
* Fix 'too wide non-owner permissions are set for resource' code defect
* Fix 'undefined reference to GC_incremental' linker error in pthread_start
* Fix GC_VSNPRINTF in cordprnt for DJGPP and MS VC for WinCE
* Fix GC_register_disclaim_proc for leak-finding mode
* Fix a deadlock in write_fault_handler if AO_or is emulated
* Fix comment typos in CMakeLists.txt, backgraph.c, de.c, gcconfig.h
* Fix concurrent bitmap update in GC_dirty
* Fix delete operator redirection if gc_cpp is built as .dll (Cygwin, MinGW)
* Fix hbp overflow in GC_install_counts
* Fix linkage with a system libatomic_ops shared library
* Fix lock assertion violation in get_index if GC_ALWAYS_MULTITHREADED
* Fix marking of finalizer closure object
* Fix marks and hb_n_marks consistency when disclaim returns true
* Fix memory allocation on GCF (Linux/x64)
* Fix missing curses.h in cord/de when compiling manually (MS VC, MinGW)
* Fix start_world not resuming all threads on Darwin
* Fix test_cpp assertion violation in find-leak mode
* Fix tests linkage with internal atomic_ops.o
* Fix unneeded end_stubborn_change in disclaim_test
* Guard against potential buffer overflow in CORD_next and CORD_pos_fetch
* New macro to suppress printing of leaked objects
* Prevent double inclusion of javaxfc.h and private/specific.h
* Reduce scope of local variables in GC_remove_all_threads_but_me
* Refine HIDE_POINTER documentation for the case of the leak-finding mode
* Refine documentation in gc_disclaim.h
* Test marking of finalizer closure object in disclaim_test
* Update documentation about arm64 ABI in gcconfig.h
* Use AO_or in async_set_pht_entry_from_index if available
* Use include gc.h with the angle brackets in the man page synopsis


== [7.6.8] 2018-08-12 ==

* Add cpu, make_as_lib, nothreads options to NT_MAKEFILE
* Add NetBSD/aarch64 and initial RISC-V support
* Adjust formatting of configure help messages and config.h comments
* Avoid multiple 'getcontext failed' warnings if getcontext is broken
* Cleanup BCC Makefile (remove absolute GC paths, fix del cmd, update clean)
* Collapse multiple NT_*_MAKEFILE scripts into a single NT_MAKEFILE
* Do not call GC_dirty_inner unless GC_incremental
* Do not use NULL in gc_inline.h
* Eliminate 'cast between incompatible function types' compiler warning
* Eliminate 'comparing signed and unsigned values' compiler warnings (bcc)
* Eliminate 'condition is always true' cppcheck warning in init_gcj_malloc
* Eliminate 'declaration of var hides global declaration' compiler warning
* Eliminate 'language extension used' Clang warning in gc.h
* Eliminate 'possibly incorrect assignment in CORD_vsprintf' compiler warning
* Eliminate 'ptr arithmetic with NULL' cppcheck warning in alloc_mark_stack
* Eliminate 'scope of var can be reduced' cppcheck warning in pthread_join
* Eliminate 'switch statement contains no case label' compiler warning
* Eliminate 'variable might be uninitialized' warning in win32_start_inner
* Eliminate duplicate clear_mark_bit call when removing disappearing link
* Fast fail on invalid CPU parameter passed to NT_MAKEFILE
* Fix 'collecting from unknown thread' abort in leak-finding mode
* Fix 'pointer arithmetic with NULL' code defect in print_callers
* Fix Borland version in documentation to match that in BCC_MAKEFILE
* Fix comment about inv_sz computation in setup_header
* Fix comments style in configure.ac and Makefile.am
* Fix compilation by digimars.mak (DMC)
* Fix compilation by WCC makefile
* Fix compilation of darwin_stop_world for iOS 8+
* Fix cords for MANUAL_VDB
* Fix dependency on gc_cpp source in BCC_MAKEFILE and NT_MAKEFILE
* Fix GC_is_valid_displacement and GC_is_visible for non-small objects
* Fix gctest in leak-finding mode
* Fix infinite restarting of mark_some when a static root disappeared (Linux)
* Fix large object base computation in PUSH_CONTENTS() if MARK_BIT_PER_OBJ
* Fix mark stack overflow checking in push_selected
* Fix missing GC_dirty calls for GC-allocated objects used internally
* Fix missing GC_dirty invocation from debug_end_stubborn_change
* Fix MSWIN32 macro redefinition (WCC)
* Fix multi-threaded gctest for the case of NTHREADS is set to zero
* Fix new and delete operators definition for DigitalMars compiler
* Fix NT_MAKEFILE for VS 2017
* Fix potential null dereference in GC_CONS
* Fix register_dynamic_libraries on Windows 10
* Fix result computation in n_set_marks
* Fix return type in GC_set_warn_proc API documentation
* Fix tests for GC compiled with MANUAL_VDB
* Fix the build for Emscripten
* Fix typo in comment for CORD_ec_flush_buf prototype
* Fix typos in ChangeLog and generic_malloc
* Fix UNTESTED for multi-threaded API functions in gctest
* Fix VirtualQuery call in case of malloc failure (Win32)
* Install gc.3 man page instead of copying gc.man to doc folder (configure)
* Keep pointer to the start of previous entry in remove_specific_after_fork
* Move de_win compiled resource files to cord/tests
* Never return null by C++ GC allocators and gc_cpp operator new
* Perform thread_suspend in loop as it may be interrupted (Darwin)
* Really abort if failed to read /proc for library registration (Linux)
* Remove code duplication in gcj_malloc and malloc_explicitly_typed
* Remove duplicate local variable in reclaim_block
* Remove information how to send bugs from README.cords file
* Remove libatomic_ops license information
* Remove unused USE_GENERIC macro definition and description
* Suppress 'functions containing switch are not expanded inline' bcc warning
* Suppress 'non-member operator new/delete may not be inline' VC++ warning
* Turn on incremental collection in gctest also if MANUAL_VDB
* Update copyright information in alloc.c, gc.c/h and the documentation
* Update EXTRA_DIST in Makefile, Win32/64 docs after NT_*_MAKEFILE removal
* Update NT_MAKEFILE usage information in README files for Win32 and Win64
* Workaround 'class C does not have a copy constructor' cppcheck warning
* Workaround 'function nested_sp is never used' cppcheck style warning
* Workaround 'opposite expression on both sides of &' cppcheck style warning
* Workaround 'template-id not supported in this context' compiler error (WCC)


== [7.6.6] 2018-04-20 ==

* Define GC_FREEBSD_THREADS and GC_ADD_CALLER macros for kFreeBSD
* Eliminate 'boolean result used in bitwise operation' cppcheck warning
* Eliminate 'there is pointer arithmetic with NULL' cppcheck warning
* Explicitly unblock GC signals on GC initialization
* Fix 'scope of var can be reduced' cppcheck err in enqueue_all_finalizers
* Fix 'undefined reference to __builtin_unwind_init' linker error (ArmCC)
* Fix arguments delimiter in pcr_interface.c (PCR)
* Fix assertion violation in DllMain of win32_threads
* Fix comment for debug_generic_malloc_inner[_ignore_off_page]
* Fix data race during apply_to_each_object(reset_back_edge)
* Fix dbg_mlc.c/o file name in documentation
* Fix gctest with musl libc on s390x
* Fix include gc_gcj.h in thread_local_alloc.c
* Fix man section number (3)
* Fix missing GC_generic_malloc_words_small implementation in new_gc_alloc.h
* Fix missing new-line in ABORT_ARG<n> definition
* Fix missing SIGBUS handler setup for kFreeBSD
* Fix null dereference in print_callers on backtrace_symbols failure
* Fix null pointer dereference in get_private_path_and_zero_file (Symbian)
* Fix the collector hang when it is configured with --enable-gc-debug
* Fix thread_suspend fail for threads registered from key destructor (OS X)
* Fix type of local variables receiving result of PHT_HASH
* Fix typo in AIX macro name
* Fix typo in comment in specific.h
* Fix unbounded heap growth in case of intensive disappearing links usage
* Remove API symbols renaming in WCC_MAKEFILE
* Support Haiku/x64 and Haiku/x86 hosts
* Support threads for DragonFly in configure
* Workaround 'address of auto-variable returned' cppcheck error
* Workaround gctest hang on kFreeBSD (if thread-local allocations are on)


== [7.6.4] 2018-01-26 ==

* Add note of set_free_space_divisor, set_warn_proc ABI change after gc-7.1
* Change compiler invocation example in gc.man to use dynamic libgc
* Delete dont_ar_* build intermediate files on make clean (Makefile.direct)
* Do not declare dl_iterate_phdr as weak for DragonFly
* Fix 'cords' parallel build in Makefile.direct
* Fix 'undeclared identifier USRSTACK' compiler error on OpenBSD-6.2
* Fix error code in abort message if sem_wait failed in start_world (NetBSD)
* Fix GC allocation mutex in child after a fork
* Fix global operator delete definition for C++14 in gc_cpp
* Fix last_reclaimed..gc_no interval comparison to threshold in unmap_old
* Fix libgc version which was changed in linkage breaking way
* Fix missing EOLn output in threadlibs tool
* Fix threadlibs tool to output '-lpthread' for DragonFly
* Prevent DATASTART redefinition for NaCl
* Remove obsolete advice about linking with _DYNAMIC=0 (Linux)


== [7.6.2] 2017-12-23 ==

* Add assertion that no hb_n_marks underflow occurs
* Add minimal testing of GC_MALLOC_[ATOMIC_]WORDS and GC_CONS (gctest)
* Add minimal testing of GC_set_bit (gctest)
* Add more cases to huge_test to cover sizes close to word-type maximum
* Add testing of new[]/delete[] (test_cpp)
* Adjust AO_HAVE_x check to match AO_fetch_and_add primitive variant used
* Adjust code indentation of calloc_explicitly_typed
* Align local_mark_stack in help_marker explicitly
* Allow custom TRACE_ENTRIES value
* Allow gctest and thread_leak_test with zero NTHREADS
* Avoid data race in finalized_count (gctest)
* Code refactoring of divide-by-HBLKSIZE occurrences
* Code refactoring of huge_test
* Code refactoring of tests/subthread_create regarding AO add primitive
* Compile thread_local_alloc only if multi-threaded build (Makefile.am)
* Delete preprocessor output on make clean (Makefile.direct)
* Disable implicit multi-threaded mode for Win32 to avoid LOCK crash
* Do not disable parallel mark for WRAP_MARK_SOME
* Do not enable mprotect-based incremental mode if unmapping is on (gctest)
* Do not install documentation if configure --disable-docs (new option)
* Do not use tkill (Android)
* Document base and size of objects allocated by finalized_malloc
* Document configure 'syntax error' issue in README
* Eliminate 'address of local variable returned' static analyzer warning
* Eliminate 'array vs singleton' code defect in typed_test (gctest)
* Eliminate 'assigned value never used' CSA warning in min_bytes_allocd
* Eliminate 'boolean result used in bitwise op' cppcheck false warning
* Eliminate 'C-style pointer casting' cppcheck style warnings in test
* Eliminate 'checking if unsigned variable is <0' cppcheck style warning
* Eliminate 'class member var with name also defined in parent' warning
* Eliminate 'comparison is always false' static analyzer warning in finalize
* Eliminate 'Condition 0==datastart always false' cppcheck warning (dyn_load)
* Eliminate 'condition is always true' cppcheck style warning
* Eliminate 'constructor with 1 argument is not explicit' cppcheck warning
* Eliminate 'CORD_*printf is never used' cppcheck style warnings (cordtest)
* Eliminate 'dereference of null' CSA false warning in array_mark_proc
* Eliminate 'function result not used' code defect in GC_mark_local
* Eliminate 'GC_collecting is set but never used' code defect (Win32)
* Eliminate 'GC_record_fault is never used' cppcheck style warning
* Eliminate 'integer shift by a negative amount' code defect in finalize
* Eliminate 'label not used' cppcheck false warnings in GC_mark_X
* Eliminate 'memory leak' code defect for scratch-allocated memory
* Eliminate 'memory leak' code defect in remove_specific
* Eliminate 'non-null arg compared to null' warning in toggleref_add (GCC)
* Eliminate 'non-reentrant function strtok called' cppcheck warning (POSIX)
* Eliminate 'possible integer underflow' code defect (cord-de)
* Eliminate 'potential overflow' static analyzer warning in test
* Eliminate 'printf format specifies type void*' GCC pedantic warnings
* Eliminate 'scope of variable can be reduced' cppcheck warnings
* Eliminate 'suspicious pointer subtraction' cppcheck warning (gc_cpp)
* Eliminate 'this statement may fall through' GCC warnings
* Eliminate 'unnecessary comparison of static strings' cppcheck warning
* Eliminate 'unsafe vsprintf is deprecated' compiler warning
* Eliminate 'unused formal parameter' compiler warnings in C++ code (MS VC)
* Eliminate 'unused variable' compiler warning in remove_all_threads_but_me
* Eliminate 'use of vulnerable sprintf' code defect in de_win test (cord)
* Eliminate 'value exceeds maximum object size' GCC warning in huge_test
* Eliminate 'value of CLOCK_TYPE unknown' cppcheck info message
* Eliminate 'value of DATASTART2 unknown' cppcheck info messages
* Eliminate 'value of GC_PTHREAD_EXIT_ATTRIBUTE unknown' cppcheck messages
* Eliminate 'value of GC_RETURN_ADDR_PARENT unknown' cppcheck info messages
* Eliminate 'value of NEED_FIXUP_POINTER unknown' cppcheck info messages
* Eliminate 'write to memory that was const-qualified' code analyzer warning
* Eliminate all 'scope of variable can be reduced' cppcheck style warnings
* Eliminate CSA warning about incorrect cast applied to HBLK_OBJS
* Eliminate CSA warning about narrowing cast in CleanUp of test_cpp
* Eliminate CSA warning of non-virtual destructor in test_cpp base class
* Eliminate CSA warning of staticroot that can be a local variable (tests)
* Eliminate CSA warning of unmodified non-const static var (disclaim_test)
* Eliminate redundant local variable in register_finalizer
* Eliminate TSan (Thread Sanitizer) warnings in gctest
* Eliminate UBSan warning of overflow during descr subtraction in mark_from
* Eliminate unreachable PROC/DEFAULT_VDB GC_printf calls in gctest main()
* Eliminate unsigned fl_builder_count underflow in mark_thread
* Enable GC_is_tmp_root for all platforms
* Execute more single-threaded GC tests by CMake
* Expand tabs to spaces in de_win.rc (tests)
* Export GC_dump_finalization/regions()
* Export GC_is_tmp_root() and GC_print_trace[_inner]()
* Export GC_print_free_list()
* Fix '32-bit value shift followed by expansion to 64-bit' code defect
* Fix 'GC_written_pages never read' code defect (GWW_VDB)
* Fix 'label cannot be reached' static analyzer warning in disclaim_test
* Fix 'size of tv is unknown' error in brief_async_signal_safe_sleep (musl)
* Fix 'syntax error' reported by cppcheck for mach_dep
* Fix 'unknown type name GC_INNER' compilation error (FreeBSD)
* Fix 'variable assigned a value that is never used' cppcheck style warnings
* Fix 'void pointers in calculations: behavior undefined' cppcheck warning
* Fix assertion violation about disabled cancel in try_to_collect_inner
* Fix atomic_ops build in Makefile.direct for Solaris
* Fix Clang static analyzer warning about not found gc_priv.h in extra files
* Fix compilation error in get_main_stack_base (Emscripten)
* Fix compilation for winpthreads if HANDLE_FORK
* Fix compilation if configured with --enable-werror on OS X
* Fix cord/de build in Makefile.direct (Linux)
* Fix data race in a list referenced by A.aa (gctest)
* Fix data race in collectable_count (gctest)
* Fix data race in do_local_mark when comparing active_count to helper_count
* Fix data race in GC_suspend/resume_thread
* Fix data race in last_stop_count access (suspend_handler_inner)
* Fix data race in make_descriptor when setting explicit_typing_initialized
* Fix data race in mark_thread when updating mark_no
* Fix data race when getting object size in explicitly-typed allocators
* Fix deadlock in GC_suspend_thread
* Fix gctest failure for Darwin if CPPCHECK is defined
* Fix lack of barriers to synchronize memory for suspend_handler
* Fix marking of disclaim-reachable objects in the incremental mode
* Fix message of VDB implementation used if MPROTECT_VDB+GWW_VDB (gctest)
* Fix missing started_thread_while_stopped call from mark_some if GCC/Clang
* Fix null dereference in GC_stack_range_for if not DARWIN_DONT_PARSE_STACK
* Fix page calculation in checksums
* Fix parallel build in Makefile.direct
* Fix test_cpp and c++ parallel build in Makefile.direct
* Fix typo in comment of GC_mark_some
* Fix typos in cdescr.html and README.sgi
* Make GC_INIT optional for clients even if thread-local allocations enabled
* Match uclinux pattern in configure
* Move conditional GC_need_to_lock setting to gc_locks.h (refactoring)
* Move README.QUICK from DOC_FILES to OTHER_FILES in Makefile.direct
* New API function (GC_is_init_called) to check if BDWGC is initialized
* New target (check-cpp) in Makefile.direct
* Prevent abort in register_data_segments for Symbian and Emscripten
* Prevent multiple 'Caught ACCESS_VIOLATION in marker' per collection
* Print realloc_count value in gctest
* Put invariant name in quotes to make mark_state comments clearer
* Refine configure messages when checking for compiler option support
* Remove extraneous semicolons after AC_MSG_WARN (configure)
* Remove page_was_dirty and remove_protection duplicate definitions
* Remove unnecessary type casts of printf arguments to unsigned long
* Remove unused ALIGN_DOUBLE, USE_GENERIC_PUSH_REGS macros (TILE-Gx/Pro)
* Rename 'test' to 'check' target in Makefile.direct
* Replace deprecated rewind to fseek in cordxtra
* Report gcc/clang pedantic warnings (configure)
* Skip thread suspend/resume API testing for Tru64 (OSF1)
* Support AddressSanitizer (Clang/GCC) and MemorySanitizer (Clang)
* Support GC_init (and get_stack_base) from non-main thread on FreeBSD/NetBSD
* Suppress 'tainted string passed to vulnerable operation' false defects
* Suppress 'taking address of label non-standard' GCC/Clang pedantic warning
* Test GC initialization from non-main thread on FreeBSD and NetBSD
* Test GCJ object creation with length-based descriptor (gctest)
* Update comment in finalized_disclaim to match FINALIZER_CLOSURE_FLAG
* Update README regarding make cords with Makefile.direct
* Update README to use autogen.sh on build from the source repository
* Update shared libraries version info to differentiate against v7.4
* Use mprotect instead of mmap in GC_unmap() on Cygwin
* Use same style of include gc.h in documentation
* Workaround '!GC_page_size is always false' cppcheck style warning
* Workaround '#error' cppcheck error messages
* Workaround '32-bit value shift by >31 bits is undefined' cppcheck warnings
* Workaround 'array compared to 0', 'untrusted loop bound' false defects
* Workaround 'bad address arithmetic' static analysis tool false positive
* Workaround 'checking if unsigned value is negative' cppcheck warning
* Workaround 'checking unsigned value is negative' code defect in mark_from
* Workaround 'comparison of identical expressions' false code defects
* Workaround 'Condition 0!=GETENV() is always false' cppcheck style warnings
* Workaround 'condition is always false' cppcheck warning in get_next_stack
* Workaround 'condition is always true' cppcheck style warnings in GC_init
* Workaround 'function is never used' cppcheck style warnings
* Workaround 'insecure libc pseudo-random number generator used' code defect
* Workaround 'int shift by negative amount' false code defect in finalize
* Workaround 'local variable size too big' static analyzer warning
* Workaround 'memory leak: result' cppcheck false error (POSIX)
* Workaround 'null pointer dereference' false positive in push_next_marked
* Workaround 'obsolescent bcopy, bzero called' cppcheck warnings (POSIX)
* Workaround 'obsolescent usleep called' cppcheck warning (POSIX)
* Workaround 'obsolete function alloca() called' cppcheck warnings
* Workaround 'passing untyped NULL to variadic function' cppcheck warning
* Workaround 'pointer used before comparison to null' code defect (pthread)
* Workaround 'possible null pointer dereference' cppcheck warnings
* Workaround 'potential multiplication overflow' code defect in de_win (cord)
* Workaround 'redundant assignment of *result to itself' cppcheck warning
* Workaround 'resource leak' false positives in alloc_MS, bl/envfile_init
* Workaround 'same expression on both sides of ==' cppcheck style warning
* Workaround 'same expression on both sides of OR' cppcheck style warning
* Workaround 'struct member is never used' cppcheck style warnings
* Workaround 'tainted int used as loop bound' static analysis tool warning
* Workaround 'Uninitialized variable' cppcheck errors
* Workaround 'unused variable' cppcheck style warnings
* Workaround 'va_list used before va_start' cppcheck error in cord
* Workaround 'value of macro unknown' cppcheck info messages
* Workaround 'value of REDIRECT_MALLOC/FREE unknown' cppcheck info messages
* Workaround 'value of SIGBUS unknown' cppcheck info messages
* Workaround 'value of WINAPI unknown' cppcheck info messages
* Workaround 'variable hides enumerator with same name' cppcheck warnings
* Workaround 'variable reassigned before old value used' cppcheck warnings
* Workaround 'waiting while holding lock' code defect in stop_world (Unix)
* Workaround false 'uninitialized var use' code defect (initsecondarythread)

Also, includes 7.4.6 changes


== [7.6.0] 2016-08-02 ==

* ABORT_ARGn log details at INFO level (Android)
* Add 'pragma message' to gc.h to detect inconsistent WIN64/_WIN64 (MS VC)
* Add API function to calculate total memory in use by all GC blocks
* Add API function to set/modify GC log file descriptor (Unix)
* Add alloc_size attribute to GC_generic_malloc
* Add alt-stack registration support
* Add assertion for GC_new_kind boolean arguments
* Add assertion on lock status to GC_alloc_large and its callers
* Add build scripts for VC 9 (Win32/64)
* Add build system plumbing for building with -Werror
* Add incremental GC support for Darwin/arm64
* Add profiling callback events to indicate start/end of reclaim phase
* Add support for enumerating the reachable objects in the heap
* Add toggle-ref support (following Mono GC API)
* Added instructions to README.md for building from git
* Adjust code indentation of malloc/calloc/str[n]dup
* Allow fork() automatic handling on Android with API level 21+
* Allow specific TLS attributes for GC_thread_key
* Allow thread local allocations from within pthread TLS destructors
* Allow to force GC_dump_regularly set on at compilation
* Altera NIOS2 support
* Change 'cord' no-argument functions declaration style to ANSI C
* Check DATASTART is less than DATAEND even assertions off
* Check for execinfo.h by configure
* Code refactoring of GC_push_finalizer/thread/typed_structures
* Code refactoring regarding 'data start' definition for FreeBSD
* Consistently set type of DATASTART/END to ptr_t (code refactoring)
* Consistently use int[] type for '_end' symbol (code refactoring)
* Consistently use outermost parentheses for DATASTART/END, STACKBOTTOM
* Define GC_LINUX_THREADS, NO_EXECUTE_PERMISSION in configure for NaCl
* Define ROUNDUP_PAGESIZE, ROUNDUP_GRANULE_SIZE macros (code refactoring)
* Define public GC_GENERIC_OR_SPECIAL_MALLOC and GC_get_kind_and_size
* Do no declare kernel_id field of GC_Thread_Rep for 64-bit Android
* Do not allow SHORT_DBG_HDRS if KEEP_BACK_PTRS or MAKE_BACK_GRAPH
* Do not warn of missing PT_GNU_RELRO segment when custom DSO filter used
* Document GC_register_my_thread returned value
* Dump the block information in CSV format
* Eliminate redundant *flh check for null in GC_allocobj
* Enable atomic-uncollectable in operator new in gc_cpp.h
* Enable build with musl libc
* Enable gc.h inclusion by client without implicit include windows.h (Win32)
* Enable huge_test for Win64 (and LLP64 target)
* Enable thread-local storage for Android Clang
* Enable thread-local storage usage for GC_malloc/calloc_explicitly_typed
* Export GC_push_all_eager, GC_push_finalizer_structures
* Fix 'arg parameter might be clobbered by setjmp' compiler warning
* Fix assertion in GC_mark_from for non-heap regions
* Fix compilation for Android clang/arm with bfd linker
* Fix integer shift undefined behavior in GC_init_explicit_typing
* Fix missing new-line and redundant trailing dot in WARN messages
* Fix STACKBOTTOM for Solaris 11/x86
* Fix tag collision between ENABLE_DISCLAIM and KEEP_BACK_PTRS
* Fix unchecked fork() result in gctest (Unix, Cygwin)
* Fix user-defined signals drop by marker threads
* Fix various typos in comments and documentation
* FreeBSD/arm support improvement
* GC_make_descriptor code refactoring (eliminate two local variables)
* GC_malloc[_atomic] global and thread-local generalization with kind
* GC_malloc_[atomic_]uncollectable generalization
* GC_scratch_alloc code refactoring (and WARN message improvement)
* Group all compact fields of GC_arrays to fit in single page
* Handle load_segs overflow in register_dynlib_callback gracefully
* Harmonize OSX/iOS configuration; enable compiling for iPhone simulator
* Implement event callbacks for profiling (following Mono GC API)
* Implement the finalization extension API
* Implement thread suspend/resume API (Linux threads only)
* Improve documentation for disappearing links in gc.h
* Make heap growth more conservative after GC_gcollect_and_unmap call
* Mark fo_head, finalize_now with a single GC_push_all call (refactoring)
* Move MessageBox invocation code from GC_abort to a separate routine (Win32)
* NaCl/arm initial support; NaCl runtime fixes for other CPUs
* New macro (GC_ALWAYS_MULTITHREADED) to set multi-threaded mode implicitly
* New macro (NO_WINMAIN_ENTRY) to prefer main() instead of WinMain in test
* New macro (REDIRECT_MALLOC_IN_HEADER) to enable source-level redirection
* Process all PT_LOAD segments before PT_GNU_RELRO segments (Glibc)
* Re-implement GC_finalized_malloc using GC_malloc_kind
* Refactoring of android_thread_kill/pthread_kill calls
* Refactoring of GC_Xobjfreelist (use single array to keep free lists)
* Refactoring of thread-local *_freelists (use single array of free lists)
* Refine description in README how to build from source repository
* Refine GC_free_space_divisor comment regarding its initial value
* Reformat code of gc_cpp.cc/h
* Remove 'opp' local variable in GC_malloc_X
* Remove 'sig' argument of GC_suspend_handler_inner (code refactoring)
* Remove code commented out by 'ifdef UNDEFINED'
* Remove hb_large_block field (use 1 extra bit of hb_flags instead)
* Remove obsolete BACKING_STORE_ALIGNMENT/DISPLACEMENT macros for Linux/IA64
* Remove redundant casts in GC_generic_or_special_malloc and similar
* Remove unsupported FreeBSD/ia64 case from gcconfig.h file
* Remove unused GC_gcjdebugobjfreelist
* Rename ATOMIC_UNCOLLECTABLE to GC_ATOMIC_UNCOLLECTABLE
* Replace non-API occurrences of GC_word to word (code refactoring)
* Return GC_UNIMPLEMENTED instead of abort in GC_get_stack_base (OS/2)
* Show WoW64 warning message if running 32-bit on Win64 (enabled by macro)
* Standalone profiling callback for threads suspend/resume
* Support (add machine description for) TILE-Gx and TILEPro targets
* Support build for Android 64-bit (arm64, mips64, x64)
* Support FreeBSD/aarch64, FreeBSD/mips
* Support iOS7 64-bit (AArch64) and iOS8+ 32/64-bit (Darwin)
* Support MinGW build in scripts
* Turn off sigsetjmp workaround for Android/x86 starting from NDK r8e
* Use magic header on objects to improve disclaim_test
* Workaround 'sa_sigaction member missing' compiler error (Android/x32)
* Workaround 'unresolved __tls_get_addr' error for Android NDK Clang
* Workaround a bug in winpthreads causing parallel marks deadlock (MinGW)

Also, includes 7.4.4 changes


== [7.4.32] 2026-02-04 ==

* Eliminate 'cast between incompatible func types' warnings for FARPROC vars
* Eliminate 'format expects argument of type' gcc warnings in dump_meminfo
* Eliminate 'GC_remove_roots_subregion not used' gcc warning on Solaris
* Eliminate 'unused parameter' clang warnings in GC_darwin_sigbus
* Eliminate 'unused variable i' gcc warning in GC_start_world (Windows)
* Fix 'KERN_PROTECTION_FAILURE while world is stopped' error on MacOS X
* Fix 'reserved' argument handling in GC_DllMain
* Fix 'undefined errno' compiler error in strdup/strndup on WinCE
* Fix a cycle in NORMAL freelist if malloc is redirected on Linux
* Fix assertion in GC_wait_for_reclaim if DllMain-based thread registration
* Fix missing new-line in help message of console variant of cord/de
* Fix race in DllMain by deferring delete_thread call to GC_start_world
* Fix SIGSEGV if pthread_detach is called before collector initialization
* Fix typos (about getcontext) in printed message in setjmp_test
* Fix various typos in comments and documentation
* Prevent collection if fork from an unregistered thread
* Refine USE_PROC_FOR_LIBRARIES macro documentation for Solaris
* Remove unused GC_VERSION in configure
* Remove unused redefinition of GC_free in gctest
* Revert 'Avoid abort on ResumeThread failure if Win32 DllMain closes thread'
* Revert 'Fix GC_suspend abort when the thread is deleted by DllMain'


== [7.4.30] 2025-10-17 ==

* Add missing test_cpp dependency on gc_allocator.h in build scripts
* Allocate non-executable memory by default (CMake)
* Avoid abort on ResumeThread failure if Win32 DllMain closes thread handle
* Do not produce '-lpthread' by threadlibs on Tru64/OSF1
* Eliminate 'allocating insufficient size 0 for char` gcc warning in gctest
* Eliminate 'compare signed/unsigned in check_finalizer_nested' bcc warning
* Eliminate 'unused parameter fd' gcc warning in NOSYS GC_write
* Fix 'symbol undefined _snprintf' dmc linker error in cordtest
* Fix 'undefined STACKBOTTOM' preprocessor error for no-OS PowerPC target
* Fix 'undefined symbol sbrk' linker error on FreeBSD
* Fix blocked signals in fork_prepare_proc on HP/UX
* Fix CMake build on macOS Catalina
* Fix GC_suspend abort when the thread is deleted by DllMain
* Fix missing parentheses in SIG_THR_RESTART macro definition
* Fix print_heap_obj call with the lock held in backgraph add_edge
* Fix rounding up in STACKBOTTOM for OSF1
* Fix symbols alignment checking for CRIS and M68K
* Fix undefined reference to GC_objfreelist and GC_bytes_allocd
* Fix various typos in comments and documentation
* Remove improper comment about returned value of CORD_extend_path
* Remove outdated comment about 'make distcheck' from Makefile.am
* Update URLs in documentation after repo transfer to bdwgc organization
* Workaround tests crash if mprotect-based VDB is manually selected (bcc)


== [7.4.28] 2024-09-07 ==

* Avoid gcc stringop-overflow warning for intended overflow in smashtest
* Fix ADD_CALL_CHAIN() placement to follow GC_store_debug_info_inner call
* Fix GC_is_visible for case of arg pointing exactly to object upper bound
* Fix GC_print_trace_inner to print the last element of the circular buffer
* Fix cordtst2.tmp file deletion in cordtest on Windows
* Fix double lock in GC_malloc called from backtrace()
* Fix indent of a closing curly braces in GC_apply_to_all_blocks
* Fix null pointer dereference in GC_is_visible if type_descr is null
* Fix per_object_helper() after changing hb_sz units
* Fix poor thread-local allocation performance because of double EXTRA_BYTES
* Fix potential GC_add_roots_inner call with an overflowed pointer (Win32)
* Fix potential address overflow in GC_add_to_heap
* Fix potential buffer overrun during read in GC_text_mapping
* Fix typos in comments
* Prevent redirected malloc call from a garbage collection routine
* Remove redundant dirty/reachable_here calls in GC_malloc_explicitly_typed
* Update and fix diagrams describing the tree structure for pointer lookups


== [7.4.26] 2024-02-03 ==

* Eliminate 'unused parameter' gcc warning in free() if IGNORE_FREE
* Eliminate 'unused value' gcc warnings in init_global_static_roots (Symbian)
* Fix 'implicit declaration of function sbrk' gcc error on Symbian
* Fix 'unused GC_set_and_save_fault_handler' warning on OS X
* Fix GC_push_stack_for() to push also Xmm registers on Windows/x64
* Fix MACH_TYPE macro redefinition on Symbian/arm
* Fix missing GC_pthread_sigmask on FreeBSD and NetBSD
* Fix missing redirect and implementation of pthread_sigmask() on OpenBSD

Also, includes 7.2r changes.


== [7.4.24] 2023-05-25 ==

* Adjust CORD_ec comment placement in ec.h
* Do not mix debug and non-debug allocations in disclaim tests
* Eliminate 'cast signed to bigger unsigned' CSA warning in WARN calls
* Ensure GC_NO_PTHREAD_SIGMASK defined if no GC_pthread_sigmask prototype
* Fix GC_thread_is_registered for finished threads
* Fix GC_unregister_my_thread call before GC functions usage in gctest
* Fix missing lock while updating GC_in_thread_creation in GC_exit_check
* Fix null pointer dereference in TRACE_TARGET
* Fix of GC_bytes_allocd increment in GC_generic_malloc_inner
* Remove redundant 'ifdef THREADS' around LOCK/UNLOCK in call_with_alloc_lock

Also, includes 7.2q changes.


== [7.4.22] 2022-08-26 ==

* Eliminate 'new_l may be used uninitialized' gcc warning in os_dep (Cygwin)
* Eliminate 'possible loss of data' compiler warning in GC_envfile_getenv
* Fix 'undeclared getpagesize' compiler warning on AIX and OSF1
* Fix GC_dirty() argument in GC_malloc_explicitly_typed_ignore_off_page
* Fix SIGSEGV caused by dropped stack access from child process in gctest
* Fix abort in Win32 DllMain if PARALLEL_MARK
* Fix assertion violation of GC_thread_key alignment if pthread-based TLS
* Fix comment in GC_init regarding GC_init_parallel call
* Fix stack overflow in gctest on Alpine Linux/s390x
* Revert "Remove nested always-false ifdef for HPUX and FREEBSD"
* Use SIGRTMIN+6 as suspend signal if sigrt-signals on OpenBSD
* Workaround crash in FreeBSD rand() by avoiding its concurrent usage

Also, includes 7.2p changes.


== [7.4.20] 2021-09-28 ==

* Do not hold GC_fault_handler_lock when in Sleep (Windows)
* Eliminate 'static GC_sysinfo definition has incomplete type' Clang warning
* Eliminate 'unused function GC_add_map_entry' compiler warning
* Eliminate 'while clause does not guard' GCC warning in GC_parse_map_entry
* Fix OS_TYPE and USE_MMAP_ANON definitions for Cygwin/x64
* Fix abort in GC_printf when gctest is built as WinMain executable (Cygwin)
* Fix configure message about 'AIX gcc optimization fix'
* Fix cordtest build in SMakefile.amiga
* Prevent GetThreadContext failure (Windows)
* Refactoring of WoW64 workaround (Win32)

Also, includes 7.2o changes


== [7.4.18] 2019-03-01 ==

* Fix 'wrong __data_start/_end pair' error on Android
* Fix thread_info() count argument value (OS X)

Also, includes 7.2n changes


== [7.4.16] 2018-12-13 ==

* Fix 'collecting from unknown thread' abort in leak-finding mode for Win32
* Fix 'undefined reference to GC_incremental' linker error in pthread_start
* Fix GC_register_disclaim_proc for leak-finding mode
* Fix concurrent bitmap update in GC_dirty
* Fix marking of finalizer closure object
* Fix marks and hb_n_marks consistency when disclaim returns true
* Fix missing curses.h in cord/de when compiling manually (MS VC, MinGW)
* Refine documentation in gc_disclaim.h

Also, includes 7.2m changes


== [7.4.14] 2018-08-11 ==

* Cleanup BCC Makefile (remove absolute GC paths, fix del cmd, update clean)
* Do not call GC_dirty_inner unless GC_incremental
* Eliminate 'cast between incompatible function types' compiler warning
* Eliminate 'comparing signed and unsigned values' compiler warnings (bcc)
* Eliminate 'language extension used' Clang warning in gc.h
* Eliminate 'possibly incorrect assignment in CORD_vsprintf' compiler warning
* Eliminate 'switch statement contains no case label' compiler warning
* Eliminate 'variable might be uninitialized' warning in win32_start_inner
* Eliminate duplicate clear_mark_bit call when removing disappearing link
* Fix 'collecting from unknown thread' abort in leak-finding mode
* Fix compilation by digimars.mak (DMC) and by WCC makefile
* Fix cords for MANUAL_VDB
* Fix dependency on gc_cpp source in BCC_MAKEFILE and NT_MAKEFILE
* Fix gctest in leak-finding mode
* Fix missing GC_dirty calls for GC-allocated objects used internally
* Fix missing GC_dirty invocation from debug_end_stubborn_change
* Fix multi-threaded gctest for the case of NTHREADS is set to zero
* Fix typos in ChangeLog and generic_malloc
* Keep pointer to the start of previous entry in remove_specific_after_fork
* New API function (GC_is_init_called) to check if BDWGC is initialized
* Remove code duplication in gcj_malloc and malloc_explicitly_typed
* Remove duplicate local variable in reclaim_block
* Remove libatomic_ops license information from README
* Workaround 'dynamic exception specifications deprecated in C++11' warning

Also, includes 7.2l changes


== [7.4.12] 2018-04-19 ==

* Define GC_FREEBSD_THREADS and GC_ADD_CALLER macros for kFreeBSD
* Fix comment for debug_generic_malloc_inner[_ignore_off_page]
* Fix gctest with musl libc on s390x
* Fix missing new-line in ABORT_ARG<n> definition
* Fix null pointer dereference in get_private_path_and_zero_file (Symbian)
* Fix type of local variables receiving result of PHT_HASH
* Remove API symbols renaming in WCC_MAKEFILE

Also, includes 7.2k changes


== [7.4.10] 2018-01-22 ==

* Fix error code in abort message if sem_wait failed in start_world (NetBSD)
Also, includes 7.2j changes


== [7.4.8] 2017-12-22 ==

* Eliminate 'this statement may fall through' GCC warnings
* Eliminate 'value exceeds maximum object size' GCC warning in huge_test
* Fix data race in make_descriptor when setting explicit_typing_initialized
* Fix marking of disclaim-reachable objects in the incremental mode
* Update comment in finalized_disclaim to match FINALIZER_CLOSURE_FLAG
Also, includes 7.2i changes


== [7.4.6] 2017-10-26 ==

* Add configure --enable-gcov option (enable code coverage analysis)
* Add configure check whether to define NO_GETCONTEXT
* Adjust GC_memalign comment
* Allow HAVE_DL_ITERATE_PHDR to be defined by client (musl)
* Allow PKG_CHECK_MODULES in configure.ac to be commented out easily
* Avoid busy waiting in mark_thread while GC_parallel is false
* Better document minimum value of size argument for typed allocations
* Change type of THREAD_TABLE_INDEX result to int in win32_threads.c
* Consistently use 'msec' instead of 'ms' in comments in pthread_support
* Do not define amiga_get_mem, MacTemporaryNewPtr unless really used (extra)
* Do not produce .tar.bz2 distribution file (configure)
* Do not require libatomic_ops for single-threaded builds (configure)
* Do not warn of missing PT_GNU_RELRO segment when custom DSO filter used
* Document GWW_VDB in gcdescr.html
* Eliminate 'cast to void* from int' compiler warnings (Darwin/x64)
* Eliminate 'conditional expression is always true' code defect in GC_init
* Eliminate 'FP divide-by-zero' static analyzer warning
* Eliminate 'incompatible function pointer' warning in mark_some (MinGW/x86)
* Eliminate 'ISO C forbids an empty translation unit' GCC pedantic warning
* Eliminate 'ISO C forbids object to function pointer conversion' warning
* Eliminate 'locally defined symbol imported' MS linker warnings (cord)
* Eliminate 'null dereference' code defect warning in register_finalizer
* Eliminate 'possible loss of data' compiler warnings (MS VC)
* Eliminate 'printf format specifier mismatch' compiler warning (tools)
* Eliminate 'type defaults to int in declaration' warning (REDIRECT_MALLOC)
* Eliminate 'value stored is never read' warning of Clang static analyzer
* Eliminate duplicate log messages in GC_mark_from
* Eliminate most of collisions in GC_threads on Linux/x64
* Ensure GC initialized when atfork_prepare is called by client
* Fix 'arg parameter might be clobbered by setjmp' compiler warning
* Fix 'bogus LR' detection in FindTopOfStack (Darwin)
* Fix 'execvp argument incompatible pointer type' compiler warning (tools)
* Fix 'GetVersion deprecated' compiler warning in os_dep (MS VC)
* Fix 'incompatible pointer' compiler warning in GC_init_dyld (OS X 64-bit)
* Fix 'incompatible ptr-to-int conversion' compiler warning in push_all_stack
* Fix 'ISO C90 does not support %lf, %lg gnu_printf formats' GCC warnings
* Fix 'ISO C90 forbids mixed declarations and code' compiler warning
* Fix 'missing libc-version.h' build error (uClibc/x86[_64])
* Fix 'replacement operator delete cannot be inline' GCC warning (Cygwin)
* Fix 'variable unused' compiler warning in FirstDLOpenedLinkMap
* Fix 'zero-size array is extension' Clang warning in os_dep (Linux/x86)
* Fix (adjust) GC_scratch_alloc actual argument type
* Fix deadlock in GC_help_marker caused by use of mark_cv of parent process
* Fix finalize.c compilation in 'strict ANSI' mode
* Fix GC shared library tests failure related to dl_iterate_phdr (musl)
* Fix gc.h compliance to strict ANSI (pthreads)
* Fix GC_bytes_allocd incrementation in case of allocation failure
* Fix GC_jmp_buf multiple definition
* Fix GC_noop6 definition to avoid its calls to be optimized away
* Fix gctest failure if PARALLEL_MARK (musl)
* Fix gctest thread stack overflow (musl-gcc)
* Fix initsecondarythread_test runtime failure if GC compiled w/o threads
* Fix lack of 2 trailing zeros in _MSC_VER numbers
* Fix local variable declarations in disclaim_bench
* Fix missing #error pragma
* Fix missing .exe for disclaim test filenames in Makefile (MinGW)
* Fix missing atomic/[un]collectable/realloc_count increments in gctest
* Fix missing new-line and redundant trailing dot in WARN messages
* Fix missing new-line at format strings end in subthread_create test
* Fix mixed include of GC public header and gc_priv.h in disclaim bench/test
* Fix potential overflow in decrement when computing GC_markers_m1
* Fix printf format specifiers in extra files (cppcheck warnings)
* Fix pthread_start compilation if single-obj-compilation (Linux)
* Fix register_finalizer call in disclaim_bench for GC_DEBUG
* Fix static assertion violation in LONG_MULT for 64-bit targets
* Fix tag collision between ENABLE_DISCLAIM and KEEP_BACK_PTRS
* Fix thread id leaks in subthread_create and threadkey_test
* Fix threaded tests runtime crash if GC_NO_THREAD_REDIRECTS supplied
* Fix tools/setjmp_t to prevent nested_sp inlining
* Fix typo in CHECK_GCLIB_VERSION name (test)
* Fix typos in comments/documentation (ews4800, extend_size_map, push_roots)
* Fix unchecked fork() result in gctest (Unix, Cygwin)
* Improve detection of internal libatomic_ops (configure)
* Move libraries version info to the beginning of Makefile.am
* Prevent abort in register_data_segments for Symbian
* Process all PT_LOAD segments before PT_GNU_RELRO segments (Glibc)
* Refine Makefile.direct comment about multi-threaded GC build
* Refine README about library source downloading
* Refine should_invoke_finalizers documentation
* Remove all generated files by NT_X64_THREADS_MAKEFILE 'clean' target
* Remove non-existent configure option in simple_example.html
* Replace C++ style comments to C ones, remove commented out code (extra)
* Support CFLAGS_EXTRA to pass extra user-defined compiler flags (configure)
* Support CFLAGS_EXTRA when checking for inline and dladdr (configure)
* Suppress 'tainted string passed to vulnerable operation' false defects
* Suppress MS VC warnings about unused param, const condition (NT_MAKEFILE)
* Update bdwgc mailing list online archive link in documentation
* Update shared libraries version info to differentiate against v7.2
* Use AC_DEFINE for defining NO_GETCONTEXT in configure
* Workaround 'index out of bounds' UBSan false warning in push_marked
* Workaround 'mmap() resource handle leak' static analyzer warning
* Workaround 'redundant assignment of *result to itself' cppcheck warning
* Workaround 'resource leak' error reported by cppcheck (tools, test)
Also, includes 7.2h changes


== [7.4.4] 2016-05-25 ==

* Allow GC_FAST_MALLOC_GRANS() multiple use in a function
* Also enable the TSX workaround for Linux/x86
* Avoid unstructured procfs on Solaris
* Change cord/de main() declaration style from K-R to ANSI C
* Change no-argument functions declaration style to ANSI C (cord)
* Do not include sigcontext.h and asm/sigcontext.h
* Eliminate 'divide by zero' compiler warning in cordtest
* Eliminate warning about 64-bit pointer-to-int cast (Win64/pthreads-w32)
* Eliminate warnings detected by Cppcheck in cord de[_win]
* Fix 'comparison of non-null parameter is always false' warning (Clang)
* Fix 'CORD_iter5 unused result' code defect in cordxtra
* Fix 'GC_generic_malloc_inner_ignore_off_page not used' compiler warning
* Fix 'implicit declaration of vsnprintf' GCC warning (if strict ANSI mode)
* Fix 'signed-to-bigger-unsigned value assignment' in GC_init_size_map
* Fix 'signed-to-bigger-unsigned value assignment' warning for hb_map
* Fix 'signed-to-bigger-unsigned value assignment' warning in GC_setpagesize
* Fix 'statement unreachable' compiler warning in GC_mark_from
* Fix 'statement unreachable' compiler warning in memalign
* Fix 'unused label' compiler warning in cord/de
* Fix 'value truncated' compiler warning in CORD_cat (MS VC)
* Fix 'variable unused' warning in GC_save_callers
* Fix 'visibility attribute not supported' GCC warning (IBM AIX)
* Fix CMake warning about CMP0054 by unquoting instances of HOST
* Fix Cygwin64 build
* Fix GC_REALLOC to call GC_FREE if new size is zero and pointer is non-NULL
* Fix Makefile.direct for Cygwin
* Fix __alloc_size__ availability detection (Clang)
* Fix abort message in GC_move_long_link
* Fix and code refactoring of lock elision workaround (Linux/x64)
* Fix assertion on mark_lock_holder for non-unique NUMERIC_THREAD_ID
* Fix data race in GC_init_explicit_typing
* Fix gc.mak regarding msvc_dbg and test (MSVC)
* Fix missing error handling of pthread_attr_init/getstacksize
* Fix missing error handling of pthread_mutex_init and cond_wait
* Fix missing numeric casts in cord
* Fix potential left shift overflows in finalize.c (64-bit targets)
* Fix pthreads-win32 name in comments and documentation
* Fix setup_mark_lock missing prototype
* Fix unchecked fcntl() result
* Fix unchecked pointer dereference in check_ints (gctest)
* Fix unchecked pthread_join() result in threadkey_test
* Fix unchecked sigdelset() result in pthread_support
* Fix undefined PTRFREE/NORMAL in gc_inline.h
* Prefix PREFETCH_FOR_WRITE with GC_ as used in gc_inline.h public header
* Relax mark_mutex attribute needed to disable elision (Linux/x64)
* Remove (deprecate) TODO file
* Remove code duplication in GC_realloc
* Remove duplicate new-line in OUT_OF_MEMORY message (cord)
* Remove references to missing linux_threads.c from documentation
* Revert "Move asm machine-dependent files to 'src' folder" (partly)
* Support Android API level 21
* Update compiler options in gc.mak (Win32)
* Use mmap instead of sbrk (Hurd)
* Workaround 'comparison is always false' GCC warning in GC_FAST_MALLOC_GRANS
* Workaround 'identical expr on both sides of bitwise op' warning
* Workaround Linux NTPL lock elision bug
* Workaround false warning about unreachable code path
* Workaround invalid '_end' symbol on Android clang 3.5+
Also, includes 7.2g changes


== [7.4.2] 2014-06-03 ==

* Add config option to use STGRTMIN-based signals for thread suspend/resume
* Allow parallel mark to be enabled on powerpc-linux systems
* Check for Fujitsu compiler in builtin_unwind logic (enable FX10/K-Computer)
* Fix 'Array subscript is above array bounds' GCC warning in GC_new_kind/proc
* Fix 'attribute declaration must precede definition' warning (clang-3.1)
* Fix (enable) Cygwin-64 build
* Fix GC_finalized_malloc failure on disclaim_test
* Fix GC_sig_suspend initialization when non-constant SIGRTMIN used
* Fix MS VC redefinition warning for functions declared with GC_ATTR_MALLOC
* Fix TEXT() usage for concatenated strings in GC_CreateLogFile (Win32)
* Fix data roots registration for Android/x86 and NDK ARM 'gold' linker
* Fix find stackbottom on BlueGene P/Q systems
* Fix machdep .lo files path in configure (SPARC, IA-64)
* Fix ok_init assignment (missing cast) in GC_new_kind_inner
* Fix typos in names in AUTHORS and ChangeLog files
* Remove barrett_diagram file duplicated by tree.html
* Remove non-existing DISCARD_WORDS from GC data structure ASCII diagram
* Restore contribution information for ancient releases in ChangeLog
Also, includes 7.2f changes


== [7.4.0] 2013-11-17 ==

* Add 'bytes reclaimed' counters to public GC_prof_stats_s
* Add AArch64 (64-bit ARM) target support
* Add GC_LONG_REFS_NOT_NEEDED ifdefs to exclude long link functionality
* Add GC_get_prof_stats[_unsafe]() to GC public API
* Add GC_push_all/conditional() to GC public API
* Add assertion on number_of_objs to GC_extend_size_map
* Add assertion to GC_enable() ensuring no counter underflow
* Add assertion to LOCK definition that lock is not already held
* Add assertion to LONG_MULT and remove useless assert in PUSH_CONTENTS_HDR
* Add double-lock assertion to GC_acquire_mark_lock
* Add manual POSIX fork handling support (Android)
* Add note about 'pkg-config' solving problem with autoconf 2.68 or older
* Add public GC_set/get_abort_func to replace default GC_on_abort
* Add public GC_start_mark_threads() to allow parallel marker in fork child
* Add public setter and getter for GC_push_other_roots
* Add support of Android logger
* Add tests for GC_register/move/unregister_long_link
* Add thread suspend/resume signals public setters (POSIX threads)
* Added long weakref support
* Adjust GC_dont_expand/gc/precollect and GC_print_stats type to match gc.h
* Adjust README.md title and references to doc .html files in it
* Adjust build scripts to enable additional test library in staticrootstest
* Adjust logged messages in start_mark_threads and GC_thr_init
* Adjust printf format specifiers in GC_print_trace
* Allow not to rely on __data_start value (Linux)
* Allow pthread_kill error code logging in GC_suspend/resume (debugging)
* Allow to compile GC_inner_start_routine aside from extra/gc.c
* Allow to omit libc atexit() call
* Avoid LOCK/UNLOCK hard-coding in gc_locks.h for PS3 target
* Better document GC_warn_proc in gc.h
* Call GC_on_abort (with NULL argument) on exit(1)
* Call GC_stats/verbose_log_printf instead of GC_log_printf if print_stats
* Change policy regarding version numbers ("micro" part instead of "alpha")
* Changed C99-style designated init of GC_dl_hashtbl struct to use C89-style
* Check GC_base result in GC_print_all_smashed_proc
* Check that SIG_SUSPEND and SIG_THR_RESTART are different (Pthreads)
* Check traceable_allocator.allocate result before dereference in test_cpp
* Code refactoring of GC_x_printf (move shared code to macro)
* Convert readme to markdown
* Default to use libc_stack_end in single-threaded GC on glibc targets
* Define GC_VSNPRINTF internal macro in misc.c (code refactoring)
* Define functions in darwin_semaphore.h as inline instead of static
* Define old_bus_handler static variable only if used (Unix)
* Detect dladdr() presence by configure
* Disable find-leak GC_gcollect on GC abnormal EXIT
* Do not define _setjmp/_longjmp macros in mach_dep.c
* Do not duplicate android_log_write output to GC log file (Android)
* Do not include sigcontext.h if NO_SIGCONTEXT_H (Linux)
* Do not set GC_lock_holder by call_with_alloc_lock if assertions disabled
* Do not use pthread_getattr_np if NO_PTHREAD_GETATTR_NP specified
* Elaborate comment on dependencies in autogen.sh
* Eliminate 'cast from int to pointer' warning in GC_exclude_static_roots
* Eliminate 'missing exception specification' warning in gc_cpp.cc (Clang)
* Eliminate 'uninitialized variable use' warning in test_printf (cord)
* Eliminate 'unused result' compiler warning in main() of test_cpp
* Eliminate 'unused value' compiler warning in GC_stop_world (Pthreads)
* Eliminate 'unused variable' compiler warning in start_mark_threads (HP/UX)
* Eliminate Clang warning for GC_pthread_exit attribute
* Eliminate GCC warning about uninitialized 'hhdr' in GC_allochblk_nth
* Eliminate GCC warning in GC_get_main_stack_base (OpenBSD)
* Eliminate GCC warnings in setjmp_t.c, test_cpp and cord 'de' app
* Eliminate GC_first_nonempty atomic value reload in GC_mark_local assertion
* Eliminate SIGBUS-related dead code in GC_write_fault_handler (Linux)
* Eliminate warning and simplify expression in GC_init_explicit_typing
* Enable 'force GC at every GC_malloc' debug-related functionality
* Enable on-demand debug logging in GC_FindTopOfStack (Darwin)
* Enable prefetch operations by default (GCC 3.0+)
* Enable staticrootstest for the case of GC shared library build
* Enable thread-local allocation support for Clang on Cygwin
* Explicitly specify that Darwin, Linux and Solaris platforms have dladdr
* Fix ABORT definition for mingw32ce (WinCE)
* Fix AM_CONFIG_HEADER in configure for autoconf-2.69-1
* Fix GC_CreateThread and GC_beginthreadex definition for Cygwin
* Fix GC_INIT_CONF_ROOTS in gc.h for Android
* Fix GC_INLINE definition to comply with ISO C90 standard (GCC)
* Fix GC_remove_all_threads_but_me for Android (fork support)
* Fix debug_register_displacement calls from GC_debug_generic_malloc_inner
* Fix dyn_load.c compilation for Android 4.3
* Fix make disclaim_test to link with new GNU ld linking rules
* Improve GC error printing atomicity in GC_debug_X and GC_print_obj
* Improve GC output atomicity in GC_print_obj, GC_print_all_errors
* Improve debug-only messages of add/remove_roots and init_linux_data_start
* Improve fork test logging in gctest
* Improve logged messages about heap size and usage
* Improve logging for Android differentiating messages by log level
* Improve staticrootstest (add global data to library, add lib w/o GC_INIT)
* Improve staticrootstest checks (tests)
* Include "config.h" instead of "private/config.h" on HAVE_CONFIG_H
* Include proper header file in 'tools' for configuration macros
* Include pthread_np.h from pthread_stop_world.c on OpenBSD
* Log error messages to stderr instead of stdout in tests
* Make GC_generic_malloc_ignore_off_page() public
* Make GC_mark_lock_holder variable static
* Make GC_print_trace always thread-safe and remove 'lock' argument
* Mark GC_started_thread_while_stopped() as GC_INNER
* Minimize code duplication in GC_mark_and_push
* Move 'include setjmp.h' from mach_dep.c to gc_priv.h
* Move GC_OPENBSD_UTHREADS definition to private/gcconfig.h (OpenBSD)
* Move GC_get_suspend/thr_restart_signal to misc.c for NaCl and OpenBSD
* Move LOCK/UNLOCK from GC_unregister_disappearing_link_inner outer
* Port BDWGC to Android/x86
* Postpone the suspend signal in GC_dirty_init only if used to stop world
* Prepend '#' symbol to GC number in logged messages
* Prevent POSIX fork if mprotect_thread is started (Darwin)
* Prevent abort on GC_err/warn_printf write failure
* Prevent misleading AC_MSG_ERROR/AS_IF errors reported in configure.ac
* Put gc_cpp symbols into 'boehmgc' namespace if GC_NAMESPACE defined
* Recognize GC_DONT_GC macro in gc.h (causes GC_INIT to turn off GC)
* Recognize GC_SIG_SUSPEND and GC_SIG_THR_RESTART tuning macros in gc.h
* Redirect WRITE to __android_log_write if GC_ANDROID_LOG (Android)
* Refine comment of GC_is_heap_ptr and GC_thread_is_registered in gc.h
* Register dynamic libraries via dl_iterate_phdr on Android and OpenBSD
* Remove DebugBreak on WriteFile failure (Win32)
* Remove GC_BUILD definition from build scripts
* Remove abort on open log failure from GC_write (Win32)
* Remove configure.ac outdated revision number
* Remove nested EXPECT in GC_core_finalized_malloc
* Remove nested always-false ifdef for HPUX and FREEBSD
* Remove redundant GC_err_printf before abort
* Remove unused UTHREAD_SP_OFFSET macro (OpenBSD)
* Rename subthread_create to subthreadcreate_test (Makefile)
* Replace GC_COND_LOG_PRINTF calls with WARN for allocation failure messages
* Replace GC_log/err_printf() followed by ABORT with ABORT_ARGn()
* Replace GC_stats_log_printf with GC_DBG/INFOLOG_PRINTF
* Replace SIG_SUSPEND/THR_RESTART macros to variables in pthread_stop_world
* Replace Win32 GC_delete_gc_thread with GC_delete_gc_thread_no_free
* Replace conditional GC_log_printf calls with GC_COND/VERBOSE_LOG_PRINTF
* Replace sprintf with defensive snprintf
* Replace var-args GC_noop with GC_noop6 (to eliminate Clang warning)
* Simplify LOCK/UNLOCK macro definition for static code analysis tools
* Specify GC_malloc result is unused in some tests
* Specify GC_pthread_join result is unused in threadkey_test
* Specify LT_INIT in configure.ac
* Start of port to QNX
* Support rthreads introduced in OpenBSD 5.2+
* Suppress 'GC_dont_gc deprecated' warning in gc.h if GC_DONT_GC
* Tag GC malloc routines with alloc_size attribute for Clang 3.2+
* Test NO_WRAP_MARK_SOME macro to suppress WRAP_MARK_SOME-specific code
* Turn off GC_LOOP_ON_ABORT functionality if GC compiled with NO_DEBUGGING
* Turn on world-stop delay logging at debug level by default for Android
* Use EXPECT in GC_COND/VERBOSE_LOG_PRINTF
* Use GC_log_printf for logging instead of GC_[err_]printf
* Use compiler TLS for Android NDK gcc/arm
* Use memcpy (BCOPY) instead of strcpy (to suppress GCC warning)
* Use pthread API to operate thread-local data on Linux if no compiler TLS
* Workaround 'ELF_DATA/EM_ALPHA redefined' warning in Android linker.h
* Workaround 'unresolved __tls_get_addr' error for Android NDK Clang
Also, includes 7.2e, 7.2d, 7.2c, 7.2b changes


== [7.3alpha2] 2012-05-11 ==

* Add 'const' qualifier to pointer argument of some API functions
* Add GC_UNDERSCORE_STDCALL, UNICODE macro templates to configure (Win32)
* Add GC_get_thr_restart_signal, GC_thread_is_registered to GC API
* Add GC_is_heap_ptr, GC_move_disappearing_link to GC API
* Add SHORT_DBG_HDRS macro template to configure
* Add Symbian port to mainline (porting done by Djamel Magri)
* Add TODO file
* Add assertion ensuring proper alignment of 'pushed' GC symbols
* Add assertion in GC_getspecific on qtid
* Add assertion to GC_incremental_protection_needs, refine documentation
* Add assertion to check GC_large_free_bytes by GC_finish_collection
* Add configure option to compile all library .c files into single gc.o
* Add cordtest to make check
* Add disclaim callbacks for efficient finalization (ENABLE_DISCLAIM)
* Add finalization.html to 'doc' folder
* Add javaxfc.h to the installation set of GC header files (configure)
* Add on-heap-resize event notification to API
* Adjust GC_log_printf format specifiers (regarding signed/unsigned long)
* Adjust GC_requested_heapsize on GC_init if GC_INITIAL_HEAP_SIZE given
* Allow GC_exclude_static_roots() region start to be unaligned
* Allow Win32 DllMain chaining on the client side
* Allow to exclude finalization support by GC_NO_FINALIZATION macro
* Allow to get memory via Win32 VirtualAlloc (USE_WINALLOC) on Cygwin
* Avoid unnecessary GC_find_limit invocation if GC_no_dls
* Avoid use of deprecated GC_dont_gc and GC_stackbottom in gctest
* Cast pointers to word (instead of unsigned long) in specific.h
* Changed the order in autogen.sh so ltmain exists in time for automake
* Declare privately and use handy GC_base_C() for constant object pointers
* Define GC_DLL if DLL_EXPORT at GC build (for Cygwin/MinGW)
* Define GC_READ_ENV_FILE in configure for WinCE unless gc-debug is off
* Do not compile backgraph.c unless configure '--enable-gc-debug'
* Do not compile pthread_stop_world.c for Cygwin/Darwin (configure)
* Do not install ancient new_gc_alloc.h broken for modern STL (configure)
* Enable GC_MIN_MARKERS to set minimal number of pthread-based markers
* Enable PARALLEL_MARK and THREAD_LOCAL_ALLOC for FreeBSD in configure
* Enable parallel mark by default in configure (Darwin/Linux/Solaris/Win32)
* Export GC_is_marked, GC_clear/set_mark_bit (for mark-bit manipulation)
* Extend thread-related debug messages
* Fix 'configure --enable-cplusplus' for Cygwin/MinGW
* Fix DATASTART (and other minor improvements) for NaCl target
* Fix GC_setspecific to prevent garbage collection inside
* Fix compiler warning in cordtest
* Fix minor warnings reported by GCC with '-pedantic' option
* Fix static data roots registration on Android (if GC is shared)
* Implement GC_get_stack_base for Darwin for single-threaded mode
* Improve GC_allochblk algorithm of block splitting when unmapping enabled
* Improve GC_collect_or_expand algorithm for many finalizers registered case
* In tests, print a message in case a test is a no-op
* Instruct configure to hide internal libgc.so symbols if supported by GCC
* Log amount of unmapped memory (if enabled) on marking-for-collection
* Make __data_start a weak symbol to allow loading modules on mips
* Move "cord" library tests to "cord/tests" folder
* Move asm machine-dependent files to "src" folder
* Move build tools sources to "tools" folder
* Move cord_pos.h to public headers folder
* Open log file in APPEND mode on Win32 (similar that on Unix/Cygwin)
* Optimize some functions by moving pthread_self calls out of LOCK section
* Place only major per-release changes description to ChangeLog (this file)
* Prevent compiler warnings in GC_FindTopOfStack and GC_ports (Darwin)
* Recognize GC_LOG_TO_FILE_ALWAYS macro to log to 'gc.log' by default
* Remove all auto-generated files from the repo
* Remove binary icon file for de_win
* Remove cordtest from "cord" library
* Remove duplicate MacOS_Test_config.h file
* Remove gc_amiga_redirects.h (included internally) from public headers
* Remove obsolete Makefile.DLL (superseded by Cygwin/MinGW configure)
* Remove obsolete unused asm files for ALPHA, HPUX, SGI, RS6000, ULTRIX
* Remove unsupported MMAP_STACKS (specific to Solaris threads)
* Remove unused ancient SILENT, __STDC__, NO_SIGNALS macros
* Replace ARGSUSED comment-based annotation with GCC 'unused' attribute
* Replace GC_ms_entry declaration with opaque definition for public API
* Replace long GC_markers global variable with int GC_markers_m1
* Replace pointer relational comparisons with non-pointer ones
* Replace printf PRIxMAX specifier with '%p' for thread id debug output
* Require autoconf 2.61 instead of v2.64
* Simplify autogen.sh (use autoreconf)
* Split GC_abort with GC_on_abort and abort() invoked from ABORT
* Support GC_ATTR_MALLOC for MS VisualStudio
* Tag auxiliary malloc-like API functions with 'malloc' attribute
* Tag deprecated variables in GC API
* Tag must-be-non-null arguments of GC API functions
* Turn on "extra" GCC warnings
* Turn on unused-parameter checking for GCC
* Update AUTHORS file
* Use EXPECT for checking various 'initialized' boolean variables
* Use USE_COMPILER_TLS on Cygwin
* Use pthread_key for thread-local storage on FreeBSD
* Use union of AO_t and word to favor strict-aliasing compiler optimization
Also, includes 7.2 changes


== [7.2u] 2026-02-04 ==

* Change cord function declaration style from K-R to ANSI C
* Eliminate 'incompatible function pointer' warning in mark_some (MinGW/x86)
* Fix 'incompatible pointer' compiler warning in GC_init_dyld (OS X 64-bit)
* Fix 'KERN_PROTECTION_FAILURE while world is stopped' error on MacOS X
* Fix 'reserved' argument handling in DllMain
* Fix 'undefined errno' compiler error in strdup/strndup on WinCE
* Fix a cycle in NORMAL freelist if malloc is redirected on Linux
* Fix GC_push_stack_for() to push also Xmm registers on Windows/x64
* Fix missing new-line in help message of console variant of cord/de
* Fix race in DllMain by deferring delete_thread call to GC_start_world
* Fix SIGSEGV if pthread_detach is called before collector initialization
* Fix typos (about getcontext) in printed message in setjmp_test
* Fix various typos in comments and documentation
* Prevent collection if fork from an unregistered thread
* Prevent GetThreadContext failure (Windows)
* Refactoring of WoW64 workaround (Win32)
* Refine USE_PROC_FOR_LIBRARIES macro documentation for Solaris
* Remove dummy GC_noop call from code visible to Lint tool only
* Remove part of DllMain-specific code which is always disabled (Windows)
* Remove unused GC_VERSION in configure
* Remove unused redefinition of GC_free in gctest
* Replace var-args GC_noop with fixed-args one
* Replace Win32 GC_delete_gc_thread with GC_delete_gc_thread_no_free
* Use GC_noop1 instead of GC_noop in GC_pause and remove duplicate GC_noop1


== [7.2t] 2025-10-17 ==

* Add missing test_cpp dependency on gc_allocator.h in build scripts
* Allocate non-executable memory by default (CMake)
* Do not produce '-lpthread' by threadlibs on Tru64/OSF1
* Fix 'symbol undefined _snprintf' dmc linker error in cordtest
* Fix 'undefined STACKBOTTOM' preprocessor error for no-OS PowerPC target
* Fix (enable) Cygwin-64 build
* Fix blocked signals in fork_prepare_proc on HP/UX
* Fix CMake build on macOS Catalina
* Fix missing parentheses in SIG_THR_RESTART macro definition
* Fix print_heap_obj call with the lock held in backgraph add_edge
* Fix rounding up in STACKBOTTOM for OSF1
* Fix symbols alignment checking for CRIS and M68K
* Fix undefined reference to GC_objfreelist and GC_bytes_allocd
* Fix various typos in comments and documentation
* Remove improper comment about returned value of CORD_extend_path
* Remove outdated comment about 'make distcheck' from Makefile.am
* Update URLs in documentation after repo transfer to bdwgc organization
* Workaround tests crash if mprotect-based VDB is manually selected (bcc)


== [7.2s] 2024-09-06 ==

* Avoid gcc stringop-overflow warning for intended overflow in smashtest
* Eliminate 'type defaults to int in declaration' warning (REDIRECT_MALLOC)
* Eliminate 'value exceeds maximum object size' GCC warning in huge_test
* Eliminate warning and simplify expression in GC_init_explicit_typing
* Fix 'GetVersion deprecated' compiler warning in os_dep (MS VC)
* Fix 'value truncated' compiler warning in CORD_cat (MS VC)
* Fix ADD_CALL_CHAIN() placement to follow GC_store_debug_info_inner call
* Fix GC_is_visible for case of arg pointing exactly to object upper bound
* Fix GC_jmp_buf multiple definition
* Fix GC_print_trace_inner to print the last element of the circular buffer
* Fix double lock in GC_malloc called from backtrace()
* Fix indent of a closing curly braces in GC_apply_to_all_blocks
* Fix null pointer dereference in GC_is_visible if type_descr is null
* Fix per_object_helper() after changing hb_sz units
* Fix poor thread-local allocation performance because of double EXTRA_BYTES
* Fix potential GC_add_roots_inner call with an overflowed pointer (Win32)
* Fix potential address overflow in GC_add_to_heap
* Fix potential buffer overrun during read in GC_text_mapping
* Fix typos in comments
* Prevent compiler warnings regarding unused argument and printf in extra
* Prevent redirected malloc call from a garbage collection routine
* Remove barrett_diagram file duplicated by tree.html
* Remove non-existing DISCARD_WORDS from GC data structure ASCII diagram
* Resolve GCC warning in setjmp_t.c
* Update and fix diagrams describing the tree structure for pointer lookups


== [7.2r] 2024-02-03 ==

* Fix 'g++ not found' error on OpenBSD (Makefile.direct)
* Fix 'implicit declaration of iscntrl()' warning in cord/de_win (MinGW)
* Fix 'info' buffer potential overrun in GC_save_callers
* Fix 'missing sysconf() prototype' gcc error in setjmp_t tool (OpenBSD)
* Fix SVR4 macro definition order
* Fix asm constraint in LONG_MULT for gcc/x86
* Fix assertion violation in GC_get_maps on Linux if malloc redirection
* Fix bitwise negation and rounding direction in setjmp_t tool
* Fix closing bracket placement for case statement in configure
* Fix indent of a closing curly brace in GC_forward_exception
* Fix missing outermost parentheses in CORD_pos_cur_char_addr
* Fix missing type widening before left shift in GC_MAKE_PROC
* Fix misspelled GC_HEADERS_H macro in gc_priv.h
* Fix null dereference in check_finalizer_nested if redirect malloc on Linux
* Fix posix_memalign() to overwrite pointer storage only on success
* Fix skipped removal of page protection in case of address hash collision
* Fix typos in comments
* Fix update of last_back_trace_gc_no if KEEP_BACK_PTRS is not defined


== [7.2q] 2023-05-25 ==

* Fix CORD_next() indent inside loop in test_basics() of cordtest
* Fix DCL_LOCK_STATE placement in GC_set_oom_fn
* Fix GC_excl_table overrun on overflow in GC_exclude_static_roots
* Fix IRIX5 defined wrongly on Tandem S-Series and WinCE/mips
* Fix comparisons to heap boundary in GC_get_back_ptr_info and GC_mark_from
* Fix disabling of automatic dynamic libraries registration
* Fix double initialization of main thread local free lists on Win32
* Fix joinable threads shutdown on NaCl
* Fix loop condition over dll_thread_table in GC_lookup_pthread (Win32)
* Fix missing GC_CALLBACK for GC_waitForSingleObjectInfinite
* Fix missing libalphagc.so dependency in Makefile.direct
* Fix missing result check of pthread_attr_getdetachstate in pthread_create
* Fix overlapping region assertion in mark_some if malloc redirect on Linux
* Fix potential SIGSEGV on out-of-memory in gctest
* Fix typos in comments and documentation
* Fix unregistering of thread created by intercepted pthread_create on NaCl
* Fix use of unset errno after pthread_create call
* Invoke GC_oom_fn if GC_make_array_descriptor failed because of no memory


== [7.2p] 2022-08-25 ==

* Avoid potential race in GC_init_real_syms after GC_allow_register_threads
* Define SUNOS5SIGS macro for kFreeBSD
* Do not assert that GC is initialized at DLL_THREAD_DETACH (Win32)
* Ensure typed objects descriptor is never located in the first word
* Fix GC_make_descriptor for zero length argument
* Fix SUNOS5SIGS documentation to match macro definition in gcconfig.h
* Fix assertion violation in GC_allow_register_threads on Windows
* Fix get_maps failure when GC_repeat_read returns zero
* Fix hb_obj_kind type in documentation (ASCII diagram) describing hblkhdr
* Fix missing lock when GC_generate_random_valid_address is called
* Fix nodist_libgc_la_SOURCES value in Makefile.am for Solaris/sparc
* Fix oldProc initialization in gc_cleanup and eliminate related warnings
* Fix parallel_initialized assertion violation in initsecondarythread (Win32)
* Fix propagation of out-of-memory occurred in GC_make_sequence_descriptor
* Fix race between calloc_explicitly_typed and push_complex_descriptor
* Fix typos in comments of .c files, gc.h and a typo in debugging.html
* Refer to Makefile.direct instead of deleted Makefile file in README
* Remove checking of RS6000 completely
* Remove non-working check of M68K in gctest
* Revert addition of msvc_dbg.h in include.am


== [7.2o] 2021-09-28 ==

* Add loop to handle abort error like in suspend logic on Darwin
* Disable mprotect-based incremental GC if /proc roots are used (Linux)
* Explicitly zero-initialize trace_buf (fix trace_buf initialization)
* Fix 'ACCESS_VIOLATION in marker' GC warning on Win32 async thread start
* Fix 'GC_generic_malloc must be available' GCC error in new_gc_alloc.h
* Fix 'expected function body after declarator' clang error in gc_cpp.cc
* Fix 'write to GC log failed' error
* Fix GC_proc_fd value in child process at fork (Solaris)
* Fix assertion violation in register_dynlib_callback on Android
* Fix configure message about 'AIX gcc optimization fix'
* Fix data race regarding *rlh value in generic_malloc_many
* Fix first_thread stack_base initialization if custom GC_stackbottom (Win32)
* Fix fread failure after enable_incremental if malloc is redirected (Linux)
* Fix gc_cflags variable name in configure (HP/UX)
* Fix handling of areas smaller than page size on recycle scratch area
* Fix incorrect define GC_OPENBSD_THREADS on sparc64
* Fix misaligned tlfs passed to AO_load on m68k
* Fix missing GC_quiet declaration in pcr_interface.c
* Fix missing gc_dlopen.c in CMake script
* Fix missing scratch_last_end_ptr update (Irix)
* Fix overflow of scratch_free_ptr value
* Fix page_was_[ever_]dirty() for static roots (Solaris)
* Fix printf format specifier in simple_example.html
* Fix save_callers for multi-threaded case if built-in backtrace unavailable
* Fix various typos in comments and documentation files
* Fix word size, data start and alignment for OpenBSD/mips64(el)
* Prevent WARN of incompatible incremental GC if default or manual VDB
* Reduce a time period between GetExitCodeThread and SuspendThread (Win32)
* Remove a misleading comment about Solaris in gc.h


== [7.2n] 2019-03-01 ==

* Fix 'mprotect remapping failed' abort on NetBSD with PaX enabled
* Fix 'unexpected mark stack overflow' abort in push_all_stack
* Fix BSD_TIME variant of MS_TIME_DIFF for the case of a.tv_usec < b.tv_usec
* Fix GetThreadContext stale register values use if WoW64 (Win32)
* Fix executable memory allocation in GC_unix_get_mem
* Fix invalid initializer of CLOCK_TYPE variables if BSD_TIME


== [7.2m] 2018-12-11 ==

* Fix comment typos in CMakeLists.txt, backgraph.c, de.c, gcconfig.h
* Fix hbp overflow in GC_install_counts
* Fix start_world not resuming all threads on Darwin
* Guard against potential buffer overflow in CORD_next and CORD_pos_fetch


== [7.2l] 2018-08-10 ==

* Fix 'pointer arithmetic with NULL' code defect in print_callers
* Fix Borland version in documentation to match that in BCC_MAKEFILE
* Fix comment about inv_sz computation in setup_header
* Fix comments style in configure.ac and Makefile.am
* Fix GC_is_valid_displacement and GC_is_visible for non-small objects
* Fix global operator delete definition for C++14 in gc_cpp
* Fix infinite restarting of mark_some when a static root disappeared (Linux)
* Fix large object base computation in PUSH_CONTENTS() if MARK_BIT_PER_OBJ
* Fix mark stack overflow checking in push_selected
* Fix MSWIN32 macro redefinition (WCC)
* Fix potential null dereference in GC_CONS
* Fix register_dynamic_libraries on Windows 10
* Fix result computation in n_set_marks
* Fix return type in GC_set_warn_proc API documentation
* Fix typo in comment for CORD_ec_flush_buf prototype
* Fix typos in ChangeLog
* Fix VirtualQuery call in case of malloc failure (Win32)
* Install gc.3 man page instead of copying gc.man to doc folder (configure)
* Perform thread_suspend in loop as it may be interrupted (Darwin)
* Workaround 'template-id not supported in this context' compiler error (WCC)


== [7.2k] 2018-04-19 ==

* Fix arguments delimiter in pcr_interface.c (PCR)
* Fix assertion violation in DllMain of win32_threads
* Fix data race during apply_to_each_object(reset_back_edge)
* Fix dbg_mlc.c/o file name in documentation
* Fix include gc_gcj.h in thread_local_alloc.c
* Fix man section number (3)
* Fix missing GC_generic_malloc_words_small implementation in new_gc_alloc.h
* Fix missing SIGBUS handler setup for kFreeBSD
* Fix null dereference in print_callers on backtrace_symbols failure
* Fix the collector hang when it is configured with --enable-gc-debug
* Fix thread_suspend fail for threads registered from key destructor (OS X)
* Fix typo in AIX macro name
* Fix typo in comment in specific.h


== [7.2j] 2018-01-21 ==

* Fix GC allocation mutex in child after a fork
* Fix last_reclaimed..gc_no interval comparison to threshold in unmap_old
* Fix libgc version which was changed in linkage breaking way
* Fix missing EOLn output in threadlibs tool


== [7.2i] 2017-12-21 ==

* Avoid data race in finalized_count (gctest)
* Fix assertion violation about disabled cancel in try_to_collect_inner
* Fix data race in a list referenced by A.aa (gctest)
* Fix data race in do_local_mark when comparing active_count to helper_count
* Fix data race in GC_init_explicit_typing
* Fix data race in last_stop_count access (suspend_handler_inner)
* Fix data race in mark_thread when updating mark_no
* Fix data race when getting object size in explicitly-typed allocators
* Fix lack of barriers to synchronize memory for suspend_handler
* Fix typos in cdescr.html, extend_size_map and ews4800 doc, README.sgi
* Prevent 'Unexpected heap growth' in single-threaded gctest (Linux/x64)


== [7.2h] 2017-10-12 ==

* Add gctest as a test (CMake)
* Change no-argument functions declaration style to ANSI C (extra files)
* Do not allow SHORT_DBG_HDRS if KEEP_BACK_PTRS or MAKE_BACK_GRAPH
* Ensure oom_fn callback executed on out-of-memory in calloc
* Fix '~' operator application to unsigned values shorter than word
* Fix 'context local variable might be clobbered by setjmp' compiler warning
* Fix 'doc' files installation folder
* Fix 'shift count >= width of type' compiler warning in GC_SQRT_SIZE_MAX
* Fix ALL_INTERIOR_POINTERS name in comments and documentation
* Fix AO_SRC_DIR target name in NT_*_MAKEFILE
* Fix assertion in GC_mark_from for non-heap regions
* Fix assertion in GC_steal_mark_stack for non-heap regions
* Fix assertion violation in GC_repeat_read if --enable-redirect-malloc
* Fix assertion violation in GC_wait_builder called from start_mark_threads
* Fix assertion violation in mark_local checking GC_mark_stack_top
* Fix assertion violation in return_single_freelist in child process
* Fix bm_huge initialization for 64-bit targets (gctest)
* Fix broken external links in documentation
* Fix bytes count passed to add_to_our_memory in backgraph new_back_edges
* Fix calloc_explicitly_typed in case of lb*n overflow
* Fix CMake warning about CMP0054 by unquoting instances of HOST
* Fix conditional expression in pos_fetch, next non-macro definitions (cord)
* Fix configure --disable-munmap handling
* Fix CORD_substr_closure for the case when CORD_from_fn returns C string
* Fix crash in FirstDLOpenedLinkMap if app linked statically (Alpine Linux)
* Fix double lock in pthread_detach (Cygwin, winpthreads)
* Fix double multiplication of lb by n in calloc_explicitly_typed
* Fix enable_parallel_mark condition in CMake script
* Fix external libatomic_ops pkg-config-based detection
* Fix gc_allocator.h file name in new_gc_alloc.h comment
* Fix gc_backptr.h, gc_mark.h, GC_DS_TAGS names in documentation
* Fix gc_cleanup destructor for non-heap objects (gc_cpp)
* Fix GC_collect_or_expand to prevent allocation size value wrap-around
* Fix GC_incremental declaration/definition type mismatch
* Fix GC_mark_stack_top assertion violation properly in mark_local
* Fix GC_remove_specific invocation from remove_all_threads_but_me
* Fix GC_requested_heapsize increment in GC_init
* Fix GC_setspecific to prevent garbage collection inside
* Fix GC_SIZE_MAX definition (Linux/musl-gcc)
* Fix GCJ support in CMake build script
* Fix gctest crash if configure --enable-handle-fork on Darwin
* Fix get_maps on proc maps file asynchronous growth
* Fix hb_n_marks underflow in clear_fl_marks if MARK_BIT_PER_OBJ
* Fix header filename in gcconfig.h comment
* Fix infinite mark_some calls after memory mapping disappeared (Glibc)
* Fix integer shift undefined behavior in GC_init_explicit_typing
* Fix leak_test crash in print_callers if free() is redirected
* Fix Makefile.direct recursive invocation
* Fix malloc routines to prevent size value wrap-around (fix CVE-2016-9427)
* Fix missing win32_threads.c compilation for Cygwin (CMake)
* Fix MS VC warning about compiling unused checksums and thread_local_alloc
* Fix name typos in GC_FAST_MALLOC_GRANS comment
* Fix null dereference in reclaim_block if DONT_ADD_BYTE_AT_END
* Fix OSF1 host pattern in CMakeLists.txt
* Fix PCR-Makefile by removing compilation of a missing file
* Fix potential data race in GC_SysVGetDataStart (SPARC)
* Fix potential integer overflow in GC_find_limit_* functions
* Fix printf arguments type in print_callers
* Fix pthread_detach for threads not yet registered (Cygwin, winpthreads)
* Fix pthread_join to avoid thread removal on failure (Cygwin, winpthreads)
* Fix pthread_join when thread is registered in thread key destructor
* Fix push_complex_descriptor to avoid unlimited global mark stack growth
* Fix removal of dead threads in a child process
* Fix SIGSEGV in GC_is_marked when gc_cleanup is used in leak-finding mode
* Fix SIGSEGV in mark_from called from do_local_mark if WRAP_MARK_SOME
* Fix Solaris/sparc detection in case of strict C compliance is enforced
* Fix STACKBOTTOM for Solaris 11/x86
* Fix storage class of local variable in register_dynamic_libraries (Irix)
* Fix tools/setjmp_t hang (OS X)
* Fix typed_test to prevent fails in malloc_explicitly_typed (64-bit)
* Fix undefined HEAP_START in register_dynamic_libraries
* Fix USE_CUSTOM_SPECIFIC mode (if manually enabled) for Win32
* Fix USE_GET_STACKBASE_FOR_MAIN definition in gcconfig.h
* Fix various typos in comments, documentation and printed messages
* Handle load_segs overflow in register_dynlib_callback gracefully
* Prevent misleading AC_MSG_ERROR/AS_IF errors reported in configure.ac
* Replace (fix) 'objs' acronym in comments with 'objects' word
* Revert "Skip GC_DS_PER_OBJECT objs with negative descriptor in GC_mark_from"
* Update documentation about bugs reporting and new releases notification
* Update Download information in GC overview document
* Update shared libraries version info (v7.2)
* Workaround a bug in winpthreads causing parallel marks deadlock (MinGW)
* Workaround missing getcontext() in Docker osrf/ubuntu_32bit


== [7.2g] 2016-05-23 ==

* Fix 'illegal option -xassembler-with-cpp' error (Oracle SunCC)
* Fix 'implicit declaration of function' compiler warnings in cord/de
* Fix CFLAGS in configure regarding -O flag passing to SunCC compiler
* Fix FirstDLOpenedLinkMap for case libgc not 1st dynamically linked (NetBSD)
* Fix GC initialization in cord de_win for Cygwin
* Fix GC_get_stack_base if called before GC_init (Win32)
* Fix OSX issue with pthread_attr_setstacksize failure
* Fix Unicode Win32 API calls in cord de_win
* Fix USE_COMPILER_TLS macro duplicate description in README
* Fix cord de_win WndProc prototype parameters for 64-bit (Win64)
* Fix file descriptor resource leak in GC_register_data_segments (OS/2)
* Fix filename printing in cordtest
* Fix missing cord_pos.h, ec.h among installed headers (Automake)
* Fix missing GC_get_stack_base for Amiga
* Fix missing msvc_dbg.h in dist_noinst_HEADERS (Automake)
* Fix mistyped ARM_THREAD_STATE macro (Darwin/arm)
* Fix null-pointer dereferences on out-of-memory in cord and tests
* Fix potential multiplication overflow in check_heap_stats (gctest)
* Fix race (and potential deadlock) at marker threads initialization
* Fix signedness of char values passed to isspace, iscntrl, isxdigit
* Fix typo (items numbering) in GC_finalize_all documentation
* Fix typos in ERROR_FL, GC_malloc_uncollectable comments
* Fix typos in gc_priv.h, in README for ews4800
* Fix unresolved vsnprintf in misc.c and snprintf in cordtest (DJGPP, VC)
* Fix various spelling errors
* Fix vsprintf_args initialization/cleanup in CORD_vsprintf for EMX
* Regenerate configure files using official libtool release (v2.4.2)
* Remove documentation about obsolete GC_REDIRECT_TO_LOCAL
* Skip GC_DS_PER_OBJECT objects with negative descriptor in GC_mark_from
* windows-untested: Fix paths to msvc_dbg.c/h


== [7.2f] 2014-06-03 ==

* Fix 'Bad signal in suspend_handler' abort on FreeBSD-9.2
* Fix 'source file in a subdirectory' Automake warnings
* Fix ABORT message in GC_restart_handler
* Fix ADD_DEFINITION in CMakeLists.txt for kFreeBSD
* Fix CMakeLists.txt: do not override CMAKE_OSX_ARCHITECTURES
* Fix GC_alloc_large by bumping GC_collect_at_heapsize in GC_add_to_heap
* Fix GC_scratch_last_end_ptr update on GC_scratch_alloc failure
* Fix GET_MEM argument rounding in GC_scratch_alloc and similar
* Fix PARALLEL_MARK for Windows 7+
* Fix build (broken by fenv.h inclusion) on Linux/x64 under uClibc
* Fix crash when using GC_malloc_many() as first allocation call
* Fix mark stack excessive growth during parallel mark
* Fix or remove broken URLs in documentation
* Fix out-of-memory case in new_back_edges, push_in_progress (backgraph)
* Fix typo in GC_collect_or_expand comment
* Fix typos in GC overview file, gc_config_macros.h, gc_cpp.h, README.changes
* Regenerate configure files by automake 1.14.1, libtool 2.4.2.418
* Update emails/links due to project site and ML transition


== [7.2e] 2013-11-10 ==

* Add weak attribute to avoid __data_start undefined messages (s390x)
* Add weak stubs for pthread_cancel API
* Adjust 'pthread_[un]register_cancel undefined ref' workaround (Pthreads)
* Append _test suffix to 'initsecondarythread' binary file names
* Enable PARALLEL_MARK and THREAD_LOCAL_ALLOC for FreeBSD in configure
* Fix 'stack section' pointer passed to push_all_stack_sections (Pthreads)
* Fix GC_CreateThread 'dwStackSize' argument type for Win64
* Fix GC_PTHREAD_PTRVAL definition for GC_PTHREADS_PARAMARK (Win32)
* Fix GC_clear_stack by declaring 'dummy' local array as volatile
* Fix GC_get_stack_base assembly code (Cygwin/Clang)
* Fix GC_malloc_explicitly_typed_ignore_off_page for large allocations
* Fix GC_marker_Id elements initialization (WinCE)
* Fix GC_print_trace missing unlock
* Fix GC_unix_mmap_get_mem for open of /dev/zero failure
* Fix GC_win32_free_heap compilation error for Cygwin
* Fix GC_win32_free_heap to prevent memory leak if USE_GLOBAL_ALLOC
* Fix Win32 GC_write preventing potential infinite recursion at abort
* Fix assertion violation in GC_mark_from prefetch loop
* Fix collection of objects referenced only from GC_mark_stack_X variables
* Fix dwSize argument of VirtualFree call in detect_GetWriteWatch (Win32)
* Fix heap sections overflow for Win32/Cygwin with enabled parallel marker
* Fix min_bytes_allocd preventing potential infinite loop in GC_allocobj
* Fix missing tabs in SMakefile.amiga file
* Fix null-pointer dereference in CORD_substr_closure
* Fix old_segv/bus_act variables initialization for FreeBSD
* Fix potential double fclose in test_extras (cordtest)
* Fix pthread_attr_t resource leak in pthread_create
* Fix race in GC_print_all_errors regarding GC_leaked
* Fix sizeof in GC_push_thread_structures
* Fix stackbottom/stack_end assignment in GC_call_with_gc_active
* Fix tests makefile to link with new GNU ld linking rules
* Fix typos in comments and documentation
* Fix unportable '==' test operators in configure
* Fix vsprintf_args cleanup in CORD_vsprintf
* Merge FreeBSD New ports collection for boehm-gc v7.2d
* Replace GC_DBG_RA with GC_DBG_EXTRAS macro
* Replace deprecated [CXX]INCLUDES to AM_C[PP]FLAGS in configure.ac file
* Use __builtin_extract_return_addr in GC_RETURN_ADDR_PARENT (gcc/x86)


== [7.2d] 2012-08-09 ==

* Fix GC_call_with_stack_base to prevent its tail-call optimization
* Fix all address-of-dummy operations by using GC_approx_sp() instead
* Fix stop_info.stack_ptr assignment in GC_suspend_all for OpenBSD
* Fix test_cpp (ensure the collector recognizes pointers to interiors)
* Fix thread-related tests for pthreads-w32
* test_cpp: Fix WinMain to prevent SEGV if zero arguments passed (MinGW)


== [7.2c] 2012-06-11 ==

* Fix CORD_cat_char_star to prevent SEGV in case of out-of-memory
* Fix GC_FirstDLOpenedLinkMap() for NetBSD 6 release
* Fix GC_scratch_alloc and GC_get_maps invocations to prevent SEGV
* Fix visibility of GC_clear/set_mark_bit (unhide symbols)
* Fix visibility of GC_push_all/conditional, GC_push_other_roots symbols


== [7.2b] 2012-05-23 ==

* Fix assertion in GC_malloc_[atomic_]uncollectable (THREADS case only)


== [7.2] 2012-05-11 ==

* Abort in GC_thr_init on pthread_atfork failure (POSIX threads)
* Add GC_WIN32_PTHREADS target in configure
* Add GC_is_disabled new function to GC API
* Add info that getcontext() resets FPE mask no longer on Linux/x64
* Add public GC_set_handle_fork to control forked child handling support
* Add realloc_test.c test
* Add support for Hexagon target
* Add thread-safe GC_get_heap_usage_safe to GC API
* Change GC_check_fl_marks prototype and implementation
* Check pthread_create/join result in test
* Define GC_DLL (in configure) if building only dynamic libraries
* Define NO_DEBUGGING (in configure) if "--disable-gc-debug" is set
* Disable incremental mode on Darwin if fork handling requested
* Enable parallel marker in configure for Solaris
* Fix "comparison of signed and unsigned values" compiler warnings
* Fix 'volatile' keyword placement in GC_SysVGetDataStart
* Fix ALIGNMENT, CPP_WORDSZ, GC_GRANULE_BYTES/WORDS for x32 target
* Fix GC_READ_ENV_FILE code for Cygwin
* Fix GC_add_roots_inner for Mac OS X (align segment start)
* Fix GC_check_fl_marks regarding concurrent access
* Fix GC_finalizer_nested size to workaround alignment problem in Watcom
* Fix GC_find_limit_with_bound to always reset fault handler on return
* Fix GC_init static assertion for clang/x64 (Darwin)
* Fix GC_init[_lib_bounds] and GC_get_main_stack_base for malloc redirection
* Fix GC_push_all/selected boundaries check
* Fix GC_register_my_thread marking thread as detached (Cygwin/pthreads-w32)
* Fix GC_remove_all_threads_but_me to cleanup thread-specific data storage
* Fix GC_restart_handler to preserve errno if needed
* Fix GC_root_size update in GC_add_roots_inner (Win32)
* Fix GC_unregister_my_thread to ensure no ongoing incremental GC (Win32)
* Fix GC_with_callee_saves_pushed for clang (disable __builtin_unwind_init)
* Fix calloc, GC_generic_malloc to check for allocation size overflows
* Fix compiler warning in GC_dyld_image_add/remove (Darwin)
* Fix configure --enable-cplusplus make install
* Fix configure to disable GCC aliasing optimization unless forced to
* Fix duplicate definitions in gcconfig.h for NetBSD
* Fix fork() support on Cygwin and Darwin targets
* Fix gc.h compatibility regression regarding GC_PTR, GC_I_HIDE_POINTERS
* Fix gc_cpp.cc for Cygwin (remove duplicate function definition)
* Fix gcconfig.h to define USE_GET_STACKBASE_FOR_MAIN for Android
* Fix gcconfig.h to handle mips64-linux target
* Fix gctest (for Win32) to avoid GC_print_stats internal variable usage
* Fix mach_dep.c to include sys/ucontext.h on Mac OS X 10.6
* Fix tests to check GC_malloc result for NULL (out-of-memory)
* Fix thread model in configure for MinGW ("win32" instead of "posix")
* Fix various warnings reported by LINT-like tools
* Fix visibility of some GC internal symbols used by GNU GCJ currently
* Port some thread tests to Win32
* Refine API GC setters and getter comments regarding locking
* Refine GC_stackbottom description in gc.h
* Remove duplicate calls in GC_register_dynamic_libraries
* Remove locking in API GC_get_bytes_since_gc and friends
* Remove newly-added GC_get_heap_size/free_bytes_inner from API
* Remove some local variables that are unused
* Support multi-threading for RTEMS target
* Use global GC_noop_sink variable in GC_noop1 to suppress compiler warning
* Use pkg-config to pick up libatomic_ops, etc
* Workaround some Linux/arm kernels bug to get correct GC_nprocs value


== [7.2alpha6] 2011-06-14 ==

* configure_atomic_ops.sh: Remove.
* Makefile.direct (dist gc.tar): Remove configure_atomic_ops.sh.
* Makefile.am (EXTRA_DIST): Add autogen.sh.

* NT_STATIC_THREADS_MAKEFILE (.cpp.obj): Remove duplicate .cpp
filename passed.
* NT_X64_THREADS_MAKEFILE (.cpp.obj): Use lowercase file
extension.
* NT_X64_STATIC_THREADS_MAKEFILE (.cpp.obj): Likewise.
* NT_MAKEFILE (.cpp.obj): Likewise.

* alloc.c (GC_add_current_malloc_heap, GC_build_back_graph,
GC_traverse_back_graph): Move prototype to gc_priv.h.
* checksums.c (GC_page_was_ever_dirty): Likewise.
* dbg_mlc.c (GC_default_print_heap_obj_proc): Likewise.
* dyn_load.c (GC_parse_map_entry, GC_get_maps,
GC_segment_is_thread_stack, GC_roots_present, GC_is_heap_base,
GC_get_next_stack): Likewise.
* finalize.c (GC_reset_finalizer_nested,
GC_check_finalizer_nested): Likewise.
* gcj_mlc.c (GC_start_debugging, GC_store_debug_info): Likewise.
* malloc.c (GC_extend_size_map, GC_text_mapping): Likewise.
* mark_rts.c (GC_mark_thread_local_free_lists): Likewise.
* misc.c (GC_register_main_static_data, GC_init_win32,
GC_setpagesize, GC_init_linux_data_start,
GC_set_and_save_fault_handler, GC_init_dyld, GC_init_netbsd_elf,
GC_initialize_offsets, GC_bl_init, GC_do_blocking_inner,
GC_bl_init_no_interiors): Likewise.
* os_dep.c (GC_greatest_stack_base_below, GC_push_all_stacks):
Likewise.
* reclaim.c (GC_check_leaked): Likewise.
* win32_threads.c (GC_gww_dirty_init): Likewise.
* darwin_stop_world.c (GC_is_mach_marker, GC_mprotect_stop,
GC_mprotect_resume): Move prototype to darwin_stop_world.h.
* pthread_support.c (GC_FindTopOfStack): Likewise.
* dyn_load.c (GC_cond_add_roots): Merge adjacent definitions.
* mark.c (GC_page_was_ever_dirty): Remove (as already declared).
* mark_rts.c (GC_roots_present): Change return type to void
pointer (to match the prototype); return NULL instead of FALSE.
* mark_rts.c (GC_add_roots_inner): Cast GC_roots_present() result.
* os_dep.c (NEED_PROC_MAPS): Move definition to gcconfig.h.
* os_dep.c (GC_write_fault_handler): Make STATIC.
* os_dep.c (GC_set_write_fault_handler): New function (only if
GC_WIN32_THREADS).
* pthread_start.c (GC_start_rtn_prepare_thread,
GC_thread_exit_proc): Move prototype to pthread_support.h.
* pthread_support.c (GC_nacl_initialize_gc_thread,
GC_nacl_shutdown_gc_thread, GC_unblock_gc_signals):
Likewise.
* pthread_support.c (GC_stop_init): Move prototype to
pthread_stop_world.h.
* win32_threads.c (GC_write_fault_handler): Remove prototype.
* win32_threads.c (GC_register_my_thread_inner): Call
GC_set_write_fault_handler instead of SetUnhandledExceptionFilter
(only if MPROTECT_VDB).
* doc/README.win32: Add information about DMC.
* include/private/gc_priv.h (GC_set_write_fault_handler): New
prototype (only if GC_WIN32_THREADS and MPROTECT_VDB).

* misc.c (vsnprintf): Redirect to vsprintf() if NO_VSNPRINTF.

* win32_threads.c (GC_unregister_my_thread): Use KNOWN_FINISHED()
instead of FINISHED macro.
* tests/test.c (check_heap_stats): Round up max_heap_sz value for
Win32 (same as for USE_MMAP).

* tests/test.c (check_heap_stats): Adjust printf format specifier
for max_heap_sz; cast max_heap_sz accordingly.

* doc/README.solaris2: Add note.

* configure.ac (SOLARIS25_PROC_VDB_BUG_FIXED): Don't define for
Solaris/x86 2.10+.

* tests/threadkey_test.c (SKIP_THREADKEY_TEST): Skip the test if
defined; explicitly define for some targets.

* mark.c (GC_dirty): Add prototype (only if MANUAL_VDB).
* stubborn.c (GC_dirty): Likewise.
* include/private/gcconfig.h (GWW_VDB, MPROTECT_VDB, PCR_VDB,
PROC_VDB): Undefine if MANUAL_VDB.
* include/private/gcconfig.h (DEFAULT_VDB): Don't define if
MANUAL_VDB.
* os_dep.c (async_set_pht_entry_from_index): Define for
MANUAL_VDB.
* os_dep.c (GC_read_dirty): Set GC_dirty_maintained only if
success; if ioctl() failed then just print warning instead of
aborting.

* include/private/gc_priv.h (GC_ASSERT): Use "%d" (instead of %ld)
for line number printing.

* os_dep.c (GC_read_dirty): Add debug logging if DEBUG_DIRTY_BITS
(for PROC_VDB only); print errors via GC_err_printf; rename "ps"
and "np" local variables to npages and pagesize, respectively;
remove "current_addr" local variable.

* os_dep.c (GC_get_main_stack_base): Convert to GC_get_stack_base
for BeOS and OS/2; define HAVE_GET_STACK_BASE.
* os_dep.c (GET_MAIN_STACKBASE_SPECIAL): Define when a specific
GC_get_main_stack_base implementation is defined.
* os_dep.c (GC_get_main_stack_base): Define that based on
GC_get_stack_base() in a single place (only if
GET_MAIN_STACKBASE_SPECIAL is unset); check GC_get_stack_base()
result.

* mark.c (GC_push_selected): Remove "push_fn" argument (use
GC_push_all directly); update the documentation.
* mark.c (GC_push_conditional): Simplify the code (for better
readability).

* mark.c (alloc_mark_stack): Use FALSE/TRUE (instead of 0/1) for
boolean local variables.
* doc/README.macros (GC_PREFER_MPROTECT_VDB): Update.
* os_dep.c (GC_page_was_dirty, GC_page_was_ever_dirty,
GC_remove_protection): Define for GWW_VDB and PROC_VDB in a single
place.
* os_dep.c (GC_page_was_dirty, GC_page_was_ever_dirty): Compute
PHT_HASH(h) only once (store result to a local variable).

* doc/README.solaris2: Update.

* include/private/gcconfig.h (end, InitStackBottom): Declare
extern variable for RTEMS.
* include/private/gcconfig.h (DATASTART, DATAEND, STACKBOTTOM):
Update (for RTEMS).
* include/private/gcconfig.h (DATAEND): Fix a typo in the macro
name (for RTEMS).
* tests/test.c (CONFIGURE_APPLICATION_DOES_NOT_NEED_CLOCK_DRIVER):
Replace with CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER (for RTEMS).

* include/private/gcconfig.h (MPROTECT_VDB): Enable for Solaris in
single-threaded environment.

* include/private/gcconfig.h (MPROTECT_VDB): Undefine if PROC_VDB.
* tests/test.c (NUMBER_ROUND_UP): New macro.
* tests/test.c (check_heap_stats): Round up total expected heap
size to the nearest 4 MiB bound.
* tests/test.c (check_heap_stats): Print the current and expected
heap sizes in case of failure.

* checksums.c (GC_check_blocks, GC_check_dirty): Do log printing
only if GC_print_stats; print errors using GC_err_printf.
* checksums.c (GC_check_blocks): Join adjacent printf() calls into
a single one.

* pthread_support.c (pthread_join): Add assertion (check thread is
finished).
* pthread_support.c (GC_register_my_thread): Don't detach the
thread if invoked from the thread destructor.
* win32_threads.c (GC_register_my_thread): Likewise.
* win32_threads.c (GC_unregister_my_thread): Don't delete the
thread (just set FINISHED) if the thread is not detached (only if
GC_PTHREADS); add assertion (check the thread is not finished).
* tests/threadkey_test.c (main): Join some created threads.

* pthread_support.c (GC_delete_gc_thread): Rename "gc_id" local
variable to "t".
* win32_threads.c (GC_delete_gc_thread): Likewise.
* pthread_support.c (pthread_join, pthread_detach,
pthread_cancel): Rename "thread_gc_id" local variable to "t".
* win32_threads.c (GC_pthread_detach): Likewise.
* win32_threads.c (GC_delete_gc_thread): Remove "gc_nvid" local
variable.
* win32_threads.c (GC_pthread_join): Rename "joinee" local
variable to "t".

* pthread_stop_world.c (pthread_sigmask): Undefine even if not
DEBUG_THREADS.
* pthread_stop_world.c (GC_unblock_gc_signals): New function (only
if GC_EXPLICIT_SIGNALS_UNBLOCK).
* pthread_support.c (GC_unblock_gc_signals): New prototype.
* pthread_support.c (GC_register_my_thread_inner,
GC_register_my_thread): Call GC_unblock_gc_signals (only if
GC_EXPLICIT_SIGNALS_UNBLOCK); add comment.
* include/private/gcconfig.h (GC_EXPLICIT_SIGNALS_UNBLOCK): New
macro.

* pthread_stop_world.c (GC_suspend_handler_inner): Remove "dummy",
"sig" local variables; rename my_thread local variable to "self".

* tests/threadkey_test.c (LIMIT): Use smaller value (don't create
more than 30 in parallel by default).

* tests/threadkey_test.c (key_once, main): Work around for Solaris
PTHREAD_ONCE_INIT.
* tests/threadkey_test.c (LIMIT): Use smaller value for Solaris.

* dyn_load.c (GC_FirstDLOpenedLinkMap): Remove unused "r" local
variable.
* pthread_support.c (GC_unregister_my_thread_inner): Revert back
GC_remove_specific invocation; add a comment.
* include/private/thread_local_alloc.h (GC_remove_specific):
Revert back.
* specific.c (slow_getspecific): Cast qtid to AO_t.
* include/private/specific.h (key_create, setspecific,
remove_specific): Remove "extern" keyword.
* include/private/specific.h (getspecific): Change type of "qtid"
local variable to unsigned long.

* pthread_support.c (GC_check_tls): Fix "#endif" comment.
* include/gc.h (GC_REDIRECT_TO_LOCAL): Remove deprecated comment.
* include/private/thread_local_alloc.h (THREAD_LOCAL_ALLOC):
Remove redundant test of the macro.

* backgraph.c (add_edge): Recognize DEBUG_PRINT_BIG_N_EDGES macro.
* os_dep.c (GC_set_and_save_fault_handler): Recognize
SIGACTION_FLAGS_NODEFER_HACK macro.
* pthread_support.c (mark_mutex): Recognize GLIBC_2_1_MUTEX_HACK
macro.
* pthread_support.c (GC_acquire_mark_lock): Remove commented out
code.
* include/private/gc_priv.h (SUNOS5SIGS): Don't include
sys/siginfo.h on Linux.
* include/private/gcconfig.h (FORCE_WRITE_PREFETCH): New macro
recognized, force PREFETCH_FOR_WRITE to be defined on x86.
* include/private/gcconfig.h (USE_HPUX_FIXED_STACKBOTTOM): New
macro recognized (for HP/UX).

* os_dep.c (GC_gww_page_was_ever_dirty): Fix comment (for
GWW_VDB).
* os_dep.c (GC_dirty_init): Use memset() for GC_written_pages
resetting (for PROC_VDB).

* tests/threadkey_test.c: New file.
* tests/tests.am (TESTS, check_PROGRAMS): Add 'threadkey_test'.
* tests/tests.am (threadkey_test_SOURCES, threadkey_test_LDADD):
New variable.

* pthread_support.c (GC_unregister_my_thread_inner): Don't call
GC_remove_specific.
* include/private/thread_local_alloc.h (GC_remove_specific):
Remove (since it is empty for all targets).
* pthread_support.c (GC_record_stack_base): New inline function.
* win32_threads.c (GC_record_stack_base): Likewise.
* pthread_support.c (GC_register_my_thread_inner): Invoke
GC_record_stack_base.
* win32_threads.c (GC_register_my_thread_inner): Likewise.
* pthread_support.c (GC_register_my_thread): If thread is FINISHED
then call GC_record_stack_base, clear FINISHED, initialize
thread-local list and return success.
* win32_threads.c (GC_register_my_thread): Likewise.
* include/gc.h (GC_register_my_thread): Update documentation.
* include/private/thread_local_alloc.h (GC_thread_key): Likewise.

* thread_local_alloc.c (GC_malloc, GC_malloc_atomic): Join
adjacent "#ifdef".
* thread_local_alloc.c (GC_malloc_atomic): Call
GC_core_malloc_atomic (instead of GC_core_malloc).

* pthread_start.c (GC_start_rtn_prepare_thread): Change return
type to GC_thread.
* pthread_start.c (GC_inner_start_routine): Pass the current
thread descriptor to pthread_cleanup_push (same as in
win32_threads.c).
* pthread_stop_world.c (GC_push_all_stacks): Rename "me" local
variable to "self".
* win32_threads.c (GC_push_all_stacks): Likewise.
* pthread_stop_world.c (GC_suspend_all, GC_start_world): Rename
"my_thread" local variable to "self".
* pthread_support.c (GC_unregister_my_thread_inner): New static
function.
* pthread_support.c (GC_unregister_my_thread,
GC_thread_exit_proc): Use GC_unregister_my_thread_inner.
* win32_threads.c (GC_register_my_thread, GC_unregister_my_thread,
GC_do_blocking_inner): Rename "t" local variable to "thread_id".
* win32_threads.c (GC_wait_marker, GC_notify_all_marker): Rename
"id" local variable to "thread_id".

* pthread_support.c (GC_unregister_my_thread): Call pthread_self
only once.
* win32_threads.c (GC_pthread_start_inner): Likewise.
* pthread_support.c (GC_unregister_my_thread): Add debug output.
* win32_threads.c (GC_unregister_my_thread): Likewise.
* pthread_support.c (GC_register_my_thread,
GC_start_rtn_prepare_thread): Rename "my_pthread" local variable
to "self".

* include/gc.h (GC_HIDE_POINTER, GC_REVEAL_POINTER): Define
unconditionally (do not test GC_I_HIDE_POINTERS); update the
comment.
* include/gc.h (HIDE_POINTER, REVEAL_POINTER): Define as alias to
GC_HIDE/REVEAL_POINTER, respectively.
* include/private/gc_pmark.h (GC_I_HIDE_POINTERS): Do not define.
* include/private/gc_priv.h (GC_I_HIDE_POINTERS): Likewise.

* include/gc.h (GC_register_my_thread): Refine the comment.

* include/gc_inline.h (GC_MALLOC_WORDS, GC_CONS): Add missing
parentheses.
* include/gc_typed.h (GC_get_bit, GC_set_bit,
GC_CALLOC_EXPLICITLY_TYPED): Likewise.

* include/private/gcconfig.h (NO_GETCONTEXT): Add missing ')'.

* include/private/gcconfig.h (NO_GETCONTEXT): Do not use
getcontext(2) on m68k because it is not implemented there.

* alloc.c (GC_clear_a_few_frames): Use BZERO().
* mark_rts.c (GC_clear_roots, GC_rebuild_root_index): Likewise.
* reclaim.c (GC_start_reclaim): Likewise.
* blacklst.c (total_stack_black_listed): Remove "len" local
variable.
* dbg_mlc.c (GC_generate_random_valid_address): Replace "for"
statement with "do-while" one.
* dyn_load.c (GC_register_dynamic_libraries,
GC_register_dynlib_callback): Remove redundant parentheses.

* cord/cordxtra.c (CORD_from_file_lazy_inner): Suppress
"unused result" compiler warning for fread().

* os_dep.c (GC_write_fault_handler): Break when in_allocd_block
is set to true.

* dbg_mlc.c (GC_has_other_debug_info): Change return type to int;
return -1 if the object has (or had) debugging info but was
marked deallocated.
* include/private/dbg_mlc.h (GC_has_other_debug_info): Likewise.
* dbg_mlc.c (GC_has_other_debug_info): Update documentation;
remove "ohdr" local variable.
* dbg_mlc.c (GC_debug_free): Don't call GC_free if the object has
probably been deallocated.
* dbg_mlc.c (GC_debug_free): Don't actually free the object even
in the leak-finding mode if GC_findleak_delay_free.
* dbg_mlc.c (GC_check_leaked): New function (only unless
SHORT_DBG_HDRS).
* doc/README.environment (GC_FINDLEAK_DELAY_FREE): Document.
* doc/README.macros (GC_FINDLEAK_DELAY_FREE): Likewise.
* include/private/dbg_mlc.h (START_FLAG, END_FLAG): Use GC_WORD_C
on 64-bit architectures.
* include/private/dbg_mlc.h (NOT_MARKED): Remove redundant
parentheses.
* include/private/dbg_mlc.h (GC_HAS_DEBUG_INFO): Update (due to
GC_has_other_debug_info change).
* include/private/gc_priv.h (GC_findleak_delay_free): New global
variable declaration (unless SHORT_DBG_HDRS).
* misc.c (GC_findleak_delay_free): New global variable; recognize
GC_FINDLEAK_DELAY_FREE.
* misc.c (GC_init): Recognize GC_FINDLEAK_DELAY_FREE environment
variable (unless SHORT_DBG_HDRS).
* reclaim.c (GC_check_leaked): Declare (unless SHORT_DBG_HDRS).
* reclaim.c (GC_add_leaked): Don't add the object to leaked list
if marked as deallocated.

* dbg_mlc.c (GC_has_other_debug_info): Fix punctuation in the
comment.
* dbg_mlc.c (GC_FREED_MEM_MARKER): New macro.
* dbg_mlc.c (GC_debug_free): Use GC_FREED_MEM_MARKER.
* dbg_mlc.c (GC_smashed): Refine documentation.
* mark.c (GC_push_selected): Change dirty_fn return type to
GC_bool.
* os_dep.c (GC_page_was_ever_dirty): Make GC_INNER.
* reclaim.c (GC_reclaim_small_nonempty_block): Remove "kind"
local  variable.
* reclaim.c (GC_reclaim_block): Pass true constant to
GC_reclaim_small_nonempty_block (instead of report_if_found).
* doc/README.autoconf: Update; fix a typo.
* include/private/gcconfig.h (GC_WORD_C): New macro.

* dbg_mlc.c (GC_store_debug_info_inner): Cast "linenum".
* dbg_mlc.c (GC_check_annotated_obj): Fix punctuation in the
comment.
* dbg_mlc.c (GC_print_smashed_obj): Add (and print) "msg"
argument.
* dbg_mlc.c (GC_debug_free, GC_print_all_smashed_proc): Pass
message to GC_print_smashed_obj.
* dbg_mlc.c (GC_debug_free): Call GC_size once.
* dbg_mlc.c (GC_debug_realloc): Calculate old_sz only if
allocation succeeded; remove unnecessary check for object is
smashed (since this is done in GC_debug_free); remove "clobbered"
local variable.

* dbg_mlc.c (GC_store_debug_info_inner, GC_store_debug_info):
Rename "integer" argument to "linenum"; change the type of the
argument to int.
* gcj_mlc.c (GC_store_debug_info): Likewise.
* dbg_mlc.c (GET_OH_LINENUM): New macro.
* dbg_mlc.c (GC_print_obj, GC_print_smashed_obj): Use
GET_OH_LINENUM; adjust print format specifier.
* dbg_mlc.c (GC_debug_malloc, GC_debug_malloc_ignore_off_page,
GC_debug_malloc_atomic_ignore_off_page,
GC_debug_generic_malloc_inner,
GC_debug_generic_malloc_inner_ignore_off_page,
GC_debug_malloc_stubborn, GC_debug_malloc_atomic,
GC_debug_malloc_uncollectable,
GC_debug_malloc_atomic_uncollectable): Remove unnecessary cast of
"i".
* gcj_mlc.c (GC_debug_gcj_malloc): Likewise.

* os_dep.c (GC_linux_stack_base): Rename to
GC_linux_main_stack_base.
* os_dep.c (GC_freebsd_stack_base): Rename to
GC_freebsd_main_stack_base; adjust error message.
* pthread_stop_world.c (GC_stop_init): Use GC_SEM_INIT_PSHARED
as an argument for sem_init().
* pthread_support.c (pthread_create): Likewise.
* pthread_support.c (pthread_create): Abort in case sem_init()
fails.
* include/private/gc_priv.h (GC_SEM_INIT_PSHARED): Define.
* tests/initsecondarythread.c: Include gcconfig.h; call GC_INIT
from main() if it should be done from the primordial thread only.

* alloc.c: Don't include sys/types.h for ArmCC.
* dyn_load.c: Likewise.
* os_dep.c: Likewise.
* mach_dep.c (_setjmp, _longjmp): Redirect to setjmp/longjmp for
ArmCC.
* mark.c (GC_noop): Define specially for ArmCC.
* include/private/gc_priv.h (GC_noop): Likewise.
* misc.c (GC_init): Don't test pointers comparison for ArmCC.
* misc.c: Don't include unistd.h for ArmCC.
* os_dep.c (pages_executable): Rename to GC_pages_executable;
make STATIC.
* os_dep.c (GC_unix_mmap_get_mem): Don't define for ArmCC.
* ptr_chck.c (GC_is_visible): Explicitly cast
(GC_DS_PER_OBJECT-GC_INDIR_PER_OBJ_BIAS) to word (to suppress
a compiler warning).
* include/private/gcconfig.h: Recognize __arm.
* include/private/gcconfig.h (HBLKPTR): Define for ArmCC.
* include/private/gcconfig.h (HBLKPTR): Add parentheses for
"bytes" argument.

* pthread_support.c (GC_get_nprocs): Don't define for Android.
* pthread_support.c (GC_dummy_thread_local): Don't test
GC_LINUX_THREADS.
* include/gc_config_macros.h (GC_ADD_CALLER, GC_RETURN_ADDR):
Define for Android.

* mach_dep.c (NO_GETCONTEXT): Move to gcconfig.h.
* os_dep.c (GC_write_fault_handler): Don't include ucontext.h if
NO_GETCONTEXT.
* include/private/gcconfig.h (GETPAGESIZE): Define as a sysconf
call for Android.

* include/private/gc_locks.h (WIN32_LEAN_AND_MEAN, NOSERVICE):
Define before including windows.h.
* include/private/gc_priv.h (WIN32_LEAN_AND_MEAN, NOSERVICE):
Likewise.
* include/private/thread_local_alloc.h (WIN32_LEAN_AND_MEAN,
NOSERVICE): Likewise.
* include/private/gc_priv.h (MS_TIME_DIFF): Avoid floating-point
arithmetics; add a comment.

* mark.c (GC_clear_hdr_marks): Don't test USE_MARK_BYTES.
* extra/setjmp_t.c (main): Don't test USE_MARK_BITS.
* include/private/gc_pmark.h (SET_MARK_BIT_EXIT_IF_SET): Likewise.
* include/private/gc_pmark.h (SET_MARK_BIT_EXIT_IF_SET): Remove
"mark_byte" local variable.
* include/private/gc_pmark.h (OR_WORD_EXIT_IF_SET): Add a comment
about that AO_or() is not used by GC unless USE_MARK_BITS
explicitly set.
* include/private/gc_priv.h (OR_WORD): Likewise.
* include/private/gc_pmark.h (INCR_MARKS): Remove trailing ';',
add parentheses.
* include/private/gc_priv.h (ONES): Define before use by
MAKE_COOLER.
* include/private/gc_priv.h (MARK_BITS_SZ): Define where used.
* include/private/gc_priv.h (OR_WORD): Don't define if
USE_MARK_BYTES.
* include/private/gcconfig.h (USE_MARK_BYTES); Remove duplicate
definition; simplify expression.

* os_dep.c (GC_get_maps): Always close the file.
* pthread_support.c (GC_get_nprocs): Likewise.
* os_dep.c (READ): Define similarly across the file (without
parameters).
* pthread_support.c (GC_get_nprocs): Use signed int type for "i"
and "len" local variables (since read() may return -1).
* include/private/gc_pmark.h (LONG_MULT): Add prefix/suffix
double underscore; add "volatile" for asm.
* include/private/gc_pmark.h (LONG_MULT): Add missing
parentheses.
* include/private/gc_priv.h (OR_WORD): Likewise.
* include/private/gc_priv.h (OR_WORD): Remove unnecessary brackets
and ';' symbol.

* os_dep.c (GC_get_stack_base): Implement for Android (same as
for Linux).
* pthread_support.c (GC_get_nprocs): Return 1 (instead of -1) if
failed to open "stat" file (not to issue a warning twice); update
the comment.
* pthread_support.c (GC_thr_init): Call sysconf() on Android to
get the number of CPUs.

* include/private/gc_priv.h (_GNU_SOURCE): Revert one of the
recent patches regarding this macro as the macro should be set
(to 1) before including any other system header.

* doc/README.environment (GC_INITIAL_HEAP_SIZE,
GC_MAXIMUM_HEAP_SIZE): Update.

* misc.c (GC_parse_mem_size_arg): Allow 'k', 'M', 'G' suffixes in
heap size specifier; return 0 if not a valid one.
* include/gc_cpp.h: Explicitly define inline one-argument delete
operator for Cygwin (as a workaround).
* tests/test_cpp.cc (main): Suppress compiler warnings about
"assigned value is unused".

* misc.c (GC_parse_mem_size_arg): New function.
* misc.c (GC_init): Use GC_parse_mem_size_arg().
* pthread_stop_world.c (tkill): Declare for Android.

* include/private/gc_priv.h (_GNU_SOURCE): Include features.h
first (except for NaCl) and then define the macro to 1 if not yet.

* tests/tests.am (TESTS, check_PROGRAMS): Add
'initsecondarythread'.
* tests/tests.am (initsecondarythread_SOURCES,
initsecondarythread_LDADD): New variable.

* dbg_mlc.c (GC_store_debug_info_inner): Always define; add
"const" to its string argument.
* dbg_mlc.c (GC_store_debug_info): Call GC_store_debug_info_inner.
* dbg_mlc.c (GC_debug_free): Set GC_have_errors in case of
smashed or previously deallocated found.
* dbg_mlc.c (GC_check_heap_block): Replace while loop with a for
one.
* reclaim.c (GC_reclaim_check): Likewise.
* dbg_mlc.c (GC_check_heap_proc): Remove redundant cast to word.
* os_dep.c (GC_get_stack_base): Don't initialize
stackbase_main_self/ss_sp on Solaris if thr_main() is zero (thus
calling GC_INIT() from a non-primordial thread is possible now).
* reclaim.c (GC_add_leaked): Turn into an inline one.
* reclaim.c (GC_reclaim_small_nonempty_block):
Change report_if_found type from int/word to boolean.
* include/private/gc_priv.h (GC_start_reclaim): Likewise.
* include/private/gc_priv.h (set_mark_bit_from_hdr,
clear_mark_bit_from_hdr): Place closing parenthesis properly.

* os_dep.c (GC_get_main_stack_base): Try to use
pthread_attr_getstack first for Linux if THREADS.
* doc/README.macros (USE_GET_STACKBASE_FOR_MAIN): Adjust text
alignment.

* dbg_mlc.c (GC_generate_random_backtrace_no_gc): Fix a message
typo.
* dbg_mlc.c (GC_debug_malloc): Add a comment (about zero size).
* dbg_mlc.c (GC_strdup): Call GC_err_printf instead of WARN (in
case of NULL argument).
* dbg_mlc.c (GC_free): In case of NULL argument, just return
(without any warning printed); eliminate "uncollectable" local
variable.

* configure.ac (THREADDLLIBS): Use alternate thread library on
Solaris 8.
* configure.ac (need_atomic_ops_asm): Set to true only for SPARC
Solaris.
* configure.ac: Don't use libdl on mips-sgi-irix6.

* mach_dep.c (NO_GETCONTEXT); Define for RTEMS.
* mach_dep.c (GC_with_callee_saves_pushed): Don't call
__builtin_unwind_init() for RTEMS; use setjmp() without the
leading underscore (for RTEMS).
* tests/test.c (BIG): Use smaller value for RTEMS.
* tests/test.c (main): Customize for RTEMS.

* configure.host: Remove doubled words in comments.
* os_dep.c: Likewise.
* doc/README: Likewise.
* extra/setjmp_t.c: Likewise.
* tests/huge_test.c: Likewise.
* extra/setjmp_t.c (getpagesize, nested_sp, main, g): Replace the
K&R-style function definition with the ANSI C one.
* extra/setjmp_t.c (nested_sp): Implement in the same way as
GC_approx_sp.

* dyn_load.c (GC_dyld_sections): Add more sections.
* dyn_load.c (GC_dyld_add_sect_fmts): New static variable.
* dyn_load.c (L2_MAX_OFILE_ALIGNMENT): New macro.
* dyn_load.c (GC_dyld_image_add, GC_dyld_image_remove): Improve
logging; add support for on-demand sections.

* gcj_mlc.c (GC_gcj_malloc_initialized): Use STATIC unless
GC_ASSERTIONS.
* include/private/gc_priv.h (GC_gcj_malloc_initialized): Don't
declare (as external) unless GC_ASSERTIONS.
* os_dep.c (GC_win32_free_heap): Clear GC_heap_bases[] also for
Cygwin; add FIXME.
* include/private/gcconfig.h: Include <sys/unistd.h> for RTEMS.
* include/private/gcconfig.h: Add "#error" for every "-->" mark.
* include/private/gcconfig.h (CLEAR_DOUBLE): Turn the code into
an expression.
* include/private/pthread_support.h (SUSPENDED_EXT): Add new flag
(which existed previously as SUSPENDED and still exists in GCJ).
* include/private/pthread_support.h (DISABLED_GC): Change the
value (as it is already used by SUSPENDED_EXT).

* tests/test.c (reverse_test):  Modify count (BIG) for
ppc64-darwin.

* reclaim.c (GC_print_all_errors): Recognize new GC_ABORT_ON_LEAK
macro and environment variable; abort if any error has been
printed provided the environment variable (or macro) is set.
* doc/README.environment (GC_ABORT_ON_LEAK): Document.
* doc/README.macros (GC_ABORT_ON_LEAK): Likewise.

* os_dep.c (GC_unix_sbrk_get_mem, GC_unix_get_mem): Don't define
for RTEMS.
* include/private/gcconfig.h (RTEMS): Add support for.
* include/private/gcconfig.h (GET_MEM): Use calloc() for RTEMS.

* mallocx.c (GC_malloc_uncollectable): Move to malloc.c (since
it is used internally in some places).

* dbg_mlc.c (GC_register_finalizer_no_order): Remove redundant
declaration.
* dbg_mlc.c (GC_debug_malloc_replacement,
GC_debug_realloc_replacement): Rename RA to GC_DBG_RA.
* malloc.c (GC_debug_malloc_replacement): Likewise.
* mallocx.c (GC_debug_realloc_replacement): Likewise.
* dbg_mlc.c (GC_store_debug_info): Move proto from dbg_mlc.h.
* malloc.c (GC_strdup, GC_strndup, GC_wcsdup): Move to mallocx.c.
* malloc.c: Include errno.h only REDIRECT_MALLOC; remove redundant
includes of string.h.
* mallocx.c: Include string.h (for GC_strdup).
* include/private/dbg_mlc.h (GC_store_debug_info): Move declaration
to dbg_mlc.c.
* include/private/gc_locks.h (UNCOND_LOCK, UNCOND_UNLOCK): Remove
redundant trailing ';'.
* include/private/gc_priv.h (START_WORLD, COND_DUMP): Likewise.
* include/private/gc_locks.h (LOCK, UNLOCK): Place opening '{'
properly.
* include/private/gc_priv.h (GC_DBG_RA): Move from dbg_mlc.c,
malloc.c, mallocx.c.

* alloc.c (GC_check_heap, GC_print_all_smashed): Move the
definition from misc.c.
* dbg_mlc.c (GC_debug_malloc_atomic_uncollectable): Define as
public.
* include/gc.h (GC_debug_malloc_atomic_uncollectable): Declare.
* include/gc.h (GC_MALLOC_ATOMIC_UNCOLLECTABLE): Define new public
macro.
* dbg_mlc.c (MAX_SMASHED): Don't define if already set.
* reclaim.c (MAX_LEAKED): Likewise.
* dbg_mlc.c (GC_add_smashed): Add FIXME about the concurrent
access to the global array.
* reclaim.c (GC_add_leaked): Likewise.
* misc.c (GC_print_back_height): Set on if GC_PRINT_BACK_HEIGHT
(new macro) is defined.
* doc/README.macros (GC_PRINT_BACK_HEIGHT): Document.
* misc.c (GC_dump_regularly, GC_init): Replace 0/1 for
GC_dump_regularly and GC_print_back_height variables with
FALSE/TRUE.
* reclaim.c (GC_print_all_errors): Refine the comment.

* tests/test.c (reverse_test_inner): Undo one of the previous
patches which shifts "c" and "d" pointers only if
ALL_INTERIOR_POINTERS (since interior pointers are always
recognized in stacks).

* misc.c (GC_stdout, GC_stderr): Move the definition to the place
where GC_log is defined (Unix only).
* misc.c (GC_init): Recognize "GC_ONLY_LOG_TO_FILE" environment
variable and the similar macro; redirect GC_stdout and GC_stderr
to GC_log if "GC_LOG_FILE" environment variable is set unless
prohibited by GC_ONLY_LOG_TO_FILE (Unix only).
* doc/README.environment (GC_ONLY_LOG_TO_FILE): Document.
* doc/README.macros (GC_ONLY_LOG_TO_FILE): Likewise.

* misc.c (GC_stdout, GC_write): Rename GC_stdout to GC_log (Win32
only).
* misc.c (GC_write): Add for MacOS (and OS/2); change WRITE()
accordingly.
* misc.c (GC_printf): Check GC_quiet before va_start().

* allchblk.c (GC_freehblk): Use GC_log_printf instead of GC_printf
inside "if (GC_print_stats)" branch.
* alloc.c (GC_collect_or_expand): Likewise.
* dyn_load.c (GC_register_dynamic_libraries): Likewise.
* headers.c (GC_scratch_alloc): Likewise.
* os_dep.c (GC_get_maps, GC_remap, PROTECT,
GC_write_fault_handler, GC_dirty_init, GC_mprotect_thread): Likewise.
* alloc.c (min_bytes_allocd): Use GC_log_printf instead of
GC_printf for DEBUG_THREADS output.
* darwin_stop_world.c (GC_stack_range_for, GC_suspend_thread_list,
GC_stop_world, GC_thread_resume, GC_start_world): Likewise.
* pthread_start.c (GC_inner_start_routine): Likewise.
* pthread_stop_world.c (GC_suspend_handler, GC_restart_handler,
GC_push_all_stacks, GC_suspend_all, GC_stop_world,
GC_start_world): Likewise.
* pthread_support.c (GC_mark_thread, GC_get_nprocs,
GC_start_rtn_prepare_thread, pthread_create): Likewise.
* checksums.c (GC_update_check_page): Use GC_printf() instead of
GC_err_printf() for error printing.
* checksums.c (GC_check_blocks, GC_check_dirty): Use GC_log_printf
instead of GC_printf for logging purposes.
* dyn_load.c (sys_errlist, sys_nerr, errno): Move declaration of
external variable outside from GC_register_dynamic_libraries.
* dyn_load.c (GC_register_dynamic_libraries): Don't use
sys_errlist value if errno equals to sys_nerr.
* dyn_load.c (GC_register_dynamic_libraries): Use GC_log_printf
instead of GC_printf for DL_VERBOSE output.
* dyn_load.c (GC_dyld_image_add, GC_dyld_image_remove,
GC_init_dyld): Use GC_log_printf instead of GC_printf for
DARWIN_DEBUG output.
* os_dep.c (catch_exception_raise): Use GC_log_printf
instead of GC_printf for DEBUG_EXCEPTION_HANDLING output.
* reclaim.c (GC_print_free_list): Move "n" increment out of
GC_printf() call.

* win32_threads.c (DEBUG_CYGWIN_THREADS, DEBUG_WIN32_PTHREADS,
DEBUG_WIN32_THREADS): Remove.
* win32_threads.c (GC_register_my_thread_inner,
GC_win32_start_inner): Use GC_log_printf instead of GC_printf
inside "if (GC_print_stats)" branch.
* win32_threads.c (GC_PTHREAD_PTRVAL): New macro (defined only if
GC_PTHREADS).
* win32_threads.c (GC_delete_gc_thread, NUMERIC_THREAD_ID,
GC_pthread_join, GC_pthread_create): Use GC_PTHREAD_PTRVAL
macro.
* win32_threads.c (GC_push_stack_for, GC_mark_thread,
GC_CreateThread, GC_beginthreadex, GC_pthread_join,
GC_pthread_create, GC_pthread_start_inner, GC_thread_exit_proc,
GC_mark_thread_local_free_lists): Use GC_log_printf instead of
GC_printf for DEBUG_THREADS output.
* win32_threads.c (GC_win32_start_inner, GC_CreateThread,
GC_beginthreadex, GC_pthread_join, GC_pthread_create,
GC_pthread_start_inner, GC_thread_exit_proc): Cast
GetCurrentThreadId result to long; don't cast value of pthread_t
type to int; adjust printf format specifiers.
* doc/README.win32 (DEBUG_WIN32_PTHREADS): Remove obsolete
information.

* tests/test.c (cons, small_cons, gcj_cons, check_ints,
check_uncollectable_ints, print_int_list, check_marks_int_list,
fork_a_thread, finalizer, mktree, chktree, alloc8bytes,
alloc_small, tree_test, typed_test, check_heap_stats, WinMain,
test, main): Remove unnecessary casts of GC_printf calls to void.

* allchblk.c (GC_print_hblkfreelist): Adjust (make uniform across
BDWGC) printed message (adjust letters case, terminating dot and
new line symbols).
* alloc.c (GC_check_fl_marks): Likewise.
* backgraph.c (new_back_edges): Likewise.
* checksums.c (GC_check_dirty): Likewise.
* darwin_stop_world.c (GC_push_all_stacks,
GC_suspend_thread_list): Likewise.
* dbg_mlc.c (GC_print_type, GC_debug_free, GC_debug_realloc,
store_old): Likewise.
* dyn_load.c (GC_register_dynamic_libraries): Likewise.
* mark.c (GC_initiate_gc, GC_mark_some, GC_mark_from, GC_push_all,
GC_push_selected, GC_push_next_marked_dirty): Likewise.
* mark_rts.c (GC_exclude_static_roots_inner): Likewise.
* os_dep.c (GC_remap, GC_default_push_other_roots,
GC_push_thread_structures, GC_dirty_init, GC_read_dirty,
catch_exception_raise_state, catch_exception_raise_state_identity,
GC_mprotect_thread_notify, GC_mprotect_thread,
catch_exception_raise): Likewise.
* pthread_stop_world.c (GC_print_sig_mask, GC_push_all_stacks,
GC_stop_world, GC_stop_init): Likewise.
* pthread_support.c (GC_thr_init, GC_register_my_thread_inner,
GC_start_routine): Likewise.
* win32_threads.c (GC_register_my_thread_inner,
GC_push_all_stacks, GC_win32_start_inner, GC_pthread_join,
GC_pthread_start_inner): Likewise.
* alloc.c (GC_expand_hp_inner): Realign the code.
* mark.c (GC_mark_from, GC_mark_local, GC_do_parallel_mark):
Likewise.
* misc.c (GC_init): Likewise.
* os_dep.c (GC_dirty_init, GC_read_dirty): Likewise.
* include/private/gc_pmark.h (PUSH_CONTENTS_HDR): Likewise.
* tests/test.c (run_one_test): Likewise.
* misc.c (GC_err_puts): Document.
* misc.c (GC_err_write): Remove.
* os_dep.c (dump_maps): Likewise.
* include/private/gc_priv.h (GC_err_write): Likewise.
* os_dep.c (GC_print_address_map): Call GC_err_puts() instead of
dump_maps() and GC_err_write().
* os_dep.c (GC_read_dirty): Remove redundant brackets.

* tests/test.c (reverse_test_inner): Test interior pointer
recognition only if ALL_INTERIOR_POINTERS.
* tests/test.c (run_one_test): Replace GC_all_interior_pointers
with GC_get_all_interior_pointers(); simplify the expression.
* tests/test.c (check_heap_stats): Replace GC_bytes_allocd and
GC_bytes_allocd_before_gc with GC_get_total_bytes().
* tests/test.c (main): Replace GC_gc_no with GC_get_gc_no().

* dbg_mlc.c (GC_debug_strdup, GC_debug_free): Output a portability
warning if the argument is NULL and GC is in leaks detection mode.
* dbg_mlc.c (GC_debug_strndup, GC_debug_wcsdup): New public
function definition.
* malloc.c (GC_strndup, GC_wcsdup, strndup): Likewise.
* mallocx.c (GC_posix_memalign): Likewise.
* malloc.c (strdup): Fix string size value; rename "len" to "lb".
* mallocx.c: Include errno.h unless WinCE (otherwise include
windows.h for Win32 error constants).
* win32_threads.c: Define WIN32_LEAN_AND_MEAN and NOSERVICE before
windows.h inclusion.
* misc.c (GC_init): Register at-exit callback if GC_find_leak
(even if GC_FIND_LEAK macro is unset).
* pthread_stop_world.c (NACL_STORE_REGS,
__nacl_suspend_thread_if_needed, GC_nacl_initialize_gc_thread):
Use BCOPY() instead of memcpy().
* pthread_support.c (GC_init_real_syms): Likewise.
* doc/README.macros (GC_DEBUG_REPLACEMENT, GC_REQUIRE_WCSDUP):
Document new macro.
* doc/README.macros (REDIRECT_MALLOC): Update documentation.
* include/gc.h (GC_strndup, GC_posix_memalign, GC_debug_strndup):
New API function prototype.
* include/gc.h (GC_MALLOC, GC_REALLOC): Redirect to
GC_debug_malloc/realloc_replacement() if GC_DEBUG_REPLACEMENT.
* include/gc.h (GC_STRDUP): Remove redundant parentheses.
* include/leak_detector.h (realloc, strdup): Likewise.
* include/gc.h (GC_STRNDUP): New API macro.
* include/gc.h (GC_NEW, GC_NEW_ATOMIC, GC_NEW_STUBBORN,
GC_NEW_UNCOLLECTABLE): Add missing parentheses.
* include/gc.h (GC_wcsdup, GC_debug_wcsdup): New API function
prototype (only if GC_REQUIRE_WCSDUP).
* include/gc.h (GC_WCSDUP): New API macro (only if
GC_REQUIRE_WCSDUP).
* include/leak_detector.h: Include stdlib.h and string.h after gc.h (unless
GC_DONT_INCLUDE_STDLIB).
* include/leak_detector.h (malloc, calloc, free, realloc):
Undefine symbol before its redefinition.
* include/leak_detector.h (strndup, memalign, posix_memalign):
Redefine to the corresponding GC function.
* include/leak_detector.h (wcsdup): Redefine to GC_WCSDUP (only
if GC_REQUIRE_WCSDUP).
* include/leak_detector.h (CHECK_LEAKS): Add comment; don't define
the macro if already defined.

* misc.c (GC_abort): Use _exit() (instead of DebugBreak) on Win32
when doing code static analysis (to inform the tool that the
function is a no-return one).
* os_dep.c (GC_linux_stack_base): Remove a duplicate validation
of the length of "stat" file; use signed int type for "i",
"buf_offset" and "len" local variables (since read() may
return -1).

* blacklst.c (GC_bl_init_no_interiors): New function (the code
moved from GC_bl_init).
* blacklst.c (GC_bl_init): Invoke GC_bl_init_no_interiors unless
GC_all_interior_pointers mode; remove unnecessarily parameter cast
for GC_scratch_alloc call.
* include/private/gc_priv.h (GC_bl_init): Move the function
declaration to misc.c file.
* misc.c (GC_bl_init_no_interiors): Add a prototype.
* misc.c (GC_set_all_interior_pointers): Allow values other than 0
and 1; allow altering GC_set_all_interior_pointers value even
after GC initialization.
* obj_map.c (GC_initialize_offsets): Clear GC_valid_offsets and
GC_modws_valid_offsets if GC_all_interior_pointers is off.
* misc.c (GC_init): Don't call GC_initialize_offsets() unless
GC_all_interior_pointers mode.

* alloc.c (GC_finish_collection): Remove redundant brackets;
adjust code indentation.
* blacklst.c (GC_add_to_black_list_normal): Simplify expression
(to improve code readability).
* blacklst.c (GC_is_black_listed): Join nested "if" (into a single
conditional expression); initialize "nblocks" just before the loop
beginning.
* misc.c (GC_init): Don't compute initial_heap_sz if GC is already
initialized.
* include/private/gc_priv.h (GC_initialize_offsets): Move the
function declaration to misc.c file.
* obj_map.c (GC_initialize_offsets): Remove offsets_initialized
static variable since the function is called only once.
* tests/middle.c (main): Use setter for GC_all_interior_pointers;
adjust printf format specifier (and cast the value passed to).

* doc/README.macros (SMALL_CONFIG, LARGE_CONFIG): Refine the
documentation.
* include/private/gc_hdrs.h (LOG_BOTTOM_SZ): Ignore SMALL_CONFIG
if LARGE_CONFIG is defined.
* include/private/gc_priv.h (CPP_LOG_HBLKSIZE): Likewise.

* alloc.c (GC_finish_collection): Replace "#else #ifdef" with
"#elif".
* include/private/gc_priv.h (CPP_LOG_HBLKSIZE, LOG_PHT_ENTRIES,
MAX_ROOT_SETS, MAX_HEAP_SECTS): Likewise.
* alloc.c (GC_expand_hp_inner): Check for GC_collect_at_heapsize
overflow even if not LARGE_CONFIG.
* dbg_mlc.c (GC_check_heap_proc): Check "oh" size even if
SMALL_CONFIG.
* finalize.c (GC_print_finalization_stats): Fix "#endif" comment.
* doc/README.environment (GC_LOG_FILE, GC_PRINT_VERBOSE_STATS,
GC_FULL_FREQUENCY): Refine the documentation.

* extra/msvc_dbg.c: Test _MSC_VER macro; include "gc.h" (for
GC_word).
* extra/msvc_dbg.c (ULONG_PTR): Replace with GC_ULONG_PTR; define
as word.

* dbg_mlc.c (GC_get_back_ptr_info, GC_print_obj,
GC_print_smashed_obj, GC_debug_free_inner): Add a code for a
LINT-like tool to instruct it that the function is invoked only
with valid parameters (otherwise a SEGV is ok); recognize LINT2
new macro.
* misc.c (GC_abort): Instruct a LINT-like tool that the function
never returns in fact.
* os_dep.c (GC_linux_stack_base): Check for read buffer overflow;
close the file immediately after read; use STRTOULL() instead of
decoding the address number manually.
* include/private/gc_priv.h (EXPECT): Don't specify outcome for a
LINT-like tool.
* include/private/gc_priv.h (GC_all_interior_pointers): Instruct a
LINT-like tool that the value is restricted to zero and one only
(required since the variable is global and its value is used as a
part of array index expression is some places).

* dbg_mlc.c (GC_make_closure): Fix SEGV in case GC_malloc returns
NULL.
* dbg_mlc.c (GC_debug_register_finalizer,
GC_debug_register_finalizer_no_order,
GC_debug_register_finalizer_unreachable,
GC_debug_register_finalizer_ignore_self): Handle out of memory
case properly (similar to GC_register_finalizer_inner).
* headers.c (GC_install_header): Handle the case when alloc_hdr()
returns NULL.
* os_dep.c (GC_get_maps_len): Defend against missing "maps" file.
* pthread_support.c (GC_mark_thread): Place a dummy return
statement (which uses "id" argument) before the actual use of "id"
as an array index (to suppress a warning produced by some static
code analysis tools).
* win32_threads.c (GC_mark_thread): Likewise.
* pthread_support.c (GC_thr_init): Abort (with the appropriate
message) if out of memory.

* finalize.c (GC_register_finalizer_inner): Fix a typo in a
comment.
*include/private/gcconfig.h (STACKBOTTOM): Likewise.
* gcj_mlc.c (GC_core_gcj_malloc): Replace 0/1 with TRUE/FALSE in
EXPECT (the 2nd argument).
* malloc.c (GC_core_malloc_atomic, GC_core_malloc, GC_free):
Likewise.
* mark.c (GC_mark_and_push, GC_mark_and_push_stack): Likewise.
* thread_local_alloc.c (GC_malloc, GC_malloc_atomic): Likewise.
* include/private/gc_hdrs.h (HC_GET_HDR): Likewise.
* include/private/gc_priv.h (SMALL_OBJ): Likewise.
* include/private/specific.h (getspecific): Likewise.
* pthread_support.c (LOCK_STATS): Add a comment.

* include/gc_pthread_redirects.h (GC_NO_DLOPEN,
GC_NO_PTHREAD_SIGMASK, GC_PTHREAD_CREATE_CONST,
GC_PTHREAD_EXIT_ATTRIBUTE, GC_NO_PTHREAD_CANCEL): Move the
definition to gc_config_macros.

* pthread_support.c (pthread_cancel, GC_pthread_cancel_t,
GC_pthread_cancel): Test GC_NO_PTHREAD_CANCEL (instead of NACL and
GC_PTHREAD_EXIT_ATTRIBUTE).
* include/gc_pthread_redirects.h (GC_pthread_cancel,
pthread_cancel): Likewise.
* pthread_support.c (GC_pthread_create, GC_pthread_sigmask,
GC_pthread_join, GC_pthread_detach, GC_pthread_cancel): Realign
code.
* include/gc_pthread_redirects.h (GC_PTHREAD_EXIT_ATTRIBUTE):
Define as empty for NaCl.
* include/gc_pthread_redirects.h (GC_NO_PTHREAD_CANCEL): New macro
defined.

* dyn_load.c (GC_init_dyld): Do not invoke
_dyld_bind_fully_image_containing_address() if GC_no_dls (as it is
not required to register the main data segment in that case).
* include/gc.h (GC_no_dls): Adjust the comment.

* dyn_load.c (GC_MUST_RESTORE_REDEFINED_DLOPEN): Test
GC_NO_DLOPEN.
* gc_dlopen.c: Likewise.
* include/gc_pthread_redirects.h (GC_dlopen, dlopen): Likewise.
* gc_dlopen.c: Don't include dlfcn.h (as it is included in
gc_pthread_redirects.h).
* pthread_support.c (pthread_sigmask, GC_pthread_sigmask_t,
GC_pthread_sigmask): Test GC_NO_PTHREAD_SIGMASK (instead of
GC_DARWIN_THREADS, GC_OPENBSD_THREADS and NACL).
* include/gc_pthread_redirects.h (GC_pthread_sigmask,
pthread_sigmask): Likewise.
* win32_threads.c (pthread_sigmask, GC_pthread_sigmask): Test
GC_NO_PTHREAD_SIGMASK (instead of GC_WIN32_PTHREADS).
* pthread_support.c (pthread_create, GC_pthread_create_t,
GC_pthread_create): Rename GC_PTHREAD_CONST to
GC_PTHREAD_CREATE_CONST.
* win32_threads.c (GC_pthread_create): Likewise.
* include/gc_pthread_redirects.h: Likewise.
* include/gc_pthread_redirects.h (GC_NO_DLOPEN,
GC_NO_PTHREAD_SIGMASK): New macro defined.
* include/gc_pthread_redirects.h (GC_PTHREAD_CREATE_CONST): Set to
empty for NaCl.
* include/gc_pthread_redirects.h (GC_PTHREAD_EXIT_ATTRIBUTE): Do
not define for Android (as CANCEL_SAFE is not defined).

* include/gc.h (GC_ADD_CALLER, GC_RETURN_ADDR,
GC_HAVE_BUILTIN_BACKTRACE, GC_CAN_SAVE_CALL_STACKS): Move
definition to gc_config_macros.h file.
* include/gc_config_macros.h: Check the file is included from gc.h
file.
* include/gc_version.h: Likewise.

* gc_dlopen.c: Empty unit for NaCl.
* os_dep.c: Include fcntl.h for NaCl.
* os_dep.c (GC_get_main_stack_base): Ignore
USE_GET_STACKBASE_FOR_MAIN macro for NaCl.
* os_dep.c (GC_get_stack_base): Return GC_UNIMPLEMENTED for NaCl.
* os_dep.c (GC_remap): Use mmap (instead of mprotect) for NaCl.
* pthread_start.c (GC_inner_start_routine): Don't invoke
pthread_cleanup_push/pop for NaCl.
* pthread_stop_world.c (GC_nacl_num_gc_threads,
GC_nacl_thread_idx, GC_nacl_park_threads_now,
GC_nacl_thread_parker, GC_nacl_gc_thread_self,
GC_nacl_thread_parked, GC_nacl_thread_used,
GC_nacl_thread_parking_inited, GC_nacl_thread_alloc_lock): New
variable (fo NaCl only).
* pthread_stop_world.c (GC_remove_allowed_signals,
suspend_handler_mask, GC_stop_count, GC_world_is_stopped,
GC_retry_signals, SIG_THR_RESTART, GC_suspend_ack_sem,
GC_restart_ack_sem, GC_suspend_handler_inner, GC_suspend_handler,
GC_restart_handler): Don't define for NaCl.
* pthread_support.c (GC_get_nprocs): Likewise.
* include/private/gc_priv.h (SIG_SUSPEND): Likewise.
* include/private/gcconfig.h (LINUX): Likewise.
* pthread_stop_world.c (GC_push_all_stacks): Push register storage
for NaCl.
* pthread_stop_world.c (GC_suspend_all, GC_stop_world,
GC_start_world): Implement for NaCl.
* pthread_stop_world.c (GC_stop_world): Don't define unused "i"
local variable for OpenBSD (and NaCl).
* pthread_stop_world.c (NACL_STORE_REGS): New macro definition for
NaCl.
* pthread_stop_world.c (nacl_pre_syscall_hook,
__nacl_suspend_thread_if_needed, nacl_post_syscall_hook,
GC_nacl_initialize_gc_thread, GC_nacl_shutdown_gc_thread): New
function (for NaCl only).
* pthread_stop_world.c (GC_stop_init): Empty for NaCl.
* pthread_support.c (pthread_cancel, pthread_sigmask): Don't
redirect for NaCl.
* include/gc_pthread_redirects.h (pthread_cancel,
pthread_sigmask): Likewise.
* pthread_support.c (GC_nacl_initialize_gc_thread,
GC_nacl_shutdown_gc_thread): New internal prototype (NaCl only).
* pthread_support.c (GC_new_thread, GC_delete_thread): Initialize
and shutdown thread for NaCl.
* pthread_support.c (GC_thr_init): Call sysconf for NaCl.
* pthread_support.c (GC_pthread_exit): Call GC_thread_exit_proc
for NaCl.
* include/gc.h: Don't include features.h for NaCl.
* include/gc_pthread_redirects.h (GC_PTHREAD_CONST): New macro.
* include/gc_pthread_redirects.h (GC_pthread_create): Use
GC_PTHREAD_CONST instead of const.
* win32_threads.c (GC_pthread_create): Likewise.
* pthread_support.c (GC_pthread_create_t, GC_pthread_create,
pthread_create): Likewise.
* include/private/gcconfig.h (NACL): Recognize NaCl.
* include/private/gcconfig.h (GC_LINUX_THREADS): Valid for NaCl.
* include/private/pthread_stop_world.h (thread_stop_info): Add
reg_storage member; define NACL_GC_REG_STORAGE_SIZE macro (for
NaCl only).
* include/private/pthread_support.h (GC_nacl_gc_thread_self):
Declare internal variable (for NaCl only).

* mach_dep.c (GC_with_callee_saves_pushed): Fix FE_ALL_EXCEPT
macro.

* mark.c (GC_mark_some): Prefix and suffix "asm" and "volatile"
keywords with double underscore.
* os_dep.c (catch_exception_raise, catch_exception_raise_state,
catch_exception_raise_state_identity): Add GC_API_OSCALL to
function definition.
* os_dep.c (catch_exception_raise_state,
catch_exception_raise_state_identity): Move definition to be
before GC_ports.
* os_dep.c (catch_exception_raise): Declare to have the symbol
defined before GC_ports.
* os_dep.c (GC_ports): Store references to catch_exception_raise,
catch_exception_raise_state, catch_exception_raise_state_identity
(to prevent stripping these symbols as dead).
* os_dep.c (catch_exception_raise, catch_exception_raise_state,
catch_exception_raise_state_identity): Mark these symbols as
"referenced dynamically" via an assembler directive (unless
NO_DESC_CATCH_EXCEPTION_RAISE).
* include/private/gc_priv.h (GC_API_OSCALL): New macro (defined
similar to GC_API but as if GC_DLL is always defined).

* os_dep.c: Don't include signal.h for GC_write_fault_handler on
Win32.
* os_dep.c (SIG_OK): Don't return true unless SIGSEGV or SIGBUS on
FreeBSD.
* os_dep.c (CODE_OK): Use SEGV_ACCERR on FreeBSD (define
SEGV_ACCERR for older FreeBSD releases).

* dyn_load.c (GC_register_map_entries,
GC_register_dynamic_libraries_dl_iterate_phdr): Calculate
DATASTART only once if DATASTART_IS_FUNC.
* dyn_load.c (GC_register_dynamic_libraries_dl_iterate_phdr):
Calculate DATAEND only once if DATAEND_IS_FUNC.
* dyn_load.c: Add comment to some endif; realign some code.
* dyn_load.c (GC_init_dyld): Don't use
_dyld_bind_fully_image_containing_address if
NO_DYLD_BIND_FULLY_IMAGE defined; add FIXME.
* include/private/gcconfig.h (GC_data_start, GC_find_limit):
Declare if used by DATASTART/DATAEND, respectively.
* include/private/gcconfig.h (DATASTART_IS_FUNC, DATAEND_IS_FUNC):
Define if DATASTART/DATAEND is a function, respectively.
* include/private/gcconfig.h (GETPAGESIZE, NO_PTHREAD_TRYLOCK,
NO_DYLD_BIND_FULLY_IMAGE): Define for Darwin/arm as well; include
unistd.h.

* os_dep.c (GC_setpagesize, GC_task_self, PROTECT, UNPROTECT):
Reorder to remove redundant ifdef for Win32.
* os_dep.c: Add comment to some endif.
* os_dep.c: Include pthread.h (for Linux even if single-threaded)
if USE_GET_STACKBASE_FOR_MAIN; also include it for Darwin.
* os_dep.c (STACKBOTTOM): Redefine for Darwin (unless prohibited
for some reason).
* os_dep.c (GC_get_main_stack_base): Allow
USE_GET_STACKBASE_FOR_MAIN for Linux even if single-threaded; add
assertion for the returned result.
* os_dep.c (GC_get_stack_base): Define for Darwin if
multi-threaded.
* os_dep.c (SIG_OK, CODE_OK): Add comment (for FreeBSD).
* os_dep.c (ID_STOP, ID_RESUME): Define only if threads.
* os_dep.c (catch_exception_raise): Remove redundant parentheses;
refine the documentation.

* NT_MAKEFILE: Define _CRT_SECURE_NO_DEPRECATE for C++ files as
well.
* NT_STATIC_THREADS_MAKEFILE: Likewise.
* doc/README.macros (USE_GET_STACKBASE_FOR_MAIN): Refine.
* include/gc.h (GC_INIT): Document.
* include/private/gc_priv.h (GC_MACH_HEADER, GC_MACH_SECTION,
GC_GETSECTBYNAME): Define depending only on the word size (i.e.,
define these macros also for ARM).
* tests/test.c (check_heap_stats): Print main thread stack bottom
as well (only if verbose mode is on).

* mach_dep.c (GC_with_callee_saves_pushed): Fix and improve code
introduced by the previous patch (if GETCONTEXT_FPU_EXCMASK_BUG
and X86_64).

* darwin_stop_world.c (GC_FindTopOfStack): Prefix and suffix
"volatile" keyword with double underscore.
* mach_dep.c (GETCONTEXT_FPU_EXCMASK_BUG): Recognize new macro and
include fenv.h if defined (unless NO_GETCONTEXT or HAVE_PUSH_REGS).
* mach_dep.c (GC_with_callee_saves_pushed): Restore FPU exception
mask corrupted by getcontext if GETCONTEXT_FPU_EXCMASK_BUG.
* include/private/gcconfig.h (GETCONTEXT_FPU_EXCMASK_BUG): Define
for Linux/x64 (since its GLibc getcontext currently has the bug).

* allchblk.c (GC_use_entire_heap): Change type to int (as declared
in gc.h); set the default value depending on new GC_USE_ENTIRE_HEAP
macro.
* misc.c (GC_init): Test GC_USE_ENTIRE_HEAP environment variable to
alter the default value of GC_use_entire_heap.
* doc/README.environment (GC_USE_ENTIRE_HEAP): Document.
* doc/README.macros (GC_USE_ENTIRE_HEAP): Likewise.

* include/private/gcconfig.h (PARALLEL_MARK): Do not make it cause
MPROTECT_VDB undefining.

* include/private/gcconfig.h (DYNAMIC_LOADING): Fix filename in
the comment.

* include/private/gc_priv.h (_GC_arrays): Move the conditional
macro definitions (shortcuts for GC_arrays members) into the
structure body.

* darwin_stop_world.c (GC_mach_handler_thread,
GC_use_mach_handler_thread,
GC_darwin_register_mach_handler_thread): Define only if
MPROTECT_VDB.
* darwin_stop_world.c (GC_suspend_thread_list): Use
GC_mach_handler_thread and GC_use_mach_handler_thread only if
MPROTECT_VDB.
* darwin_stop_world.c (GC_stop_world): Reset GC_mach_threads_count
only if defined (i.e. unless GC_NO_THREADS_DISCOVERY).
* misc.c (GC_init): Fix comment for GWW_VDB.
* os_dep.c (DARWIN_EXC_STATE, DARWIN_EXC_STATE_COUNT,
DARWIN_EXC_STATE_T, DARWIN_EXC_STATE_DAR): New macros.
* os_dep.c (catch_exception_raise): Use DARWIN_EXC_STATE,
DARWIN_EXC_STATE_COUNT, DARWIN_EXC_STATE_T, DARWIN_EXC_STATE_DAR.
* pthread_support.c (GC_thr_init): Define "dummy" local variable
only unless GC_DARWIN_THREADS.
* include/private/gcconfig.h (MPROTECT_VDB): Define for Darwin
even in the single-threaded mode; define for iPhone/iPad.
* include/private/gcconfig.h (IA64): Remove unnecessary "ifdef"
around "undef".
* include/private/gcconfig.h (HEURISTIC1): Remove unused for
Cygwin.
* include/private/gcconfig.h (STACKBOTTOM): Use fixed address for
Darwin/arm (instead of HEURISTIC1).

* misc.c (GC_write): Replace multiple "ifdef/endif" with "elif"
(for ECOS and NOSYS).
* os_dep.c (GC_get_main_stack_base): Likewise.
* os_dep.c (GC_get_main_stack_base): Check
USE_GET_STACKBASE_FOR_MAIN macro before checking STACKBOTTOM one;
remove "dummy" variable (use result one instead).
* doc/README.macros (SN_TARGET_PS3): Document.
* extra/threadlibs.c (main): Don't output "-lpthread" (and "-ldl")
for Android.
* include/private/pthread_support.h: Fix comment for "endif".

* misc.c (GC_allocate_ml): Define global variable if SN_TARGET_PS3.
* misc.c (GC_init): Initialize GC_allocate_ml if SN_TARGET_PS3.
* os_dep.c (SIGSEGV): Define to dummy zero if SN_TARGET_PS3.
* os_dep.c (GC_unix_mmap_get_mem): Don't define if SN_TARGET_PS3.
* os_dep.c (GC_default_push_other_roots,
GC_push_thread_structures): Define for SN_TARGET_PS3.
* include/private/gc_locks.h (GC_allocate_ml, LOCK, UNLOCK): Define
for SN_TARGET_PS3.
* include/private/gcconfig.h (SN_TARGET_PS3): Recognize new macro
(Sony PS/3 target).
* include/private/gcconfig.h (THREADS): Define unconditionally if
SN_TARGET_PS3.
* include/private/gcconfig.h (GET_MEM): Define for SN_TARGET_PS3.

* alloc.c (GC_collect_or_expand): Replace NIL with NULL in message.
* dbg_mlc.c (GC_debug_malloc, GC_debug_malloc_ignore_off_page,
GC_debug_malloc_atomic_ignore_off_page,
GC_debug_generic_malloc_inner,
GC_generic_malloc_inner_ignore_off_page, GC_debug_malloc_stubborn,
GC_debug_malloc_atomic, GC_debug_malloc_uncollectable,
GC_debug_malloc_atomic_uncollectable): Likewise.
* gcj_mlc.c (GC_debug_gcj_malloc): Likewise.
* dbg_mlc.c (GC_check_annotated_obj): Replace NIL with NULL in a
comment.
* dyn_load.c (GC_FirstDLOpenedLinkMap): Likewise.
* mark_rts.c (GC_roots_present): Likewise.
* doc/README: Likewise.
* include/private/gc_hdrs.h (IS_FORWARDING_ADDR_OR_NIL): Likewise.
* include/private/gc_priv.h (_GC_arrays): Likewise.

* configure.ac: Use AC_CHECK_LIB() to check for pthread instead of
just blindly linking to -lpthread, as Android includes pthread
support within libc and does not provide a separate libpthread.
* dyn_load.c (GC_register_dynamic_libraries): Skip current link map
entry if l_addr is NULL (Android/bionic only).
* pthread_stop_world.c (android_thread_kill): New internal function
(Android only).
* pthread_stop_world.c (GC_suspend_all, GC_start_world): Call
android_thread_kill (based on tkill) instead of pthread_kill on
Android (since pthread_kill cannot be used safely on the platform).
* pthread_support.c (GC_new_thread): Store thread Id (obtained from
gettid) for use by android_thread_kill (Android only).
* include/private/pthread_support.h (GC_Thread_Rep): Add kernel_id
structure member (Android only).
* include/private/gcconfig.h: Recognize __x86_64 macro as a synonym
of __x86_64__ (Darwin); define __environ macro (Android on M68K).

* allchblk.c (GC_freehblk): Print extended error message (done via
GC_printf() before aborting with a short message) only if
GC_print_stats.
* dyn_load.c (GC_register_dynamic_libraries): Likewise.
* os_dep.c (GC_get_maps, GC_register_data_segments, GC_remap,
PROTECT, GC_write_fault_handler, GC_mprotect_thread): Likewise.
* pthread_stop_world.c (GC_start_world): Likewise.
* win32_threads.c (GC_register_my_thread_inner): Likewise.
* os_dep.c (GC_get_main_stack_base, GC_register_data_segments,
GC_dirty_init): Remove redundant print of an error message before
aborting with the same message.
* os_dep.c (GC_register_data_segments): Remove format specifier
from the string passed to GC_err_puts(); use ABORT instead of EXIT
(if invalid executable type).
* os_dep.c (GC_remap): Adjust printf format specifier (for long
type).
* os_dep.c (GC_dirty_init): Print a message about SIG_IGN detected
(for SIGSEGV/BUS) only if GC_print_stats.
* os_dep.c (catch_exception_raise): Join 2 adjacent GC_err_printf
calls.

* tests/test.c (main): Print the relevant message if GWW_VDB.
* include/private/gcconfig.h: Don't define MPROTECT_VDB for Win32
on x64 if compiled by GCC.

* tests/staticrootstest.c: Include string.h for memset() prototype.
* tests/thread_leak_test.c (main): Fix printf() format specifiers.

* CMakeLists.txt: Check enable_parallel_mark on Darwin.
* configure.ac: Likewise.
* darwin_stop_world.c (DARWIN_SUSPEND_GC_THREADS,
DARWIN_QUERY_TASK_THREADS): Rename to GC_NO_THREADS_DISCOVERY and
GC_DISCOVER_TASK_THREADS, respectively.
* os_dep.c (DARWIN_SUSPEND_GC_THREADS): Likewise.
* pthread_support.c (DARWIN_SUSPEND_GC_THREADS): Likewise.
* darwin_stop_world.c (DARWIN_QUERY_TASK_THREADS): Don't define
(and remove FIXME).
* darwin_stop_world.c (GC_use_threads_discovery): Add GC_API;
comment; remove FIXME.
* win32_threads.c (GC_NO_DLLMAIN): Rename to
GC_NO_THREADS_DISCOVERY.
* tests/test.c (GC_NO_DLLMAIN): Likewise.
* doc/README.macros (GC_NO_DLLMAIN): Likewise.
* doc/README.win32 (GC_NO_DLLMAIN): Likewise.
* doc/README.macros (GC_NO_THREADS_DISCOVERY): Update the comment.
* win32_threads.c (GC_win32_dll_threads): Define as macro to true
if GC_DISCOVER_TASK_THREADS (and not GC_NO_THREADS_DISCOVERY);
update the comment.
* win32_threads.c (GC_use_DllMain): Rename to
GC_use_threads_discovery; do not set GC_win32_dll_threads if
GC_DISCOVER_TASK_THREADS.
* win32_threads.c (GC_started_thread_while_stopped,
GC_lookup_thread_inner, UNPROTECT_THREAD, GC_lookup_pthread,
GC_thr_init, GC_pthread_create, DllMain): Rewrite some expressions
which use GC_win32_dll_threads to minimize the possibility of
an "unreachable code" compiler warning when GC_win32_dll_threads
is defined as a macro.
* win32_threads.c (GC_unregister_my_thread): Don't call
GC_delete_thread() if GC_win32_dll_threads and THREAD_LOCAL_ALLOC
(since can't happen); use "t" local variable only if not
GC_win32_dll_threads.
* doc/README.macros (GC_DISCOVER_TASK_THREADS): Document.
* include/gc.h (GC_use_DllMain): Rename to
GC_use_threads_discovery but keep old name as a macro definition.
* include/gc.h (GC_use_threads_discovery): Declare also for
Darwin; update the comment.
* tests/test.c (main): Call GC_use_threads_discovery for Darwin
(to test the mode if possible).

* darwin_stop_world.c (DARWIN_SUSPEND_GC_THREADS,
DARWIN_QUERY_TASK_THREADS): New macro recognized.
* darwin_stop_world.c (GC_query_task_threads): add STATIC;
initialize to false; define as macro if DARWIN_SUSPEND_GC_THREADS
or DARWIN_QUERY_TASK_THREADS; remove FIXME.
* darwin_stop_world.c (GC_use_threads_discovery): New function
(for setting GC_query_task_threads value).
* darwin_stop_world.c (GC_mach_handler_thread,
GC_use_mach_handler_thread, GC_mach_thread, GC_MAX_MACH_THREADS,
GC_mach_threads, GC_mach_threads_count, GC_suspend_thread_list,
GC_darwin_register_mach_handler_thread): Define only if not
DARWIN_SUSPEND_GC_THREADS.
* darwin_stop_world.c (GC_stop_world, GC_start_world): Exclude
the code for GC_query_task_threads case from compilation unless
DARWIN_SUSPEND_GC_THREADS.
* os_dep.c (GC_darwin_register_mach_handler_thread): Declared only
if Darwin threads and not DARWIN_SUSPEND_GC_THREADS.
* os_dep.c (GC_mprotect_thread): Call
GC_darwin_register_mach_handler_thread only if THREADS and not
DARWIN_SUSPEND_GC_THREADS.
* pthread_support.c (marker_mach_threads): Don't define if
DARWIN_SUSPEND_GC_THREADS.
* pthread_support.c (GC_mark_thread): Don't fill in
marker_mach_threads if DARWIN_SUSPEND_GC_THREADS.
* include/private/gc_locks.h (GC_need_to_lock): Always declare for
THREADS case.

* darwin_stop_world.c (GC_query_task_threads): Don't define to
false for DARWIN_DONT_PARSE_STACK case; unconditionally initialize
the variable to false (for now).
* darwin_stop_world.c (GC_push_all_stacks): Call task_threads()
only if not DARWIN_DONT_PARSE_STACK.
* darwin_stop_world.c (GC_stop_world, GC_start_world): Use the
approach based on task_threads() only if GC_query_task_threads
else use GC_threads table.

* darwin_stop_world.c (GC_mach_threads): Remove static qualifier.
* darwin_stop_world.c (GC_stop_init): Remove (as we do not need to
really clear GC_mach_threads[]).
* darwin_stop_world.c (GC_stop_world): Reset GC_mach_threads_count
(instead of calling GC_stop_init).
* include/private/pthread_support.h (GC_stop_init): Remove proto.
* pthread_support.c (GC_stop_init): Add proto (unless Darwin).
* pthread_support.c (GC_thr_init): Don't call GC_stop_init() if
GC_DARWIN_THREADS.

* darwin_stop_world.c (GC_stack_range_for): New static function
(move the code from GC_push_all_stacks).
* darwin_stop_world.c (GC_push_all_stacks): Call
GC_stack_range_for(); rename kern_return local variable to
kern_result.
* darwin_stop_world.c (GC_is_mach_marker): Change argument type
from mach_port_t to thread_act_t.
* pthread_support.c (GC_is_mach_marker): Likewise.

* darwin_stop_world.c (GC_push_all_stacks): Fix "my_task" local
variable initialization (always call current_task()).
* pthread_support.c (GC_thr_init, GC_register_my_thread_inner):
Don't set thread's stop_info.stack_ptr value for Darwin.
* include/private/darwin_stop_world.h (thread_stop_info): Update
the comment for stack_ptr.

* darwin_stop_world.c (GC_push_all_stacks): Rename "r", "me" local
variables to "kern_return" and "my_thread" ones, respectively;
call mach_port_deallocate() unconditionally.
* darwin_stop_world.c (GC_stop_world): Don't call mach_thread_self
if DEBUG_THREADS.

* darwin_stop_world.c (GC_mach_thread): Move from
darwin_stop_world.h.
* include/private/darwin_stop_world.h (GC_mach_thread): Remove.
* win32_threads.c (GC_start_world): Define "thread_id" local
variable only if GC_ASSERTIONS; decide whether to resume a thread
based on its "suspended" field value; assert that suspended thread
stack_base is non-zero and the thread is not our one.

* darwin_stop_world.c (GC_thread_resume): New inline function
(move code from GC_thread_resume).
* darwin_stop_world.c (GC_start_world): Check result of
task_threads(); call GC_thread_resume().
* os_dep.c (GC_malloc_heap_l, GC_is_malloc_heap_base): Define
only if not CYGWIN32.
* os_dep.c (GC_is_heap_base): Call GC_is_malloc_heap_base() only
if not CYGWIN32.

* darwin_stop_world.c (FindTopOfStack): Change return type to
ptr_t (from long); make GC_INNER; add GC_ prefix.
* darwin_stop_world.c (GC_push_all_stacks): Add thread_blocked
local variable (initialized from the corresponding GC_thread
field unless GC_query_task_threads); add assertion that our
thread is not blocked; prefix FindTopOfStack with GC_ and remove
no longer needed cast to ptr_t of the result; handle thread
blocked case (and remove FIXME); use GC_push_all_stack_sections
unless GC_query_task_threads (and remove FIXME).
* pthread_support.c (GC_FindTopOfStack): Declare (if needed).
* pthread_support.c (GC_do_blocking_inner): Call
GC_save_regs_in_stack (if needed) before acquiring the lock.
* win32_threads.c (GC_do_blocking_inner): Likewise.
* pthread_support.c (GC_do_blocking_inner): Set/clear topOfStack
field of GC_thread (Darwin only).
* include/private/pthread_support.h (GC_thread): Add topOfStack
field for Darwin (unless DARWIN_DONT_PARSE_STACK).

* finalize.c (GC_check_finalizer_nested): Change return type to
char pointer (instead of int pointer); use explicit cast for
GC_finalizer_nested assignment.
* pthread_support.c (GC_check_finalizer_nested): Likewise.
* win32_threads.c (GC_check_finalizer_nested): Likewise.
* finalize.c (GC_finalizer_nested): Change type to unsigned char.
* finalize.c (GC_notify_or_invoke_finalizers): Change type of
"pnested" local variable to char pointer.
* pthread_support.c (GC_do_blocking_inner,
GC_call_with_gc_active): Use explicit cast for "thread_blocked"
field assignment.
* win32_threads.c (GC_lookup_pthread): Use explicit cast for
"suspended" field assignment.
* win32_threads.c (GC_Thread_Rep): Use short type for
finalizer_skipped; use char type for finalizer_nested and flags
fields and reorder some fields (to minimize GC_Thread_Rep
structure size).
* include/private/pthread_support.h (GC_Thread_Rep): Likewise.
* win32_threads.c (GC_Thread_Rep): Use char type for suspended
field (instead of GC_bool).
* include/private/pthread_support.h (GC_Thread_Rep): Use char type
for thread_blocked field (instead of short).

* darwin_stop_world.c (GC_query_task_threads): New variable (or
macro).
* darwin_stop_world.c (GC_push_all_stacks): Use
GC_query_task_threads (to choose between algorithms based on
kernel task_threads and based on GC_threads table); update FIXME;
remove commented out GC_push_one statements.
* pthread_support.c (GC_thr_init, GC_do_blocking_inner,
GC_call_with_gc_active, GC_register_my_thread_inner): Initialize
stack_ptr field for all platforms.
* pthread_support.c (GC_call_with_gc_active): Initialize
saved_stack_ptr field for all platforms.
* include/private/darwin_stop_world.h (thread_stop_info): Add
stack_ptr field; change type of already_suspended from int to
GC_bool.

* darwin_stop_world.c (GC_MAX_MACH_THREADS): New macro.
* darwin_stop_world.c (GC_mach_threads, GC_stop_init): Use
GC_MAX_MACH_THREADS instead of THREAD_TABLE_SZ.
* darwin_stop_world.c (GC_mach_threads): Add FIXME.
* darwin_stop_world.c (GC_stop_init, GC_suspend_thread_list,
GC_stop_world): Use FALSE and TRUE for already_suspended field and
"changed", "found" variables.
* darwin_stop_world.c (GC_is_mach_marker): New prototype (only if
PARALLEL_MARK).
* darwin_stop_world.c (GC_suspend_thread_list): Change return type
to GC_bool; change type of "changed", "found" to GC_bool; make
"my_thread" as an argument (instead of acquiring/deallocating it
locally); do not add my_thread, GC_mach_handler_thread and marker
threads to GC_mach_threads table; check for overflow of
GC_mach_threads table; increase GC_mach_threads_count if "found"
is true and info.suspend_count is non-zero.
* darwin_stop_world.c (GC_suspend_thread_list, GC_start_world):
Adjust "thread" format specifiers for GC_printf(); search thread
in "old_list" starting from the previous found one.
* darwin_stop_world.c (GC_stop_world): Rename "changes" to
"changed" local variable; remove "result" variable; adjust
GC_printf debugging message.
* darwin_stop_world.c (GC_start_world): Do not check for
my_thread and GC_use_mach_handler_thread (since they are not added
to GC_mach_threads table); call thread_info() only if
DEBUG_THREADS or GC_ASSERTIONS.
* pthread_support.c (marker_mach_threads): New static variable (if
Darwin).
* pthread_support.c (GC_is_mach_marker): New function (if Darwin).
* pthread_support.c (GC_mark_thread): Fill in marker_mach_threads
table (if Darwin).

* alloc.c (GC_parallel): Define only if THREADS.
* misc.c (GC_get_parallel): Likewise.
* include/gc.h (GC_parallel, GC_get_parallel,
GC_get_suspend_signal, GC_allow_register_threads,
GC_register_my_thread, GC_unregister_my_thread): Define only if
GC_THREADS.
* include/gc.h (GC_get_heap_size): Fix a typo in a comment.

* configure.ac: Use `AC_C_INLINE'.
* include/private/gc_priv.h (GC_INLINE): Use "inline" keyword
(determined by configure AC_C_INLINE) if HAVE_CONFIG_H is defined.

* dyn_load.c (DL_ITERATE_PHDR_STRONG): New macro (define for
FreeBSD).
* dyn_load.c (GC_register_main_static_data): Move the definition
above GC_register_dynamic_libraries_dl_iterate_phdr one (FreeBSD
case); unconditionally return FALSE if DL_ITERATE_PHDR_STRONG.
* dyn_load.c (GC_register_dynamic_libraries_dl_iterate_phdr): Test
GC_register_main_static_data() result (instead of direct testing
of dl_iterate_phdr (to prevent a compiler warning).
* os_dep.c (CODE_OK): Test si_code also for the value of 2
(FreeBSD case; required for FreeBSD v7+).
* os_dep.c (CODE_OK): Properly use parentheses (HPUX case).
* include/private/gcconfig.h (DATASTART): Cast etext argument in
GC_FreeBSDGetDataStart() call; remove unnecessary "&" (FreeBSD
case).

* include/private/specific.h (quick_thread_id): Define thru
GC_approx_sp(); define as a macro.
* include/private/specific.h (getspecific): Use GC_INLINE instead
of __inline__ (to work around Sun CC which does not recognize
inline keyword surrounded with underscores).

* darwin_stop_world.c (FindTopOfStack): Simplify condition
expressions.
* darwin_stop_world.c (GC_push_all_stacks): Merge two variants
of this function (DARWIN_DONT_PARSE_STACK).
* darwin_stop_world.c (GC_push_all_stacks): Add a check for our
thread is found (same as in pthread_stop_world.c).
* darwin_stop_world.c (GC_push_all_stacks): Print the number of
scanned threads if verbose (same as in pthread_stop_world.c).

* darwin_stop_world.c (GC_push_all_stacks): Reset
thread_state_count value before every thread_get_state call;
refine the comment for thread_state_count.
* darwin_stop_world.c (GC_push_all_stacks): Ignore rsp, rip/eip,
rflags, cs, fs, gs, ss, ds, es, __pc registers; uncomment ebp
register pushing.
* darwin_stop_world.c (GC_push_all_stacks): Set outCount to
GC_MACH_THREAD_STATE_COUNT (instead of THREAD_STATE_MAX).
* darwin_stop_world.c (GC_push_all_stacks): Remove FIXME and WARN
for x86.

* doc/README.macros (DARWIN_DONT_PARSE_STACK): Fix a typo.
* darwin_stop_world.c (GC_use_mach_handler_thread): Change type
to GC_bool.
* darwin_stop_world.c (GC_suspend_thread_list, GC_start_world):
Simplify the expressions involving GC_use_mach_handler_thread.
* darwin_stop_world.c (GC_darwin_register_mach_handler_thread):
Initialize GC_use_mach_handler_thread to TRUE (instead of 1).

* include/gc_pthread_redirects.h (GC_pthread_sigmask, GC_dlopen,
pthread_sigmask, dlopen): Don't define for pthreads-win32 (and
don't include signal.h and dlfcn.h).

* dyn_load.c (GC_register_dynlib_callback): Add FIXME.

* include/private/gcconfig.h: Add support for FreeBSD on ppc64.

* os_dep.c (PROTECT, UNPROTECT): Correct VM_PROT_EXEC to
VM_PROT_EXECUTE.

* os_dep.c (os2_alloc): Don't set PAG_EXECUTE unless
pages_executable is on.
* os_dep.c (os2_alloc): Add FIXME (for recursion).
* os_dep.c (UNPROTECT): Abort with a more informative message if
pages_executable is on ("mprotect" case).
* os_dep.c (PROTECT, UNPROTECT): Set VM_PROT_EXEC if
pages_executable is on (Darwin case).
* pthread_support.c (GC_init_real_syms): Abort with an informative
message if libgc is linked after libpthread.

* dyn_load.c (GC_register_dynlib_callback): Adjust "start" pointer
for 64-bit targets.
* pthread_support.c (start_mark_threads): Expand PTHREAD_CREATE
macro.
* pthread_support.c (start_mark_threads): Call INIT_REAL_SYMS()
since REAL(pthread_create) is used.
* pthread_support.c (PTHREAD_CREATE): Remove unused.

* extra/threadlibs.c (main): Remove --wrap for "read" (since not
wrapped anymore).
* doc/README.linux (GC_USE_LD_WRAP): Likewise.
* os_dep.c (__wrap_read): Likewise.

* include/gc_pthread_redirects.h: Test GC_PTHREADS and GC_H at the
beginning of the file.
* include/gc_pthread_redirects.h (GC_PTHREAD_EXIT_ATTRIBUTE): New
macro (defined only for Linux and Solaris).
* include/gc_pthread_redirects.h (GC_pthread_cancel,
GC_pthread_exit): Declare new API function (only if
GC_PTHREAD_EXIT_ATTRIBUTE).
* include/gc_pthread_redirects.h (pthread_cancel, pthread_exit):
Redirect (if GC_PTHREAD_EXIT_ATTRIBUTE).
* include/private/pthread_support.h (DISABLED_GC): New macro.
* pthread_support.c (pthread_cancel, pthread_exit): Restore
original definition or declare "real" function (if needed and
GC_PTHREAD_EXIT_ATTRIBUTE).
* pthread_support.c (GC_pthread_cancel_t, GC_pthread_exit_t):
Declare new types if needed.
* pthread_support.c (GC_pthread_cancel, GC_pthread_exit): New
function definition (only if GC_PTHREAD_EXIT_ATTRIBUTE).
* pthread_support.c (GC_init_real_syms): Initialize pointers to
the "real" pthread_cancel and pthread_exit (only if
GC_PTHREAD_EXIT_ATTRIBUTE).
* pthread_support.c (GC_unregister_my_thread): Enable collections
if DISABLED_GC was set (only if GC_PTHREAD_EXIT_ATTRIBUTE).
* pthread_support.c (pthread_cancel, pthread_exit): New wrapped
function definition (only if GC_PTHREAD_EXIT_ATTRIBUTE defined).
* pthread_support.c (GC_start_routine): Refine the comment.
* extra/threadlibs.c (main): Adjust --wrap (add "read",
"pthread_exit", "pthread_cancel" but remove "sleep").
* doc/README.linux (GC_USE_LD_WRAP): Likewise.

* include/gc.h (GC_MALLOC_STUBBORN): Remove trailing ';' in the
macro definition.
* include/gc.h (GC_reachable_here): Likewise.
* include/gc.h (GC_reachable_here): Prefix and postfix "volatile"
with double '_'.

* pthread_start.c: New file.
* CMakeLists.txt (SRC): Add pthread_start.c.
* Makefile.am (libgc_la_SOURCES): Likewise.
* Makefile.direct (CSRCS): Likewise.
* Makefile.direct (OBJS): Add pthread_start.obj.
* extra/gc.c: Add a comment; include pthread_start.c.
* pthread_support.c (start_info): Move the struct definition down
closer to its usage.
* pthread_support.c (GC_thread_exit_proc): Replace STATIC with
GC_INNER.
* pthread_support.c (GC_inner_start_routine): Move to the
definition to pthread_start.c; leave only the prototype; remove
STATIC.
* pthread_support.c (GC_start_rtn_prepare_thread): New function
(contains parts of the original GC_inner_start_routine).

* configure.ac (NO_EXECUTE_PERMISSION): Add comment.
* doc/README.macros (NO_EXECUTE_PERMISSION): Update the
documentation.
* include/gc.h (GC_set_pages_executable, GC_get_pages_executable):
New API function declaration.
* os_dep.c (OPT_PROT_EXEC): Remove (superseded by
pages_executable).
* os_dep.c (pages_executable): New static variable.
* os_dep.c (IGNORE_PAGES_EXECUTABLE): New macro (used by
GC_get_pages_executable only).
* os_dep.c (GC_unix_mmap_get_mem, GC_remap, PROTECT, UNPROTECT):
Replace OPT_PROT_EXEC with pages_executable.
* os_dep.c (GC_unix_mmap_get_mem, GC_remap, GC_win32_get_mem,
GC_wince_get_mem, UNPROTECT): Undefine IGNORE_PAGES_EXECUTABLE.
* os_dep.c (GC_win32_get_mem, GC_wince_get_mem, GC_remap, PROTECT,
UNPROTECT): Use PAGE_EXECUTE_... only if pages_executable is on.
* os_dep.c (GC_set_pages_executable, GC_get_pages_executable): New
API function definition.

* tests/test.c (check_heap_stats): Increase max_heap_sz by 20% for
64-bit CPUs (to prevent "Unexpected heap growth" failure on Win64,
at least).

* tests/test.c (check_heap_stats): Increase max_heap_sz by 25% for
32-bit CPUs (to prevent "Unexpected heap growth" failure).

* gc_dlopen.c (dlopen): Prototype REAL_DLFUNC if GC_USE_LD_WRAP.
* pthread_support.c (pthread_create, pthread_join, pthread_detach,
pthread_sigmask): Likewise.
* gc_dlopen.c (dlopen): Remove cast (redundant since the prototype
is added).
* gc_dlopen.c (GC_dlopen): Fix return type.
* pthread_support.c (GC_init_real_syms): Don't define
LIBPTHREAD_NAME, LIBPTHREAD_NAME_LEN, len, namebuf and
libpthread_name if RTLD_NEXT.

* gc_dlopen.c (disable_gc_for_dlopen): Update the comment.
* gc_dlopen.c (dlopen): Likewise.
* include/gc.h (GC_enable_incremental): Refine the comment.
* include/gc.h (DECLSPEC_NORETURN): Define macro as empty if
missing (only for Win32).
* include/gc.h (GC_ExitThread): Use DECLSPEC_NORETURN.
* win32_threads.c (GC_ExitThread): Likewise.
* include/gc.h (GC_endthreadex): Add a comment.

* include/cord.h: Fix typos.

* Makefile.am (EXTRA_DIST): Add "CMakeLists.txt" and
"tests/CMakeLists.txt".
* doc/doc.am (dist_pkgdata_DATA): Add "doc/README.cmake".

* mach_dep.c (NO_GETCONTEXT): Also define if AVR32.
* include/private/gcconfig.h (AVR32): New macro (also define the
supplementary macros for the target).
* include/private/thread_local_alloc (USE_COMPILER_TLS): Don't
define for AVR32.

* tests/leak_test.c (main): Explicitly define as returning int
(to prevent a spurious test failure on some Linux/alpha targets).
* tests/thread_leak_test.c (main): Likewise.
* tests/thread_leak_test.c: Initialize GC_find_leak in the main
thread (before GC_INIT) only.
* tests/leak_test.c (main): Use GC_set_find_leak() instead of
accessing GC_find_leak directly.
* tests/thread_leak_test.c (main): Likewise.

* include/gc.h (GC_find_leak, GC_finalize_on_demand,
GC_java_finalization, GC_dont_expand, GC_no_dls,
GC_dont_precollect): Simplify the comment (remove the information
about data races since the value is boolean).

* os_dep.c (GC_get_stack_base, GC_get_main_stack_base): New
Solaris-specific implementation (based on thr_stksegment).
* os_dep.c (stackbase_main_self, stackbase_main_ss_sp): New static
variable used by the Solaris-specific GC_get_stack_base().

* pthread_support.c (GC_mark_thread_local_free_lists,
GC_check_tls): Mark (and check) only for live threads (in case of
GC_destroy_thread_local() is called already but GC_delete_thread()
is not yet).
* win32_threads.c (GC_mark_thread_local_free_lists, GC_check_tls):
Likewise.

* NT_MAKEFILE: Remove the comment about DLL and win32s.
* NT_STATIC_THREADS_MAKEFILE: Likewise.
* NT_X64_STATIC_THREADS_MAKEFILE: Likewise.
* NT_MAKEFILE: Add ".SUFFIXES" directive (to handle gc_cpp.cc
properly on VS 2005+).
* NT_MAKEFILE: Update GC log file name in comments.
* NT_STATIC_THREADS_MAKEFILE: Likewise.
* NT_X64_STATIC_THREADS_MAKEFILE: Likewise.
* NT_X64_THREADS_MAKEFILE: Likewise.
* doc/README.win32: Likewise.
* NT_MAKEFILE: Remove ":full" for "-debug" option (since no
longer supported by VS).
* NT_STATIC_THREADS_MAKEFILE: Likewise.
* NT_MAKEFILE: Commented out copying of gc_cpp.cc to gc_cpp.cpp.
* NT_STATIC_THREADS_MAKEFILE: Likewise.
* NT_X64_STATIC_THREADS_MAKEFILE: Likewise.
* NT_X64_THREADS_MAKEFILE: Likewise.
* NT_STATIC_THREADS_MAKEFILE: Add -D PARALLEL_MARK option.
* NT_STATIC_THREADS_MAKEFILE: Increase stack size for gctest.exe.
* NT_X64_STATIC_THREADS_MAKEFILE: Remove "-stack" option (use the
default stack size limit).
* NT_X64_THREADS_MAKEFILE: Rename "gc64_dll.dll" to "gc64.dll".
* win32_threads.c (GC_get_next_stack): Always define (since it is
also used for Cygwin now).

* alloc.c (GC_maybe_gc): Move GC_notify_full_gc() call upper to
be just before GC_clear_marks() call.
* include/gc_mark.h (GC_start_callback_proc): Refine the comment.

* Makefile.am (check_LTLIBRARIES): Initialize to empty.
* tests/tests.am (TESTS, check_PROGRAMS): Add staticrootstest.
* tests/tests.am (staticrootstest_SOURCES, staticrootstest_LDADD,
libstaticrootslib_la_SOURCES, libstaticrootslib_la_LIBADD,
libstaticrootslib_la_LDFLAGS, libstaticrootslib_la_DEPENDENCIES):
Define.
* tests/tests.am (check_LTLIBRARIES): Add libstaticrootslib.la.

* tests/staticrootstest.c: New file.
* tests/staticrootslib.c: Likewise.

* dyn_load.c (GC_get_next_stack, GC_cond_add_roots): Define for
Cygwin as well as other win32 targets.
* dyn_load.c (GC_wnt): Define to constant true.
* dyn_load.c (GC_register_dynamic_libraries): Define for Cygwin as
well as other win32 targets.
* mark_rts.c (rt_hash, GC_roots_present, add_roots_to_index):
Don't define for Cygwin, as on other win32.
* mark_rts.c (GC_add_roots_inner, GC_clear_roots): Handle on
Cygwin as for other win32 targets.
* mark_rts.c (GC_rebuild_root_index): Don't declare on Cygwin, as
other win32.
* mark_rts.c (GC_remove_tmp_roots): Do declare on Cygwin as on
other win32.
* mark_rts.c (GC_remove_roots, GC_remove_roots_inner): Don't
declare on Cygwin as on other win32.
* mark_rts.c (GC_is_tmp_root): Do declare on Cygwin when
!NO_DEBUGGING, as on other win32 targets.
* mark_rts.c (GC_cond_register_dynamic_libraries): Handle on
Cygwin as for other win32 targets.
* os_dep.c (GC_setpagesize): Handle on Cygwin as on other win32.
* os_dep.c (GC_get_main_stack_base): Don't declare on Cygwin, as
other win32.
* os_dep.c (GC_sysinfo): Declare on Cygwin, as other win32.
* os_dep.c (GC_win32_get_mem): Declare on Cygwin, as on other
Win32, but call GC_unix_get_mem instead of GlobalAlloc.
* os_dep.c (GC_win32_free_heap): Declare on Cygwin (as empty).
* ptr_chck.c (GC_is_visible): Register dynamic libraries on Cygwin
as on other win32 platforms.
* win32_threads.c (GC_get_next_stack): Define on Cygwin as well as
for dynamic loading targets.
* include/private/gc_priv.h (GC_INNER): Don't try to use
visibility on Cygwin which does not support it.
* include/private/gc_priv.h (struct roots): Don't declare r_next
member on Cygwin as on other windows hosts.
* include/private/gc_priv.h (LOG_RT_SIZE, RT_SIZE): Don't define
likewise.
* include/private/gc_priv.h (struct _GC_arrays): Do declare
_heap_bases[] member and don't declare _root_index likewise.
* include/private/gc_priv.h (GC_heap_bases): Do define likewise.
* include/private/gc_priv.h (_SYSTEM_INFO): Do forward-declare
likewise.
* include/private/gc_priv.h (GC_sysinfo): Do declare extern
likewise.
* include/private/gcconfig.h (GC_win32_get_mem, GET_MEM): Do
prototype on Cygwin as other win32 platforms.

* os_dep.c (GC_get_main_stack_base): Use pthread_getattr_np() and
pthread_attr_getstack() instead of GC_get_stack_base() (and check
returned stackaddr for NULL); output a warning on failure.

* alloc.c (GC_start_call_back): Replace the definition type to
GC_start_callback_proc.
* alloc.c (GC_set_start_callback, GC_get_start_callback): New
setter/getter function.
* alloc.c (GC_try_to_collect_inner): Call GC_notify_full_gc()
unconditionally (because GC_try_to_collect_inner always does full
GC).
* include/gc_mark.h (GC_start_callback_proc): New type.
* include/gc_mark.h (GC_set_start_callback,
GC_get_start_callback): New API function declaration.

* doc/README.macros (USE_GET_STACKBASE_FOR_MAIN): Document.
* os_dep.c (GC_get_main_stack_base): Recognize
USE_GET_STACKBASE_FOR_MAIN (only if THREADS and LINUX_STACKBOTTOM)
and use GC_get_stack_base() in this case.

* os_dep.c (GC_get_stack_base): Add LOCK/UNLOCK() (since
GC_find_limit_with_bound() should be called with the lock held).
* backgraph.c (FOR_EACH_PRED): Fix a typo.

* alloc.c (GC_set_stop_func, GC_get_stop_func): Add
DCL_LOCK_STATE.
* finalize.c (GC_notify_or_invoke_finalizers): Likewise.
* gc_dlopen.c (disable_gc_for_dlopen): Likewise.
* gcj_mlc.c (maybe_finalize, GC_debug_gcj_malloc): Likewise.
* mark.c (GC_print_trace): Likewise.
* misc.c (GC_set_warn_proc, GC_get_warn_proc, GC_enable,
GC_disable, GC_new_free_list, GC_new_kind, GC_new_proc,
GC_set_oom_fn, GC_get_oom_fn, GC_set_finalizer_notifier,
GC_get_finalizer_notifier): Likewise.
* os_dep.c (GC_get_stack_base, GC_print_callers): Likewise.
* pthread_support.c (GC_is_thread_tsd_valid,
GC_wait_for_gc_completion, GC_init_parallel, GC_do_blocking_inner,
GC_call_with_gc_active, GC_unregister_my_thread, pthread_join,
pthread_detach, GC_register_my_thread, GC_inner_start_routine,
pthread_create): Likewise.
* reclaim.c (GC_print_all_errors): Likewise.
* win32_threads.c (GC_is_thread_tsd_valid, GC_register_my_thread,
GC_unregister_my_thread, GC_do_blocking_inner,
GC_call_with_gc_active, GC_lookup_pthread, GC_pthread_join,
GC_pthread_start_inner, GC_thread_exit_proc, GC_pthread_detach,
GC_init_parallel): Likewise.

* doc/README.darwin: Update.

* CMakeLists.txt: Adjust INCLUDE_DIRECTORIES and SRC (to make it
usable on Mac OS X).
* doc/README.cmake: Update.

* CMakeLists.txt: New file (adding CMake support).
* tests/CMakeLists.txt: Likewise.
* doc/README.cmake: Likewise.

* configure.ac (darwin): Don't define HAS_PPC_THREAD_STATE...
macros.
* include/private/gc_priv.h (THREAD_FLD): Recognize
__DARWIN_UNIX03 instead of HAS_PPC_THREAD_STATE... macros.

* pthread_support.c: Include <sys/param.h> and <sys/sysctl.h> for
OpenBSD.
* pthread_support.c (get_ncpu): Define also for Darwin, NetBSD and
OpenBSD.
* pthread_support.c (GC_thr_init): Use get_ncpu() for Darwin,
NetBSD and OpenBSD.

* mallocx.c (GC_generic_malloc_many, GC_malloc_many): Define even
if THREADS is undefined.
* include/gc.h (GC_malloc_many): Update the comment.

* include/gc_cpp.h (GC_PLACEMENT_DELETE): Define for Embarcadero
(formerly known as Borland) C++ compiler v6.21+.
* include/gc_cpp.h (GC_NO_OPERATOR_NEW_ARRAY): Define for ancient
VC++ compilers.

* win32_threads.c (GC_register_my_thread_inner,
GC_pthread_start_inner): Undo the previous commit changes for
the thread flags and DETACHED state (since the state is only
tested in GC_thread_exit_proc).

* include/gc.h (GC_unregister_my_thread): Fix a typo; update the
comment.
* pthread_support.c (GC_delete_thread): Allow to delete the main
thread (don't call GC_INTERNAL_FREE for it); update the comment.
* win32_threads.c (GC_delete_thread): Likewise.
* pthread_support.c (GC_unregister_my_thread): Add an assertion
for FINISHED flag is unset.
* tests/test.c (check_heap_stats): Test the main thread
unregistering (only if THREADS).
* win32_threads.c (GC_register_my_thread_inner): Set flags to
DETACHED (only if GC_PTHREADS).
* win32_threads.c (GC_unregister_my_thread): Add FIXME (for
GC_wait_for_gc_completion).
* win32_threads.c (GC_pthread_start_inner): Clear flags detached
state if needed; set pthread_id and flags while holding the lock.

* include/private/gc_priv.h (SIG_SUSPEND): Don't define for
OpenBSD and Darwin.

* include/gc.h: Recognize _M_X64 (as an alias for _AMD64_).

* test.c (main, WinMain): Consistently don't invoke
GC_enable_incremental() if MAKE_BACKGRAPH is defined, but
do invoke it even if parallel marking is enabled.

* tests/test.c (reverse_test): Comment out a check for MSWIN32
(when determining BIG value) assuming outdated win32s.
* tests/test.c (reverse_test): Rename to reverse_test_inner;
change the declaration (to be of GC_fn_type); call itself thru
GC_call_with_gc_active() if the argument is zero.
* tests/test.c (reverse_test): New function added calling
reverse_test_inner thru GC_do_blocking (to test GC_do_blocking and
GC_call_with_gc_active).

* doc/README.macros (IGNORE_DYNAMIC_LOADING, PLATFORM_ANDROID):
Document.
* dyn_load.c: Don't include <elf.h> if PLATFORM_ANDROID.
* dyn_load.c: Include bionic <linker.h> (instead of <link.h>) if
PLATFORM_ANDROID.
* include/private/gcconfig.h (LINUX): Define also if
PLATFORM_ANDROID (for the windows-based toolkit).
* include/private/gcconfig.h (SEARCH_FOR_DATA_START): Explicitly
define for Android/x86 platform.
* include/private/gcconfig.h (IGNORE_DYNAMIC_LOADING): Recognize
new macro (undefine DYNAMIC_LOADING in this case).
* include/private/gcconfig.h (CANCEL_SAFE): Don't define if
PLATFORM_ANDROID.
* include/private/gcconfig.h (IF_CANCEL): Fix definition for the
explicitly defined CANCEL_SAFE.

* allchblk.c (GC_allochblk_nth): Don't call GC_remove_protection()
if GC_DISABLE_INCREMENTAL.
* reclaim.c (GC_reclaim_generic): Likewise.
* checksums.c (GC_page_was_ever_dirty): Add prototype.
* include/private/gc_locks.h (GC_mark_lock_holder): Don't declare
unless PARALLEL_MARK.
* include/private/gc_priv.h (GC_dirty_maintained,
GC_page_was_dirty, GC_remove_protection, GC_dirty_init): Don't
declare if GC_DISABLE_INCREMENTAL.
* include/private/gc_priv.h (GC_print_finalization_stats): Don't
declare if SMALL_CONFIG.
* include/private/gcconfig.h (CHECKSUMS): Explicitly undefine if
GC_DISABLE_INCREMENTAL (since nothing to check).
* include/private/gcconfig.h (DEFAULT_VDB): Don't define if
GC_DISABLE_INCREMENTAL.
* os_dep.c (GC_dirty_maintained): Likewise.
* mark.c (GC_initiate_gc): Don't call GC_read_dirty() if
GC_DISABLE_INCREMENTAL.
* os_dep.c (GC_gww_page_was_ever_dirty, GC_page_was_ever_dirty):
Uncomment; define only if CHECKSUMS.

* darwin_stop_world.c (GC_push_all_stacks): Fix a bug (call
GC_push_all_stack() instead of GC_push_all_stack_frames()).
* include/private/gc_priv.h (GC_push_all_stack_frames,
GC_push_all_register_frames): Rename to
GC_push_all_stack_sections and GC_push_all_register_sections,
respectively.
* mark_rts.c (GC_push_all_stack_frames,
GC_push_all_register_frames, GC_push_all_stack_part_eager_frames,
GC_push_current_stack): Likewise.
* pthread_stop_world.c (GC_push_all_stacks): Likewise.
* win32_threads.c (GC_push_stack_for): Likewise.
* misc.c (GC_call_with_gc_active): Rename "frame" local variable
to "stacksect".
* pthread_support.c (GC_call_with_gc_active): Likewise.
* win32_threads.c (GC_call_with_gc_active): Likewise.
* pthread_support.c (GC_call_with_gc_active): Update FIXME for
Darwin.
* win32_threads.c (GC_Thread_Rep): Update the comment for
traced_stack_sect.

* darwin_stop_world.c (GC_push_all_stacks): Rename
activation_frame to traced_stack_sect.
* include/private/gc_priv.h (GC_push_all_stack_frames,
GC_push_all_register_frames): Likewise.
* include/private/pthread_support.h (GC_Thread_Rep): Likewise.
* mark_rts.c (GC_push_all_register_frames,
GC_push_all_stack_frames, GC_push_all_stack_part_eager_frames,
GC_push_current_stack): Likewise.
* pthread_stop_world.c (GC_push_all_stacks): Likewise.
* pthread_support.c (GC_call_with_gc_active): Likewise.
* win32_threads.c (GC_Thread_Rep, GC_call_with_gc_active,
GC_push_stack_for): Likewise.
* include/private/gc_priv.h (GC_activation_frame_s): Rename to
GC_traced_stack_sect_s.
* include/private/gc_priv.h (GC_activation_frame): Rename to
GC_traced_stack_sect.
* misc.c (GC_activation_frame, GC_call_with_gc_active): Likewise.
* doc/README.macros (UNICODE): Document.

* doc/README.macros (GC_READ_ENV_FILE): Document (new macro).
* include/private/gc_priv.h (GETENV): Recognize GC_READ_ENV_FILE;
declare and use GC_envfile_getenv().
* misc.c (GC_envfile_content, GC_envfile_length): New static
variable (only if GC_READ_ENV_FILE).
* misc.c (GC_ENVFILE_MAXLEN): New macro (used in GC_envfile_init).
* misc.c (GC_envfile_init, GC_envfile_getenv): New function (only
if GC_READ_ENV_FILE).
* misc.c (GC_init): Call GC_envfile_init() (before using GETENV)
if GC_READ_ENV_FILE.
* misc.c (GC_init): Move GC_setpagesize() and GC_init_win32()
calls to be just before GC_envfile_init() one (since the latter
uses GET_MEM).
* misc.c (GC_abort): use ExitProcess() (instead of DebugBreak) for
WinCE if NO_DEBUGGING; add a comment for DebugBreak() (for WinCE).
* mark_rts.c (GC_add_roots_inner): Remove redundant trailing '\n'
from the ABORT message.
* misc.c (GC_init): Likewise.
* os_dep.c (GC_get_main_stack_base, GC_register_data_segments):
Likewise.
* pthread_stop_world.c (GC_push_all_stacks): Likewise.
* pthread_support.c (GC_init_real_syms, start_mark_threads):
Likewise.

* win32_threads.c (GC_get_next_stack): Don't define for Cygwin
(since unused for now).

* dyn_load.c (HAVE_REGISTER_MAIN_STATIC_DATA): Don't define unless
GC_register_main_static_data() is defined.
* dyn_load.c (GC_register_dynamic_libraries): Define only if used
(if DYNAMIC_LOADING or PCR or Win32/CE).
* dyn_load.c (GC_register_main_static_data): Define the default
one only if DYNAMIC_LOADING.
* include/private/gc_priv.h (GC_register_dynamic_libraries):
Declare only if used (to prevent compiler warning).

* mark_rts.c (GC_approx_sp): Add a comment (for GCC).


== [7.2alpha4] 2009-12-01 ==

* configure.ac (AC_CONFIG_COMMANDS): Quote srcdir value.

* include/gc.h (GC_get_suspend_signal): New function declaration.
* misc.c (GC_get_suspend_signal): New API function (only if
THREADS).

* alloc.c (min_bytes_allocd): Multiply GC_free_space_divisor by
two if GC_incremental (instead of TRUE_INCREMENTAL).

* sparc_mach_dep.S (GC_push_regs): Remove the reference.

* os_dep.c (SIZE_T, PULONG_PTR): Remove.
* os_dep.c (ULONG_PTR): Replace with GC_ULONG_PTR (defined as GC
"word"); add the comment.
* os_dep.c (GetWriteWatch_type, detect_GetWriteWatch,
GC_gww_read_dirty): Prefix ULONG_PTR with "GC_".

* win32_threads.c (THREAD_TABLE_SZ): Change back to a power-of-two
const value (for speed).
* win32_threads.c (THREAD_TABLE_INDEX): New macro.
* win32_threads.c (GC_new_thread, GC_lookup_thread_inner,
GC_delete_gc_thread, GC_delete_thread, GC_lookup_pthread): Use
THREAD_TABLE_INDEX instead of THREAD_TABLE_SZ.
* win32_threads.c (PTHREAD_MAP_HASH): Rename to PTHREAD_MAP_INDEX.

* win32_threads.c (THREAD_TABLE_SZ): Make the const value prime.

* backgraph.c: Remove apostrophe char from "#error".

* doc/README.macros (GC_DISABLE_INCREMENTAL): Document.
* include/private/gcconfig.h (GC_DISABLE_INCREMENTAL): Recognize
new macro; implicitly define it if SMALL_CONFIG.
* alloc.c (GC_incremental, GC_timeout_stop_func): Check for
GC_DISABLE_INCREMENTAL instead of SMALL_CONFIG.
* include/private/gc_priv.h (GC_incremental, TRUE_INCREMENTAL,
GC_push_conditional): Likewise.
* mark.c (GC_push_next_marked_dirty, GC_push_selected,
GC_push_conditional, GC_block_was_dirty): Likewise.
* misc.c (GC_enable_incremental): Likewise.
* misc.c (GC_init): Likewise.

* dyn_load.c (WIN32_LEAN_AND_MEAN): Guard with ifndef.
* misc.c (WIN32_LEAN_AND_MEAN): Likewise.
* os_dep.c (WIN32_LEAN_AND_MEAN): Likewise.
* allchblk.c (GC_allochblk_nth): Fix a minor typo (don't/doesn't)
in a comment.
* backgraph.c: Likewise.
* dyn_load.c (GC_register_dynamic_libraries): Likewise.
* extra/threadlibs.c (main): Likewise.
* pthread_support.c (pthread_join): Likewise.
* tests/test.c (main): Likewise.

* mach_dep.c (GC_push_regs): Remove STATIC (just to catch
a duplicate symbol definition linker error).
* misc.c (GC_clear_stack_inner): Likewise.
* sparc_mach_dep.S (GC_push_regs): Comment out the reference.

* include/private/gc_priv.h (GC_write_disabled): New variable
declaration (only if GC_ASSERTIONS and Win32 threads).
* misc.c (GC_write): Add assertion for GC_write_disabled value is
not on (only if THREADS).
* win32_threads.c (GC_write_disabled): New variable (only if
GC_ASSERTIONS and not Cygwin).
* win32_threads.c (GC_stop_world): Set and clear GC_write_disabled
(while holding GC_write_cs).

* win32_threads.c (GC_please_stop): If DllMain-based thread
registration is not compiled in then define GC_please_stop as
a non-volatile variable for assertion only.
* win32_threads.c (GC_stop_world): Set and clear only if defined.
* win32_threads.c (GC_stop_world): Add the comment for GC_printf()
usage (while holding GC_write_cs).
* win32_threads.c (GC_delete_gc_thread): Likewise.
* os_dep.c (GC_remove_protection): Likewise.

* pthread_support.c (GC_inner_start_routine): Join 3 sequential
GC_printf() calls into a single one (for DEBUG_THREADS).

* include/private/gc_priv.h (GC_total_stacksize): New variable
declaration (only if THREADS).
* alloc.c (GC_total_stacksize): New variable (only if THREADS).
* alloc.c (min_bytes_allocd): Calculate stack_size using
GC_stackbottom only in the single-threaded case; otherwise use
GC_total_stacksize; print GC_total_stacksize value if
DEBUG_THREADS.
* darwin_stop_world.c (GC_push_all_stacks): Use "%p" printf type
specifier for lo/hi values (instead of "%lx").
* darwin_stop_world.c (GC_push_all_stacks): Use
GC_push_all_stack_frames() instead of GC_push_all_stack().
* darwin_stop_world.c (GC_push_all_stacks): Recalculate
GC_total_stacksize value.
* pthread_stop_world.c (GC_push_all_stacks): Likewise.
* win32_threads.c (GC_push_all_stacks): Likewise.
* win32_threads.c (GC_push_stack_for): Pass "me" argument; return
stack size; don't check for non-zero value of thread->stack_base.
* win32_threads.c (GC_push_all_stacks): Don't call
GC_push_stack_for() and don't check for "t->id == me" if
thread->stack_base is zero.

* dyn_load.c (GC_dump_meminfo): Prefix "%lx" printf type specifier
with "0x".
* os_dep.c (PROTECT): Likewise.
* win32_threads.c (GC_mark_thread_local_free_lists): Cast p->id to
int (to match printf type specifier).

* tests/test.c (check_heap_stats): Take into account the unmapped
memory size when checking for "Unexpected heap growth"; remove
FIXME.

* alloc.c: Revert last change.

* include/private/gcconfig.h (STACKBOTTOM): Add a presence check
for eCos/NOSYS.
* misc.c (GC_write): Comment out _Jv_diag_write() call (since no
longer defined in GCJ).

* os_dep.c (brk): Rename to ecos_gc_brk.

* alloc.c (min_bytes_allocd): Use GC_stackbottom value to compute
stack_size even if THREADS.
* doc/README.macros (DEBUG_THREADS): Document.
* pthread_support.c (DEBUG_THREADS): Remove the commented out
definition.
* win32_threads.c (DEBUG_WIN32_THREADS): Remove duplicate
definition.
* win32_threads.c: Include errno.h (except for WinCE).
* win32_threads.c (GC_win32_start_inner): Copy "start" and "param"
to local variables, and free "arg" parameter before "start"
invocation.
* win32_threads.c (GC_beginthreadex): Set errno to EAGAIN on error
(instead of calling SetLastError(ERROR_NOT_ENOUGH_MEMORY)).
* win32_threads.c (GC_beginthreadex): Return 0 on error (instead
of -1).

* darwin_stop_world.c (GC_darwin_register_mach_handler_thread):
Use GC_INNER for the function definition.
* include/private/darwin_stop_world.h
(GC_darwin_register_mach_handler_thread): Remove the prototype.
* os_dep.c (GC_darwin_register_mach_handler_thread): Use GC_INNER
for the function prototype.
* include/private/gc_priv.h (NDEBUG): Explicitly define if
NO_DEBUGGING and not GC_ASSERTIONS (before the standard headers
inclusion).

* include/private/gcconfig.h: Move DebugBreak() workaround (for
x86mingw32ce toolchain) to gc_priv.h (after windows.h inclusion).

* allchblk.c (GC_unmap_old, GC_merge_unmapped, GC_allochblk,
GC_freehblk): Use GC_INNER for the function definition.
* alloc.c (GC_never_stop_func, GC_should_collect,
GC_try_to_collect_inner, GC_collect_a_little_inner,
GC_set_fl_marks, GC_add_to_our_memory, GC_add_to_heap,
GC_expand_hp_inner, GC_collect_or_expand, GC_allocobj): Likewise.
* backgraph.c (GC_build_back_graph, GC_traverse_back_graph):
Likewise.
* blacklst.c (GC_default_print_heap_obj_proc, GC_bl_init,
GC_promote_black_lists, GC_unpromote_black_lists,
GC_add_to_black_list_normal, GC_add_to_black_list_stack,
GC_is_black_listed): Likewise.
* darwin_stop_world.c (GC_push_all_stacks, GC_push_all_stacks,
GC_stop_init, GC_stop_world, GC_start_world): Likewise.
* dbg_mlc.c (GC_has_other_debug_info, GC_store_back_pointer,
GC_marked_for_finalization, GC_generate_random_backtrace_no_gc,
GC_store_debug_info, GC_start_debugging,
GC_debug_generic_malloc_inner,
GC_debug_generic_malloc_inner_ignore_off_page,
GC_debug_malloc_uncollectable, GC_debug_free_inner): Likewise.
* dyn_load.c (GC_register_dynamic_libraries,
GC_register_main_static_data, GC_init_dyld): Likewise.
* finalize.c (GC_push_finalizer_structures, GC_finalize,
GC_notify_or_invoke_finalizers, GC_print_finalization_stats):
Likewise.
* gcj_mlc.c (GC_core_gcj_malloc): Likewise.
* headers.c (GC_find_header, GC_header_cache_miss,
GC_scratch_alloc, GC_init_headers, GC_install_header,
GC_install_counts, GC_remove_header, GC_remove_counts,
GC_next_used_block, GC_prev_block): Likewise.
* mach_dep.c (GC_with_callee_saves_pushed): Likewise.
* malloc.c (GC_collect_or_expand, GC_alloc_large,
GC_generic_malloc_inner, GC_generic_malloc_inner_ignore_off_page,
GC_core_malloc_atomic, GC_core_malloc, GC_free_inner): Likewise.
* mallocx.c (GC_generic_malloc_ignore_off_page): Likewise.
* mark.c (GC_collection_in_progress, GC_clear_hdr_marks,
GC_set_hdr_marks, GC_set_mark_bit, GC_clear_mark_bit,
GC_clear_marks, GC_initiate_gc, GC_mark_some,
GC_mark_stack_empty, GC_invalidate_mark_state,
GC_signal_mark_stack_overflow, GC_mark_from, GC_help_marker,
GC_mark_init, GC_push_all, GC_push_conditional,
GC_mark_and_push_stack, GC_push_all_eager, GC_push_all_stack):
Likewise.
* mark_rts.c (GC_is_static_root, GC_roots_present, GC_approx_sp,
GC_exclude_static_roots_inner, GC_push_all_register_frames,
GC_push_all_stack_frames, GC_cond_register_dynamic_libraries,
GC_push_roots): Likewise.
* misc.c (GC_extend_size_map, GC_clear_stack, GC_err_write):
Likewise.
* new_hblk.c (GC_build_fl, GC_new_hblk): Likewise.
* obj_map.c (GC_register_displacement_inner, GC_add_map_entry,
GC_initialize_offsets): Likewise.
* os_dep.c (GC_get_maps, GC_parse_map_entry, GC_text_mapping,
GC_init_linux_data_start, GC_init_netbsd_elf, GC_setpagesize,
GC_set_and_save_fault_handler, GC_setup_temporary_fault_handler,
GC_reset_fault_handler, GC_get_register_stack_base, GC_init_win32,
GC_add_current_malloc_heap, GC_is_heap_base, GC_unmap, GC_remap,
GC_unmap_gap, GC_push_all_stacks, GC_gww_dirty_init,
GC_dirty_init, GC_read_dirty, GC_page_was_dirty,
GC_page_was_ever_dirty, GC_remove_protection,
GC_write_fault_handler, GC_mprotect_stop, GC_mprotect_resume,
GC_save_callers, GC_print_callers): Likewise.
* pthread_stop_world.c (GC_push_all_stacks, GC_stop_world,
GC_start_world, GC_stop_init): Likewise.
* pthread_support.c (GC_mark_thread_local_free_lists,
GC_lookup_thread, GC_reset_finalizer_nested,
GC_check_finalizer_nested, GC_segment_is_thread_stack,
GC_greatest_stack_base_below, GC_thr_init, GC_init_parallel,
GC_do_blocking_inner, GC_lock, GC_acquire_mark_lock,
GC_release_mark_lock, GC_wait_for_reclaim, GC_notify_all_builder,
GC_wait_marker, GC_notify_all_marker): Likewise.
* reclaim.c (GC_print_all_errors, GC_block_empty,
GC_reclaim_generic, GC_start_reclaim, GC_continue_reclaim,
GC_reclaim_all): Likewise.
* thread_local_alloc.c (GC_init_thread_local,
GC_destroy_thread_local, GC_mark_thread_local_fls_for): Likewise.
* win32_threads.c (GC_reset_finalizer_nested,
GC_check_finalizer_nested, GC_do_blocking_inner, GC_stop_world,
GC_start_world, GC_push_all_stacks, GC_get_next_stack,
GC_acquire_mark_lock, GC_release_mark_lock, GC_wait_for_reclaim,
GC_notify_all_builder, GC_wait_marker, GC_notify_all_marker,
GC_thr_init, GC_init_parallel, GC_lock,
GC_mark_thread_local_free_lists): Likewise.
* alloc.c (GC_add_current_malloc_heap, GC_build_back_graph,
GC_traverse_back_graph): Use GC_INNER for the function prototype.
* darwin_stop_world.c (GC_mprotect_stop, GC_mprotect_resume):
Likewise.
* dbg_mlc.c (GC_default_print_heap_obj_proc): Likewise.
* dyn_load.c (GC_parse_map_entry, GC_get_maps,
GC_segment_is_thread_stack, GC_roots_present, GC_is_heap_base,
GC_get_next_stack): Likewise.
* finalize.c (GC_reset_finalizer_nested,
GC_check_finalizer_nested): Likewise.
* gcj_mlc.c (GC_start_debugging): Likewise.
* include/private/dbg_mlc.h (GC_save_callers, GC_print_callers,
GC_has_other_debug_info, GC_store_debug_info): Likewise.
* include/private/gc_hdrs.h (GC_header_cache_miss): Likewise.
* include/private/gc_locks.h (GC_lock): Likewise.
* include/private/gc_pmark.h (GC_signal_mark_stack_overflow,
GC_mark_from): Likewise.
* include/private/pthread_support.h (GC_lookup_thread,
GC_stop_init): Likewise.
* include/private/thread_local_alloc.h (GC_init_thread_local,
GC_destroy_thread_local, GC_mark_thread_local_fls_for): Likewise.
* malloc.c (GC_extend_size_map, GC_text_mapping): Likewise.
* mark.c (GC_page_was_ever_dirty): Likewise.
* mark_rts.c (GC_mark_thread_local_free_lists): Likewise.
* misc.c (GC_register_main_static_data, GC_init_win32,
GC_setpagesize, GC_init_linux_data_start,
GC_set_and_save_fault_handler, GC_init_dyld, GC_init_netbsd_elf,
GC_do_blocking_inner): Likewise.
* os_dep.c (GC_greatest_stack_base_below): Likewise.
* win32_threads.c (GC_write_fault_handler, GC_gww_dirty_init):
Likewise.
* include/private/gc_priv.h: Likewise.
* include/private/gc_priv.h (GC_INNER): Update the comment.
* doc/README.macros (GC_DLL): Update.

* alloc.c (GC_collection_in_progress): Move the prototype to
gc_priv.h.
* gc_dlopen.c (GC_collection_in_progress): Likewise.
* pthread_support.c (GC_collection_in_progress): Likewise.
* misc.c (GC_init_parallel): Likewise.
* pthread_support.c (GC_init_parallel): Likewise.
* win32_threads.c (GC_init_parallel): Likewise.
* darwin_stop_world.c (GC_thr_init): Likewise.
* misc.c (GC_thr_init): Likewise.
* pthread_stop_world.c (GC_thr_init): Likewise.
* pthread_support.c (GC_thr_init): Likewise.
* blacklst.c (GC_clear_bl, GC_copy_bl,
GC_number_stack_black_listed): Make STATIC.
* dbg_mlc.c (GC_print_obj, GC_make_closure,
GC_debug_invoke_finalizer): Likewise.
* malloc.c (GC_alloc_large_and_clear): Likewise.
* mark.c (GC_push_selected, GC_push_marked1, GC_push_marked2,
GC_push_marked4, GC_push_marked, GC_push_next_marked,
GC_push_next_marked_dirty, GC_push_next_marked_uncollectable):
Likewise.
* misc.c (GC_clear_stack_inner): Likewise.
* os_dep.c (GC_repeat_read, GC_default_push_other_roots): Likewise.
* darwin_stop_world.c (FindTopOfStack): Make static; define only
if not DARWIN_DONT_PARSE_STACK.
* dbg_mlc.c (GC_debug_free_inner): Define only if DBG_HDRS_ALL.
* dyn_load.c (GC_repeat_read): Remove unused prototype.
* include/private/gc_pmark.h (GC_find_start): Likewise.
* misc.c (GC_read, GC_register_finalizer_no_order): Likewise.
* dyn_load.c (GC_segment_is_thread_stack): Add prototype (only if
THREADS).
* dyn_load.c (GC_register_main_static_data): Define only if
DYNAMIC_LOADING.
* finalize.c (GC_enqueue_all_finalizers): Remove unnecessary tail
"return" statement.
* gc_dlopen.c (GC_SOLARIS_THREADS): Don't recognize (since implies
GC_PTHREADS).
* include/gc.h: Fix a typo.
* include/gc_inline.h (GC_ASSERT): Define (if not defined) since
the header is public.
* include/gc_inline.h (GC_generic_malloc_many): New public
function declaration.
* mallocx.c (GC_generic_malloc_many): Make public.
* include/private/gc_priv.h (GC_INNER): Use visibility attribute
(if available).
* include/private/gc_priv.h (GC_EXTERN): Define using GC_INNER.
* include/private/gc_priv.h: Include atomic_ops.h if THREADS and
MPROTECT_VDB.
* os_dep.c: Don't include atomic_ops.h
* win32_threads.c: Likewise.
* include/private/gc_priv.h (GC_push_selected, GC_push_regs,
GC_push_marked, GC_number_stack_black_listed,
GC_alloc_large_and_clear, GC_reclaim_or_delete_all,
GC_generic_malloc_many, GC_make_closure,
GC_debug_invoke_finalizer, GC_print_obj, GC_page_was_ever_dirty):
Remove the prototype.
* mark.c (GC_page_was_ever_dirty): Add prototype (only if
PROC_VDB).
* include/private/gc_priv.h (GC_push_next_marked_dirty,
GC_push_next_marked, GC_push_next_marked_uncollectable): Move
the prototype to mark.c.
* include/private/gc_priv.h (GC_is_static_root): Declare only if
not THREADS.
* include/private/gc_priv.h (GC_free_inner): Declare only if
THREADS.
* include/private/gc_priv.h (GC_debug_free_inner): Declare only if
THREADS and DBG_HDRS_ALL.
* include/private/gc_priv.h (GC_markers): Declare GC_markers only
if PARALLEL_MARK.
* include/private/gc_priv.h (GC_register_main_static_data): Move
the prototype to misc.c.
* mach_dep.c (GC_push_regs): Make STATIC; define only along with
HAVE_PUSH_REGS definition.
* mach_dep.c (GC_clear_stack_inner): Replace K&R-style function
definition with the ANSI C one.
* mark.c (GC_started_thread_while_stopped): Declared only if not
GNU C.
* win32_threads.c (GC_started_thread_while_stopped): Don't define
if GNU C.
* mark.c (GC_mark_from): Avoid unbalanced brackets in
#if-#else-#endif blocks.
* mark_rts.c (GC_is_static_root): Define only if not THREADS.
* os_dep.c (GC_get_stack_base): Make public (for OpenBSD).
* os_dep.c (GC_page_was_ever_dirty): Comment out the function
except for PROC_VDB.
* tests/test.c (main): Don't reference GC_print_obj,
GC_make_closure, GC_debug_invoke_finalizer,
GC_page_was_ever_dirty, GC_is_fresh (in GC_noop).
* thread_local_alloc.c: Don't include "gc_inline.h".
* win32_threads.c (GC_write_fault_handler): Declare only if
MPROTECT_VDB.

* allchblk.c (DEBUG): Remove macro (since unused).
* allchblk.c: Include private/gc_priv.h before other includes and
definitions.
* alloc.c: Likewise.
* gc_dlopen.c: Likewise.
* headers.c: Likewise.
* mallocx.c: Likewise.
* mark_rts.c: Likewise.
* new_hblk.c: Likewise.
* reclaim.c: Likewise.
* mark.c: Include private/gc_pmark.h before other includes.
* misc.c: Likewise.
* dyn_load.c (_GNU_SOURCE): Move the definition to gc_priv.h.
* pthread_support.c (_USING_POSIX4A_DRAFT10): Likewise.
* pthread_support.c (_POSIX4A_DRAFT10_SOURCE): Remove (since
already defined in gc_config_macros.h).
* dyn_load.c (GC_init_dyld): Remove parameter cast for
_dyld_register_func_for_add_image() and
_dyld_register_func_for_remove_image(); add the comment about
possible warnings; add FIXME for the deprecated
_dyld_bind_fully_image_containing_address().
* include/private/gc_priv.h: Include gc.h before the standard
headers inclusion.
* tests/test.c: Likewise.
* include/private/gcconfig.h (DebugBreak): Update the comment.
* typd_mlc.c (ED_INITIAL_SIZE): Remove ';'.

* configure.ac (openbsd): Define GC_OPENBSD_THREADS.
* configure.ac: Add AM_CONDITIONAL(OPENBSD_THREADS).
* configure.ac: Add sparc-openbsd case.
* doc/README.macros (GC_NETBSD_THREADS, GC_OPENBSD_THREADS):
Document.
* tests/test.c (main): Handle OpenBSD case.
* include/private/pthread_stop_world.h: Likewise.
* extra/threadlibs.c (main): Replace K&R-style function definition
with the ANSI C one.
* extra/threadlibs.c (main): Handle GC_OPENBSD_THREADS case.
* dyn_load.c (OPENBSD): Recognize (similar to NETBSD).
* include/gc_config_macros.h (GC_SOLARIS_THREADS): Recognize;
define it for OpenBSD.
* include/gc_pthread_redirects.h (GC_pthread_sigmask,
pthread_sigmask): Don't declare and redefine for OpenBSD.
* include/private/gcconfig.h: Handle OpenBSD (on arm, sh, x86,
x64, powerpc).
* mach_dep.c (NO_GETCONTEXT): Likewise.
* include/private/pthread_stop_world.h (thread_stop_info): Don't
define last_stop_count field if OpenBSD.
* misc.c (GC_init_dyld): Add declaration (if NetBSD).
* misc.c (GC_init): Don't call GC_init_netbsd_elf() for OpenBSD.
* os_dep.c (GC_init_netbsd_elf): Don't define for OpenBSD.
* os_dep.c (old_segv_act, GC_jmp_buf_openbsd): New static variable
(only if OpenBSD).
* os_dep.c (GC_fault_handler_openbsd, GC_find_limit_openbsd,
GC_skip_hole_openbsd): New static function (only if OpenBSD).
* os_dep.c (GC_get_stack_base, GC_get_main_stack_base,
GC_register_data_segments): Define specially for OpenBSD case.
* os_dep.c (GC_fault_handler_lock): Initialize to
AO_TS_INITIALIZER (instead of 0).
* pthread_support.c (GC_allocate_lock): Likewise.
* pthread_stop_world.c (NSIG, GC_print_sig_mask,
GC_remove_allowed_signals, suspend_handler_mask, GC_stop_count,
GC_world_is_stopped, GC_retry_signals, SIG_THR_RESTART,
GC_suspend_ack_sem, GC_suspend_handler_inner, GC_suspend_handler,
GC_restart_handler): Don't define and use if OpenBSD.
* pthread_stop_world.c (GC_suspend_all, GC_stop_world,
GC_start_world): Handle OpenBSD case.
* pthread_stop_world.c (GC_stop_init): Define as empty if OpenBSD.
* pthread_support.c (pthread_sigmask): Don't undefine the macro and
don't define the wrapper function if OpenBSD.
* pthread_support.c (GC_thr_init): Handle OpenBSD case.

* dyn_load.c: Move the inclusion of private/gc_priv.h below
definition of a feature macro (_GNU_SOURCE).

* include/gc.h (REVEAL_POINTER): Remove redundant parentheses.
* include/gc.h (GC_HIDE_POINTER, GC_REVEAL_POINTER): New macros
(only if GC_I_HIDE_POINTERS).
* backgraph.c (GET_OH_BG_PTR): Prefix REVEAL_POINTER() with "GC_".
* dbg_mlc.c (GC_get_back_ptr_info): Likewise.
* finalize.c (GC_grow_table, GC_dump_finalization, GC_finalize,
GC_enqueue_all_finalizers): Likewise.
* backgraph.c (SET_OH_BG_PTR): Prefix HIDE_POINTER() with "GC_".
* finalize.c (GC_general_register_disappearing_link,
GC_unregister_disappearing_link, GC_register_finalizer_inner,
GC_finalize): Likewise.
* include/private/dbg_mlc.h (HIDE_BACK_PTR): Likewise.
* include/private/dbg_mlc.h (GC_I_HIDE_POINTERS): Define instead
of I_HIDE_POINTERS.
* include/private/gc_priv.h (GC_I_HIDE_POINTERS): Likewise.
* include/gc.h (_GC_H): Strip leading underscore.
* include/gc_backptr.h (_GC_H): Likewise.
* include/gc_gcj.h (_GC_H): Likewise.
* include/gc_mark.h (_GC_H): Likewise.
* include/gc_typed.h (_GC_TYPED_H, _GC_H): Likewise.
* include/javaxfc.h (_GC_H): Likewise.
* include/new_gc_alloc.h (__GC_SPECIALIZE): Likewise.
* include/private/dbg_mlc.h (_GC_H): Likewise.
* include/private/gc_priv.h (_GC_H): Likewise.

* gc_cpp.cc: Include "gc_cpp.h" instead of <gc_cpp.h>.

* include/private/gc_priv.h (GC_INNER): New macro (for GC-scope
variable definitions).
* include/private/gc_priv.h (GC_EXTERN): Update the comment.
* allchblk.c (GC_unmap_threshold): Define as GC_INNER.
* alloc.c (GC_incremental, GC_world_stopped, GC_n_heap_sects,
GC_n_memory, GC_fail_count): Likewise.
* blacklst.c (GC_black_list_spacing, GC_print_heap_obj): Likewise.
* gcj_mlc.c (GC_gcj_malloc_initialized, GC_gcjobjfreelist): Likewise.
* mach_dep.c (GC_save_regs_ret_val): Likewise.
* mark.c (GC_n_mark_procs, GC_obj_kinds, GC_n_kinds,
GC_mark_stack, GC_mark_stack_limit, GC_mark_stack_size,
GC_mark_stack_top, GC_mark_state, GC_mark_stack_too_small,
GC_mark_no, GC_markers): Likewise.
* mark_rts.c (GC_root_size, GC_push_typed_structures): Likewise.
* misc.c (GC_allocate_ml, GC_debugging_started, GC_check_heap,
GC_print_all_smashed, GC_print_back_height, GC_dump_regularly,
GC_backtraces, GC_force_unmap_on_gcollect,
GC_large_alloc_warn_interval, GC_is_initialized, GC_write_cs,
GC_current_warn_proc, GC_blocked_sp, GC_activation_frame): Likewise.
* os_dep.c (GC_page_size, GC_dont_query_stack_min,
GC_no_win32_dlls, GC_wnt, GC_sysinfo, GC_push_other_roots,
GC_dirty_maintained, GC_fault_handler_lock): Likewise.
* pthread_support.c (GC_allocate_ml, GC_lock_holder,
GC_need_to_lock, GC_thr_initialized, GC_threads,
GC_in_thread_creation, GC_collecting, GC_allocate_lock,
GC_mark_lock_holder): Likewise.
* reclaim.c (GC_bytes_found, GC_fl_builder_count, GC_have_errors):
Likewise.
* win32_threads.c (GC_allocate_ml, GC_lock_holder,
GC_need_to_lock, GC_mark_lock_holder, GC_collecting): Likewise.
* extra/gc.c (GC_INNER, GC_EXTERN): Define as STATIC.
* mach_dep.c (GC_with_callee_saves_pushed): Remove redundant {}.

* include/private/gc_priv.h (GC_bytes_allocd, GC_objfreelist,
GC_aobjfreelist): Replace GC_EXTERN to extern for SEPARATE_GLOBALS
case (since they are not defined inside GC at present).
* include/private/gc_priv.h (GC_objects_are_marked): Remove the
declaration (since made static).
* mark.c (GC_objects_are_marked): Define as STATIC.
* win32_threads.c (GC_thr_initialized, GC_in_thread_creation):
Likewise.
* mark.c (GC_N_KINDS_INITIAL_VALUE): New macro (defined and used
to initialize GC_n_kinds).
* win32_threads.c (start_mark_threads): Adjust the comment.

* alloc.c (GC_notify_full_gc): Use GC_INLINE for a tiny static
function.
* backgraph.c (pop_in_progress, GC_apply_to_each_object): Likewise.
* mark_rts.c (add_roots_to_index): Likewise.

* extra/gc.c: New file.
* Makefile.am (EXTRA_DIST): Add "extra/gc.c".

* misc.c (GC_log): Remove the declaration; move the definition (to
the place where it is used); make STATIC.
* misc.c (GC_init): Use GC_err_printf() instead of GC_log_printf()
to print open log failure.
* misc.c (GC_write): Don't abort on open log failure if the GC is
compiled with GC_PRINT_VERBOSE_STATS (useful for WinCE).

* include/private/gcconfig.h (USE_MMAP): Guard with ifndef.

* allchblk.c (GC_fail_count, GC_large_alloc_warn_interval): Move
the variable declaration to gc_priv.h.
* alloc.c (GC_bytes_found, GC_unmap_threshold,
GC_force_unmap_on_gcollect): Likewise.
* dyn_load.c (GC_no_win32_dlls, GC_wnt): Likewise.
* finalize.c (GC_fail_count): Likewise.
* include/private/gc_locks.h (GC_allocate_ml, GC_lock_holder,
GC_collecting, GC_mark_lock_holder, GC_need_to_lock): Likewise.
* include/private/gc_pmark.h (GC_n_mark_procs, GC_mark_stack_size,
GC_mark_stack_limit, GC_mark_stack_top, GC_mark_stack,
GC_mark_stack_too_small, GC_mark_state): Likewise.
* include/private/pthread_support.h (GC_threads,
GC_thr_initialized, GC_in_thread_creation): Likewise.
* mallocx.c (GC_bytes_found): Likewise.
* mark_rts.c (GC_save_regs_ret_val, GC_world_stopped): Likewise.
* misc.c (GC_unmap_threshold): Likewise.
* os_dep.c (GC_unmap_threshold): Likewise.
* pthread_support.c (GC_markers): Likewise.
* thread_local_alloc.c (GC_gcjobjfreelist,
GC_gcj_malloc_initialized, GC_gcj_kind): Likewise.
* win32_threads.c (GC_fault_handler_lock, GC_write_cs,
GC_dont_query_stack_min, GC_markers, GC_wnt): Likewise.
* include/private/gc_priv.h (GC_EXTERN): New macro (used mostly as
a tag for now); defined after "gcconfig.h" inclusion.
* include/private/gc_priv.h: Use GC_EXTERN instead of "extern"
keyword for most global variables.
* alloc.c (GC_copyright): Add the comment about the symbol
visibility.
* finalize.c (GC_fo_entries): Likewise.
* include/private/gc_priv.h (GC_print_stats): Likewise.
* misc.c (GC_quiet): Likewise.
* mallocx.c (GC_bytes_allocd_tmp): Make the volatile variable
STATIC.
* pthread_support.c (GC_threads): Add explicit zero initializer
(to make the variable definition differ from the declaration).

* backgraph.c (GC_quiet): Remove the declaration (not needed
anymore since gc_priv.h is always included).
* checksums.c (GC_quiet): Likewise.
* gcj_mlc.c (GC_quiet): Likewise.
* headers.c (GC_hdr_cache_hits, GC_hdr_cache_misses): Add the
comment.
* include/private/gc_hdrs.h (GC_hdr_cache_hits,
GC_hdr_cache_misses): Likewise.
* mark.c (GC_first_nonempty): Make the volatile variable STATIC.
* pthread_stop_world.c (GC_stop_count, GC_world_is_stopped):
Likewise.
* win32_threads.c (GC_please_stop, GC_max_thread_index,
GC_mark_mutex_waitcnt): Likewise.

* pthread_support.c (GC_USE_LD_WRAP): Fix a typo (swapped 'L' and
'D') in the name.

* gc_dlopen.c (GC_MUST_RESTORE_REDEFINED_DLOPEN): Define if dlopen
redirection is turned off; turn it on later when dlopen real
symbol is no longer needed (according to the comment and the same
as in dyn_load.c).
* gc_dlopen.c (WRAP_FUNC, REAL_FUNC): Rename to WRAP_DLFUNC and
REAL_DLFUNC, respectively (to have unique names since the
definitions may differ from that of the similar ones in
pthread_support.c).
* mark.c (source): Undefine the macro when no longer needed.
* os_dep.c (handler): Rename the type to GC_fault_handler_t (to
have the unique name across the project).
* os_dep.c (STAT_BUF_SIZE, STAT_READ); Guard with ifndef; add the
comment.
* pthread_support.c (STAT_BUF_SIZE, STAT_READ): Likewise.
* os_dep.c (sbrk): Undo sbrk() redirection (for ECOS) when no
longer needed.

* pthread_stop_world.c (pthread_sigmask): Undefine before using
in GC_print_sig_mask() (only if DEBUG_THREADS); add the comment.
* win32_threads.c (dlopen, _beginthread): Don't undefine (since
neither redirected nor used here).
* win32_threads.c (GC_Thread_Rep): Rename "table_management" to
"tm" for short; remove "tm_" prefix.
* win32_threads.c (in_use, next): Don't define the macros; use
tm.in_use and tm.next fields, respectively (to ease debugging).
* win32_threads.c (HASH): Rename to PTHREAD_MAP_HASH (to have
unique name across the project).

* include/private/gc_priv.h (I_HIDE_POINTERS): Define before gc.h
inclusion.
* include/private/gc_pmark.h (I_HIDE_POINTERS): Define if gc.h is
not included yet.
* finalize.c (I_HIDE_POINTERS): Don't define.
* include/private/dbg_mlc.h (I_HIDE_POINTERS): Likewise.
* misc.c (I_HIDE_POINTERS): Likewise.
* include/private/dbg_mlc.h (HIDE_POINTER, REVEAL_POINTER,
GC_hidden_pointer): Don't define if HIDE_POINTER is undefined.
* include/private/gc_pmark.h: Remove the comment about gc_priv.h
inclusion order.

* dyn_load.c: Include gc_priv.h before using configuration
information (MACOS).
* dyn_load.c (GC_must_restore_redefined_dlopen): Rename to
GC_MUST_RESTORE_REDEFINED_DLOPEN.

* backgraph.c (SET_OH_BG_PTR): Place outermost parenthesis
properly.
* darwin_stop_world.c: Replace "if DEBUG_THREADS" with
"ifdef DEBUG_THREADS".
* pthread_stop_world.c: Likewise.
* pthread_support.c: Likewise.
* include/gc_inline.h: Guard with GC_INLINE_H.

* alloc.c (GC_copyright): Define as const.
* alloc.c (GC_collect_at_heapsize): Replace "static" with "STATIC"
(since the name starts with "GC_" prefix).
* dbg_mlc.c (GC_describe_type_fns): Likewise.
* dyn_load.c (GC_FirstDLOpenedLinkMap,
GC_register_dynlib_callback, GC_dyld_sections,
GC_dyld_name_for_hdr, GC_dyld_image_add, GC_dyld_image_remove):
Likewise.
* malloc.c (GC_libpthread_start, GC_libpthread_end,
GC_libld_start, GC_libld_end): Likewise.
* mark_rts.c (GC_remove_root_at_pos, GC_rebuild_root_index):
Likewise.
* os_dep.c (GC_gww_read_dirty, GC_gww_page_was_dirty,
GC_gww_page_was_ever_dirty, GC_mprotect_thread_notify,
GC_mprotect_thread_reply, GC_mprotect_thread, GC_darwin_sigbus,
GC_forward_exception): Likewise.
* pthread_support.c (GC_syms_initialized): Likewise.
* typd_mlc.c (GC_push_typed_structures_proc): Likewise.
* win32_threads.c (GC_win32_dll_threads,
GC_register_my_thread_inner, GC_lookup_pthread, GC_get_stack_min,
GC_waitForSingleObjectInfinite): Likewise.
* darwin_stop_world.c (GC_use_mach_handler_thread,
GC_use_mach_handler_thread, GC_mach_threads_count): Replace
"static" with "STATIC" and add zero initializer.
* os_dep.c (GC_task_self, GC_ports, GC_mprotect_state,
GC_sigbus_count): Likewise.
* headers.c (free_hdr): Replace "static" with GC_INLINE.
* misc.c (GC_tmp): Rename static variable to fwrite_gc_res.
* os_dep.c (memory): Rename static variable to ecos_gc_memory.
* os_dep.c (async_set_pht_entry_from_index): Make static (for
MPROTECT_VDB case).
* pthread_support.c (GC_real_pthread_create,
GC_real_pthread_sigmask, GC_real_pthread_join,
GC_real_pthread_detach, GC_init_real_syms): Use REAL_FUNC() macro
for static GC_real_XXX symbols.
* win32_threads.c (GC_may_be_in_stack): Remove "GC_" prefix.

* alloc.c (GC_finish_collection): Replace getenv() with GETENV().
* dyn_load.c (GC_init_dyld): Likewise.
* os_dep.c (GC_print_callers): Likewise.
* dyn_load.c (GC_dyld_name_for_hdr): Cast _dyld_get_image_name()
result (since it's always of "struct mach_header" type).
* dyn_load.c (GC_init_dyld): Cast GC_dyld_image_add and
GC_dyld_image_remove (to always have the first argument of
"struct mach_header" pointer type).

* configure.ac: Add threads support for OpenBSD case (threads may
not work correctly for it).

* acinclude.m4: Rename to m4/gc_set_version.m4.
* m4/libtool.m4: Delete the file.
* m4/lt~obsolete.m4: Likewise.
* m4/ltoptions.m4: Likewise.
* m4/ltsugar.m4: Likewise.
* m4/ltversion.m4: Likewise.

* include/private/gcconfig.h: Define DebugBreak() as _exit(-1) for
x86mingw32ce toolchain to workaround the incorrect DebugBreak()
declaration in winbase.h (the workaround would turn into a no-op
when DebugBreak() will be defined as a macro in the toolchain).

* include/private/gcconfig.h: Recognize __i386__ if WinCE (for
x86mingw32ce toolchain).
* include/private/gcconfig.h (NO_GETENV): Don't define for CeGCC
toolchain (or if already defined).
* include/private/gcconfig.h (NO_GETENV_WIN32): New macro (always
defined for WinCE or if NO_GETENV is defined).
* misc.c (GC_CreateLogFile): Use NO_GETENV_WIN32 macro instead of
NO_GETENV one.

* configure.ac: Add AC_CONFIG_MACRO_DIR([m4]).
* Makefile.am: Add "ACLOCAL_AMFLAGS = -I m4".
* libtool.m4: Remove.
* m4/libtool.m4: New file (generated).
* m4/lt~obsolete.m4: Likewise.
* m4/ltoptions.m4: Likewise.
* m4/ltsugar.m4: Likewise.
* m4/ltversion.m4: Likewise.

* include/gc.h (GC_UNDERSCORE_STDCALL): Recognize new macro;
prefix GC_CreateThread and GC_ExitThread with '_' if defined.
* doc/README.macros (GC_UNDERSCORE_STDCALL): Document.

* alloc.c (GC_collect_or_expand): Add "retry" argument; add the
comments; don't use "default" stop_func on a retry if
GC_dont_expand.
* alloc.c (GC_allocobj): Pass "retry" argument to
GC_collect_or_expand().
* malloc.c (GC_alloc_large): Likewise.
* include/private/gc_priv.h (GC_collect_or_expand): Move the
declaration to malloc.c; add "retry" argument.

* alloc.c (GC_start_call_back): Move the variable definition from
misc.c.
* include/private/gc_priv.h (GC_start_call_back): Remove the
declaration.
* alloc.c (GC_notify_full_gc): Remove unnecessary cast of 0.
* alloc.c (GC_try_to_collect_inner): Also call stop_func at the
beginning of the function.
* include/gc.h (GC_try_to_collect): Refine the comment about
stop_func.

* alloc.c (GC_default_stop_func, GC_try_to_collect_general,
GC_gcollect): Add the comment.
* alloc.c (GC_try_to_collect_general): Move the assertion on
stop_func != 0 to GC_try_to_collect().
* alloc.c (GC_try_to_collect_general): If stop_func == 0 then use
GC_default_stop_func instead (holding the lock).
* alloc.c (GC_gcollect): Pass 0 as stop_func instead of
GC_default_stop_func (to prevent data races).

* Makefile.direct: Move "define arguments" documentation to
doc/README.macros; add reference to doc/README.macros.
* Makefile.dj: Change the documentation reference to
doc/README.macros.
* README.QUICK: Likewise.
* configure.ac: Likewise.
* allchblk.c: Remove unnecessary "-D" from the comment.
* doc/README.macros: Likewise.
* README.environment: Likewise.
* include/gc.h: Likewise.
* include/gc_inline.h: Likewise.
* include/private/gcconfig.h: Likewise.
* README.QUICK: Fix a typo.

* misc.c (GC_CreateLogFile): Use FILE_ATTRIBUTE_NORMAL for
CreateFile(); don't immediately flush every write if very verbose.

* doc/README.win32: Replace ".exe.log" to ".gc.log".
* doc/README.win64: Likewise.
* doc/README.win64: Fix a typo.
* misc.c (GC_CreateLogFile): Strip executable file extension for
the log file; use ".gc.log" extension (instead of ".log").

* include/gc_config_macros.h: Avoid the redefinition of
GC_xxx_THREADS macros.

* alloc.c (GC_try_to_collect_general): Change the type of "result"
local variable to GC_bool.

* include/gc_config_macros.h: Use old behavior for FreeBSD and
NetBSD platform detection code (check that other GC_xxx_THREADS
are undefined); add FIXME.

* include/gc_config_macros.h: Rearrange the platform detection
code (GC_WIN32_PTHREADS implies GC_WIN32_THREADS; define
GC_THREADS first if GC_XXX_THREADS already set; define proper
GC_XXX_THREADS if GC_THREADS; define GC_PTHREADS in a single
place; define _REENTRANT if posix threads except for Win32).

* alloc.c (GC_try_to_collect_general): New function (move the code
from GC_try_to_collect, pass force_unmap argument).
* alloc.c (GC_try_to_collect, GC_gcollect): Call
GC_try_to_collect_general().
* alloc.c (GC_gcollect_and_unmap): New public function.
* include/gc.h (GC_gcollect_and_unmap): New function declaration.
* tests/test.c (window_proc): Call GC_gcollect_and_unmap() on
WM_HIBERNATE event (instead of GC_set_force_unmap_on_gcollect()
and GC_gcollect()).

* include/gc.h (GC_allow_register_threads, GC_register_my_thread,
GC_unregister_my_thread, GC_malloc_many): Refine the comment.
* include/gc.h (GC_malloc_many, GC_NEXT): Declare unconditionally
(that is, don't depend on GC_THREADS macro).
* include/gc.h: Don't check for __CYGWIN32__ and __CYGWIN__ along
with a check for GC_PTHREADS (since the former implies the
latter).

* include/gc.h (GC_SOLARIS_THREADS): Don't check for.
* include/gc.h (GC_MIN, GC_MAX): Don't define.
* mallocx.c (GC_malloc_many): Add comment to #endif.

* configure.ac: Drop the subdir-objects Automake option, since
it's incompatible with picking source files from libatomic_ops.

* allchblk.c (GC_fail_count, GC_large_alloc_warn_interval): Add
"extern" keyword to a global variable declaration (some compilers
require it).
* alloc.c (GC_bytes_found, GC_unmap_threshold,
GC_force_unmap_on_gcollect): Likewise.
* dyn_load.c (GC_no_win32_dlls, GC_wnt): Likewise.
* finalize.c (GC_fail_count): Likewise.
* include/private/gc_hdrs.h (GC_hdr_cache_hits,
GC_hdr_cache_misses): Likewise.
* mallocx.c (GC_bytes_found): Likewise.
* mark_rts.c (GC_save_regs_ret_val, GC_world_stopped): Likewise.
* misc.c (GC_unmap_threshold): Likewise.
* os_dep.c (GC_unmap_threshold, GC_old_allocator): Likewise.
* pthread_support.c (GC_markers): Likewise.
* thread_local_alloc.c (GC_gcjobjfreelist,
GC_gcj_malloc_initialized, GC_gcj_kind): Likewise.
* win32_threads.c (GC_fault_handler_lock, GC_write_cs,
GC_dont_query_stack_min, GC_markers, GC_wnt): Likewise.

* tests/huge_test.c: Define GC_IGNORE_WARN (if not defined) to
suppress misleading GC "Out of Memory!" warning printed on every
GC_MALLOC(LONG_MAX) call.
* tests/huge_test.c: Include "gc.h" instead of <gc.h>.
* tests/huge_test.c (main): Replace K&R-style function definition
with the ANSI C one.

* dyn_load.c (GC_register_dynamic_libraries): Always use
lpMaximumApplicationAddress value for WinCE (even for old
versions).
* os_dep.c (VER_PLATFORM_WIN32_CE): Define if not in winbase.h.
* os_dep.c (GC_dont_query_stack_min): New global variable (only if
WinCE and THREADS).
* os_dep.c (GC_setpagesize): Adjust lpMaximumApplicationAddress
for WinCE (prior to version 6) if not _WIN32_WCE_EMULATION; set
GC_dont_query_stack_min for older WinCE (prior to version 5).
* win32_threads.c (GC_dont_query_stack_min): Declare.
* win32_threads.c (GC_get_stack_min): Rename the macro to
GC_wince_evaluate_stack_min for WinCE; update the comment.
* win32_threads.c (GC_push_stack_for, GC_get_next_stack): Use
GC_wince_evaluate_stack_min() instead of GC_get_stack_min() for
WinCE and don't update thread's last_stack_min value (only if
GC_dont_query_stack_min).
